//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TFormMain.h"           
#include <IniFiles.hpp>
#include <windows.h>
#include <iphlpapi.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "iphlpapi.lib"
#pragma link "te_controls"
#pragma link "TntComCtrls"
#pragma link "TntStdCtrls"
#pragma link "TntButtons"
#pragma link "TntExtCtrls"
#pragma resource "*.dfm"
TFormMain *FormMain;
//---------------------------------------------------------------------------

__fastcall TFormMain::TFormMain(TComponent* Owner)
        : TForm(Owner)
{
        // ó ۽
        BasePath = IncludeTrailingPathDelimiter(ExtractFilePath(Application->ExeName));
        SetCurrentDir(BasePath);
        DestSysPath = "Sys";
        if(!DirectoryExists(BasePath + DestSysPath))
            CreateDir(BasePath + DestSysPath);
        DestLogPath = "Log";
        if(!DirectoryExists(BasePath + DestLogPath))
            CreateDir(BasePath + DestLogPath);
        bStopSend = false;
        bMsg = true;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::FormCreate(TObject *Sender)
{
        //  
        this->Caption = "DIBD_Protocol_V6_Simulator [Ver 6.00]";
        RoadIniFile();
        RoadLangFile("english");
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{       
        // α׷ 
        SaveIniFile();
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::RoadIniFile()
{
        //   ini Ͽ ҷ Լ
        AnsiString IniFileName = ChangeFileExt(Application->ExeName, ".ini");
        AnsiString SectionName;

        try
        {
            if(!FileExists(IniFileName))
            {
                TFileStream *fs = NULL;
                fs = new TFileStream(IniFileName, fmCreate | fmShareCompat);
                delete fs;
            }
        }
        catch(...)
        {
        }

        TIniFile * IF = NULL;
        try
        {
            IF = new TIniFile(IniFileName);
            SectionName = "Main";
            PortUse1                = IF->ReadString(SectionName, "PortUse1", "COM1");
            BaudRateUse1            = (eBaudRate)IF->ReadInteger(SectionName, "BaudRate1", 6);
            IPAddress               = IF->ReadString(SectionName, "IPAddress", "127.0.0.1");
            IPPort                  = IF->ReadInteger(SectionName, "IPPort", 5000);
            UDPIPAddress             = IF->ReadString(SectionName, "UDPIPAddress", "127.0.0.1");
            DSPPort                  = IF->ReadInteger(SectionName, "Main_DSP_PORT", 5108);
            SRCPort                  = IF->ReadInteger(SectionName, "Main_SRC_PORT", 5109);
            ComKind                  = IF->ReadInteger(SectionName, "ComKind", 0);
            ModuleWidth              = IF->ReadInteger(SectionName, "ModuleWidth", 6);
            ModuleHeight             = IF->ReadInteger(SectionName, "ModuleHeight", 2);
            DelayRun                 = IF->ReadBool(SectionName, "FlagReplyPacket", false);
            WaitTime                 = IF->ReadInteger(SectionName, "ReplyPacket0_DelayTime", 3000);
            DelayTime                = IF->ReadInteger(SectionName, "ReplyPacket1_DelayTime", 350);
            ServerCommOpenDelay      = IF->ReadInteger(SectionName, "SvrCommOpenDly", 25000);
            ProgramType              = IF->ReadInteger(SectionName, "ProgramType", e2BPP);
            Controler1               = IF->ReadInteger(SectionName, "DibdAddress", 0);
            bFlagCrcPacket           = IF->ReadBool(SectionName, "CrcCheck", true);
            LogFileCnt               = IF->ReadInteger(SectionName, "LogFileCnt", 1);
            OldLogDate               = IF->ReadString(SectionName, "OldLogDate", FormatDateTime("YYYYMMDD", Now()));

            SectionName = "ProtocolInfo";
            ProtocolTabKind          = IF->ReadInteger(SectionName, "TabKind", 0);
            ProtocolBlockNo          = IF->ReadInteger(SectionName, "BlockNo", 0);
            ProtocolBlockNo2         = IF->ReadInteger(SectionName, "BlockNo2", 0);
            ProtocolPageNo2          = IF->ReadInteger(SectionName, "PageNo2", 0);
            MessageCount             = IF->ReadInteger(SectionName, "SvrMsgMaxCnt", 10);
            if(MessageCount > 50)
                MessageCount = 50;

            AnsiString ProtocolFileName = BasePath + IncludeTrailingPathDelimiter(DestSysPath) + "ProtocolData.dat";
            ZeroMemory(&ProtocolData, sizeof(sProtocolData));
            TFileStream *ProtocolFile = NULL;
            if(FileExists(ProtocolFileName))
            {
                try{
                    ProtocolFile = new TFileStream(ProtocolFileName, fmOpenRead | fmShareCompat);
                    ProtocolFile->Read(&ProtocolData, sizeof(sProtocolData));
                }catch(...){
                }
                if(ProtocolFile)
                {
                    delete ProtocolFile;
                    ProtocolFile = NULL;
                }
            }
            else
            {
                AnsiString asData = "";
                char Buf[3];
                char Buf2[3];
                for(int i = 0; i < 51; i++)
                {
                    for(int j = 0; j < 3; j++)
                    {
                        ProtocolData.ProtocolDispControl[i][j] = 1;
                        ProtocolData.ProtocolDispType[i][j]  = 0;
                        ProtocolData.ProtocolCodeKind[i][j]  = 0;
                        ProtocolData.ProtocolFontSize[i][j]  = 1;
                        asData = "ȿ";
                        memcpy(&ProtocolData.ProtocolEntEffect[i][j][0], asData.c_str(), asData.Length());
                        memcpy(&ProtocolData.ProtocolLasDirect[i][j][0], asData.c_str(), asData.Length());
                        asData = " ";
                        memcpy(&ProtocolData.ProtocolEntDirect[i][j][0], asData.c_str(), asData.Length());
                        memcpy(&ProtocolData.ProtocolLasDirect[i][j][0], asData.c_str(), asData.Length());
                        asData = "20";
                        memcpy(&ProtocolData.ProtocolSpeed[i][j][0], asData.c_str(), asData.Length());
                        asData = "2";
                        memcpy(&ProtocolData.ProtocolDelay[i][j][0], asData.c_str(), asData.Length());
                        ProtocolData.ProtocolStartXPos[i][j] = 0;
                        ProtocolData.ProtocolStartYPos[i][j] = 0;
                        ProtocolData.ProtocolEndXPos[i][j]   = 0;
                        ProtocolData.ProtocolEndYPos[i][j]   = 0;
                        ProtocolData.ProtocolBGImage[i][j]   = 0;
                        ProtocolData.ProtocolColorType[i][j] = 0;
                        asData = "1";
                        memcpy(&ProtocolData.ProtocolColor[i][j][0], asData.c_str(), asData.Length());
                        asData = "0";
                        memcpy(&ProtocolData.ProtocolBGColor[i][j][0], asData.c_str(), asData.Length());
                        if(i == 0)
                        {
                            asData = "޹0" + IntToStr(j + 1);
                            memcpy(&ProtocolData.ProtocolData[i][j][0], asData.c_str(), asData.Length());
                        }
                        else
                        {
                            ZeroMemory(Buf, 3);
                            wsprintf(Buf, "%02d", i);
                            ZeroMemory(Buf2, 3);
                            wsprintf(Buf2, "%02d", j + 1);
                            asData = "Ϲݹ" + AnsiString(Buf).TrimRight() + "-" + AnsiString(Buf2).TrimRight();
                            memcpy(&ProtocolData.ProtocolData[i][j][0], asData.c_str(), asData.Length());
                        }
                    }
                }
            }
        }
        __finally
        {
            if(IF)
            {
                delete IF;
                IF = NULL;
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::SaveIniFile()
{
        // ini   Լ
        AnsiString IniFileName = ChangeFileExt(Application->ExeName, ".ini");
        AnsiString SectionName;

        try
        {
            if(!FileExists(IniFileName))
            {
                TFileStream *fs = NULL;
                fs = new TFileStream(IniFileName, fmCreate | fmShareCompat);
                delete fs;
            }
        }
        catch(...)
        {
        }

        TIniFile * IF = NULL;
        try
        {
            IF = new TIniFile(IniFileName);
            SectionName = "Main";
            IF->WriteString(SectionName,  "PortUse1", PortUse1);
            IF->WriteInteger(SectionName, "BaudRate1", BaudRateUse1);
            IF->WriteString(SectionName, "IPAddress", IPAddress);
            IF->WriteInteger(SectionName, "IPPort", IPPort);
            IF->WriteString(SectionName, "UDPIPAddress", UDPIPAddress);
            IF->WriteInteger(SectionName, "Main_DSP_PORT", DSPPort);
            IF->WriteInteger(SectionName, "Main_SRC_PORT", SRCPort);
            IF->WriteInteger(SectionName, "ComKind", ComKind);
            IF->WriteBool(SectionName, "FlagReplyPacket", DelayRun);
            IF->WriteInteger(SectionName, "ReplyPacket0_DelayTime", WaitTime);
            IF->WriteInteger(SectionName, "ReplyPacket1_DelayTime", DelayTime);
            IF->WriteInteger(SectionName, "SvrCommOpenDly", ServerCommOpenDelay);
            IF->WriteInteger(SectionName, "ProgramType", ProgramType);
            IF->WriteInteger(SectionName, "DibdAddress", Controler1);
            IF->WriteBool(SectionName, "FlagCrcPacket", bFlagCrcPacket);
            IF->WriteInteger(SectionName, "LogFileCnt", LogFileCnt);
            IF->WriteString(SectionName, "OldLogDate", OldLogDate);

            SectionName = "ProtocolInfo";
            AnsiString ProtocolFileName = BasePath + IncludeTrailingPathDelimiter(DestSysPath) + "ProtocolData.dat";
            TFileStream *ProtocolFile = NULL;
            AnsiString tempData = "";
            try{
                int iCurBlockNo = 0;
                int iCurPageNo = 0;
                if(tsEnv->Showing)
                {
                    if(rbNo1->Checked)
                        ProtocolBlockNo = 0;
                    else if(rbNo2->Checked)
                        ProtocolBlockNo = 1;
                    else if(rbNo3->Checked)
                        ProtocolBlockNo = 2;
                    iCurBlockNo = ProtocolBlockNo;
                    ProtocolData.ProtocolDispControl[0][iCurBlockNo] = cbDispControl->ItemIndex;
                    if(cbRevRefeat->Checked)
                        ProtocolData.ProtocolDispControl[0][iCurBlockNo] |= 0x80;
                    ProtocolData.ProtocolDispType[0][iCurBlockNo] = cbDispType->ItemIndex;
                    ProtocolData.ProtocolCodeKind[0][iCurBlockNo] = cbCodeKind->ItemIndex;
                    ProtocolData.ProtocolFontSize[0][iCurBlockNo] = cbFontSize->ItemIndex;
                    tempData = cbEntEffect->Text;
                    memcpy(&ProtocolData.ProtocolEntEffect[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = cbEntDirect->Text;
                    memcpy(&ProtocolData.ProtocolEntDirect[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = cbLasEffect->Text;
                    memcpy(&ProtocolData.ProtocolLasEffect[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = cbLasDirect->Text;
                    memcpy(&ProtocolData.ProtocolLasDirect[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    ProtocolData.ProtocolColorType[0][iCurBlockNo] = cbAssistEffect->ItemIndex;
                    tempData = cbSpeed->Text;
                    memcpy(&ProtocolData.ProtocolSpeed[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = cbDelay->Text;
                    memcpy(&ProtocolData.ProtocolDelay[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    ProtocolData.ProtocolStartXPos[0][iCurBlockNo] = cbStartXPos->ItemIndex;
                    ProtocolData.ProtocolStartYPos[0][iCurBlockNo] = cbStartYPos->ItemIndex;
                    ProtocolData.ProtocolEndXPos[0][iCurBlockNo] = cbEndXPos->ItemIndex;
                    ProtocolData.ProtocolEndYPos[0][iCurBlockNo] = cbEndYPos->ItemIndex;
                    ProtocolData.ProtocolBGImage[0][iCurBlockNo] = cbBGImage->ItemIndex;
                    tempData = eColor->Text;
                    memcpy(&ProtocolData.ProtocolColor[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = eBGColor->Text;
                    memcpy(&ProtocolData.ProtocolBGColor[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = eData->Text;
                    memcpy(&ProtocolData.ProtocolData[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = BasePath + IncludeTrailingPathDelimiter(DestSysPath)
                        + "EnvData" + IntToStr(iCurBlockNo) + ".dat";
                    eData->Lines->SaveToFile(tempData);
                }
                else
                {
                    if(rbNo21->Checked)
                        ProtocolBlockNo2 = 0;
                    else if(rbNo22->Checked)
                        ProtocolBlockNo2 = 1;
                    else if(rbNo23->Checked)
                        ProtocolBlockNo2 = 2;
                    ProtocolPageNo2 = cbPageNo2->ItemIndex;
                    iCurBlockNo = ProtocolBlockNo2;
                    iCurPageNo = ProtocolPageNo2 + 1;
                    ProtocolData.ProtocolDispControl[iCurPageNo][iCurBlockNo] = cbDispControl2->ItemIndex;
                    ProtocolData.ProtocolDispType[iCurPageNo][iCurBlockNo] = cbDispType2->ItemIndex;
                    ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo] = cbCodeKind2->ItemIndex;
                    ProtocolData.ProtocolFontSize[iCurPageNo][iCurBlockNo] = cbFontSize2->ItemIndex;
                    tempData = cbEntEffect2->Text;
                    memcpy(&ProtocolData.ProtocolEntEffect[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = cbEntDirect2->Text;
                    memcpy(&ProtocolData.ProtocolEntDirect[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = cbLasEffect2->Text;
                    memcpy(&ProtocolData.ProtocolLasEffect[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = cbLasDirect2->Text;
                    memcpy(&ProtocolData.ProtocolLasDirect[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    ProtocolData.ProtocolColorType[iCurPageNo][iCurBlockNo] = cbAssistEffect->ItemIndex;
                    tempData = cbSpeed2->Text;
                    memcpy(&ProtocolData.ProtocolSpeed[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = cbDelay2->Text;
                    memcpy(&ProtocolData.ProtocolDelay[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    ProtocolData.ProtocolStartXPos[iCurPageNo][iCurBlockNo] = cbStartXPos2->ItemIndex;
                    ProtocolData.ProtocolStartYPos[iCurPageNo][iCurBlockNo] = cbStartYPos2->ItemIndex;
                    ProtocolData.ProtocolEndXPos[iCurPageNo][iCurBlockNo] = cbEndXPos2->ItemIndex;
                    ProtocolData.ProtocolEndYPos[iCurPageNo][iCurBlockNo] = cbEndYPos2->ItemIndex;
                    ProtocolData.ProtocolBGImage[iCurPageNo][iCurBlockNo] = cbBGImage2->ItemIndex;
                    tempData = eColor2->Text;
                    memcpy(&ProtocolData.ProtocolColor[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = eBGColor2->Text;
                    memcpy(&ProtocolData.ProtocolBGColor[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = eData2->Text;
                    memcpy(&ProtocolData.ProtocolData[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                    tempData = BasePath + IncludeTrailingPathDelimiter(DestSysPath)
                        + "MessageData" + IntToStr(iCurPageNo) + IntToStr(iCurBlockNo) + ".dat";
                    eData2->Lines->SaveToFile(tempData);
                }
                ProtocolFile = new TFileStream(ProtocolFileName, fmCreate | fmShareCompat);
                ProtocolFile->Write(&ProtocolData, sizeof(sProtocolData));
            }catch(...){
            }
            if(ProtocolFile)
            {
                delete ProtocolFile;
                ProtocolFile = NULL;
            }
            ProtocolTabKind = pcMessage->ActivePageIndex;
            IF->WriteInteger(SectionName, "TabKind", ProtocolTabKind);
            IF->WriteInteger(SectionName, "BlockNo", ProtocolBlockNo);
            IF->WriteInteger(SectionName, "BlockNo2", ProtocolBlockNo2);
            IF->WriteInteger(SectionName, "PageNo2", ProtocolPageNo2);
            IF->WriteInteger(SectionName, "SvrMsgMaxCnt", MessageCount);
        }
        __finally
        {
            if(IF)
            {
                delete IF;
                IF = NULL;
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::RoadLangFile(AnsiString aslang)
{
        //  ҷ Լ
        AnsiString IniFileName = "";

        IniFileName = BasePath + DestSysPath + "\\dv_" + aslang + ".ini";
        AnsiString SectionName;

        TIniFile * IF = NULL;
        try
        {
            IF = new TIniFile(IniFileName);
            if(aslang.LowerCase() == "korea")
            {
                SectionName = "MainButton";
                LangFile.BtnPort                        = IF->ReadString(SectionName, "BtnPort",                        "ż");
                LangFile.BtnSize                        = IF->ReadString(SectionName, "BtnSize",                        " ũ");
                LangFile.BtnApply                       = IF->ReadString(SectionName, "BtnApply",                       "");
                LangFile.BtnSend                        = IF->ReadString(SectionName, "BtnSend",                        "");
                LangFile.BtnTimeRead                    = IF->ReadString(SectionName, "BtnTimeRead",                    "DIBD ð б");
                LangFile.BtnSignalSend                  = IF->ReadString(SectionName, "BtnSignalSend",                  "ȣ");
                LangFile.BtnSyncLED                     = IF->ReadString(SectionName, "BtnSyncLED",                     "ð");
                LangFile.BtnPowerLEDOn                  = IF->ReadString(SectionName, "BtnPowerLEDOn",                  "ѱ");
                LangFile.BtnPowerLEDOff                 = IF->ReadString(SectionName, "BtnPowerLEDOff",                 "");
                LangFile.BtnClose                       = IF->ReadString(SectionName, "BtnClose",                       "");
                LangFile.BtnLog                         = IF->ReadString(SectionName, "BtnLog",                         "α ");
                LangFile.BtnSelectAll                   = IF->ReadString(SectionName, "BtnSelectAll",                   "ü ");
                SectionName = "FormComport";
                LangFile.FormComportCaption             = IF->ReadString(SectionName, "FormComportCaption",             "  â");
                LangFile.FormComportButton1             = IF->ReadString(SectionName, "FormComportButton1",             "Ʈݱ");
                LangFile.FormComportButton2             = IF->ReadString(SectionName, "FormComportButton2",             "Ʈ");
                LangFile.FormComportButton3             = IF->ReadString(SectionName, "FormComportButton3",             "DIBD");
                LangFile.FormComportButton4             = IF->ReadString(SectionName, "FormComportButton4",             "Ӳ");
                LangFile.FormComportButton5             = IF->ReadString(SectionName, "FormComportButton5",             "ϱ");
                LangFile.FormComportrbSerial            = IF->ReadString(SectionName, "FormComportrbSerial",            "Serial ");
                LangFile.FormComportrbLAN               = IF->ReadString(SectionName, "FormComportrbLAN",               "Client TCP/IP ");
                LangFile.FormComportrbServer            = IF->ReadString(SectionName, "FormComportrbServer",            "Server TCP/IP ");
                LangFile.FormComportrbUDP               = IF->ReadString(SectionName, "FormComportrbUDP",               "UDP ");
                LangFile.FormComportLabel1              = IF->ReadString(SectionName, "FormComportLabel1",              " Ʈ    :");
                LangFile.FormComportLabel2              = IF->ReadString(SectionName, "FormComportLabel2",              " ӵ    :");
                LangFile.FormComportLabel3              = IF->ReadString(SectionName, "FormComportLabel3",              "DTR 帧    :");
                LangFile.FormComportLabel4              = IF->ReadString(SectionName, "FormComportLabel4",              "RTS 帧    :");
                LangFile.FormComportLabel5              = IF->ReadString(SectionName, "FormComportLabel5",              "IP Address :");
                LangFile.FormComportLabel6              = IF->ReadString(SectionName, "FormComportLabel6",              "Port             :");
                LangFile.FormComportcbDDNS              = IF->ReadString(SectionName, "FormComportcbDDNS",              "Dynamic DNS");
                LangFile.FormComportAddress             = IF->ReadString(SectionName, "FormComportAddress",             "DIBD :");
                LangFile.FormComportSystem              = IF->ReadString(SectionName, "FormComportSystem",              "ġ");
                SectionName = "FormProtocol";
                LangFile.FormProtocolCaption = IF->ReadString(SectionName, "FormProtocolCaption",                       "DIBD  V6 ùķ̼ â");
                LangFile.FormProtocolLabel1 = IF->ReadString(SectionName,  "FormProtocolLabel1",                        "1. ȣ");
                LangFile.FormProtocolLabel2 = IF->ReadString(SectionName,  "FormProtocolLabel2",                        "2. ǹȣ");
                LangFile.FormProtocolLabel3 = IF->ReadString(SectionName,  "FormProtocolLabel3",                        "3. ǥ");
                LangFile.FormProtocolLabel4 = IF->ReadString(SectionName,  "FormProtocolLabel4",                        "4. ǥù");
                LangFile.FormProtocolLabel5 = IF->ReadString(SectionName,  "FormProtocolLabel5",                        "5. ڵ");
                LangFile.FormProtocolLabel6 = IF->ReadString(SectionName,  "FormProtocolLabel6",                        "6. Ʈũ");
                LangFile.FormProtocolLabel7 = IF->ReadString(SectionName,  "FormProtocolLabel7",                        "7. ȿ");
                LangFile.FormProtocolLabel8 = IF->ReadString(SectionName,  "FormProtocolLabel8",                        "8. ȿ");
                LangFile.FormProtocolLabel9 = IF->ReadString(SectionName,  "FormProtocolLabel9",                        "9. ȿ");
                LangFile.FormProtocolLabel10 = IF->ReadString(SectionName, "FormProtocolLabel10",                       "10.ȿӵ");
                LangFile.FormProtocolLabel11 = IF->ReadString(SectionName, "FormProtocolLabel11",                       "11.ð(x500ms)");
                LangFile.FormProtocolLabel12 = IF->ReadString(SectionName, "FormProtocolLabel12",                       "12.X");
                LangFile.FormProtocolLabel13 = IF->ReadString(SectionName, "FormProtocolLabel13",                       "13.Y");
                LangFile.FormProtocolLabel14 = IF->ReadString(SectionName, "FormProtocolLabel14",                       "14.X");
                LangFile.FormProtocolLabel15 = IF->ReadString(SectionName, "FormProtocolLabel15",                       "15.Y");
                LangFile.FormProtocolLabel16 = IF->ReadString(SectionName, "FormProtocolLabel16",                       "16.̹");
                LangFile.FormProtocolLabel17 = IF->ReadString(SectionName, "FormProtocolLabel17",                       "17.1.ڻ");
                LangFile.FormProtocolLabel18 = IF->ReadString(SectionName, "FormProtocolLabel18",                       "17.2.ڹ");
                LangFile.FormProtocolLabel19 = IF->ReadString(SectionName, "FormProtocolLabel19",                       "18.");
                LangFile.FormProtocolLabel20 = IF->ReadString(SectionName, "FormProtocolLabel20",                       "Ϲݹ ޸ ʱȭ");
                LangFile.FormProtocolLabel21 = IF->ReadString(SectionName, "FormProtocolLabel21",                       "Ϲݹ   ");
                LangFile.FormProtocolLabel22 = IF->ReadString(SectionName, "FormProtocolLabel22",                       "̹ ");
                LangFile.FormProtocolLabel23 = IF->ReadString(SectionName, "FormProtocolLabel23",                       "ĶŸ  ̸ ȭ ̹ ٸ Ƿ,");
                LangFile.FormProtocolLabel24 = IF->ReadString(SectionName, "FormProtocolLabel24",                       "  ȭ ȮϽñ ٶϴ.");
                LangFile.FormProtocolLabel25 = IF->ReadString(SectionName, "FormProtocolLabel25",                       "ݺȽ");
                LangFile.FormProtocolLabel26 = IF->ReadString(SectionName, "FormProtocolLabel26",                       " ũ");
                LangFile.FormProtocolLabel27 = IF->ReadString(SectionName, "FormProtocolLabel27",                       "ȭ");
                LangFile.FormProtocolTab1    = IF->ReadString(SectionName, "FormProtocolTab1",                          "޹");
                LangFile.FormProtocolTab2    = IF->ReadString(SectionName, "FormProtocolTab2",                          "Ϲݹ");
                LangFile.FormProtocolTab3    = IF->ReadString(SectionName, "FormProtocolTab3",                          "Ư");
                LangFile.FormProtocolEffect1  = IF->ReadString(SectionName, "FormProtocolEffect1",                      "");
                LangFile.FormProtocolEffect2  = IF->ReadString(SectionName, "FormProtocolEffect2",                      "ǥþ");
                LangFile.FormProtocolEffect3  = IF->ReadString(SectionName, "FormProtocolEffect3",                      "Ͽǥ");
                LangFile.FormProtocolEffect4  = IF->ReadString(SectionName, "FormProtocolEffect4",                      "ϻǥ");
                LangFile.FormProtocolEffect5  = IF->ReadString(SectionName, "FormProtocolEffect5",                      "ϼڵ");
                LangFile.FormProtocolEffect6  = IF->ReadString(SectionName, "FormProtocolEffect6",                      "ڵ");
                LangFile.FormProtocolEffect7  = IF->ReadString(SectionName, "FormProtocolEffect7",                      "ະ");
                LangFile.FormProtocolEffect8  = IF->ReadString(SectionName, "FormProtocolEffect8",                      "ι");
                LangFile.FormProtocolEffect9  = IF->ReadString(SectionName, "FormProtocolEffect9",                      "ü");
                LangFile.FormProtocolEffect10 = IF->ReadString(SectionName, "FormProtocolEffect10",                     "|ι");
                LangFile.FormProtocolEffect11 = IF->ReadString(SectionName, "FormProtocolEffect11",                     "ȿ");
                LangFile.FormProtocolDateItem1 = IF->ReadString(SectionName, "FormProtocolDateItem1",                   "");
                LangFile.FormProtocolDateItem2 = IF->ReadString(SectionName, "FormProtocolDateItem2",                   "ȭ");
                LangFile.FormProtocolDateItem3 = IF->ReadString(SectionName, "FormProtocolDateItem3",                   "");
                LangFile.FormProtocolDateItem4 = IF->ReadString(SectionName, "FormProtocolDateItem4",                   "");
                LangFile.FormProtocolDateItem5 = IF->ReadString(SectionName, "FormProtocolDateItem5",                   "");
                LangFile.FormProtocolDateItem6 = IF->ReadString(SectionName, "FormProtocolDateItem6",                   "");
                LangFile.FormProtocolDateItem7 = IF->ReadString(SectionName, "FormProtocolDateItem7",                   "");
                SectionName = "Effect";
                LangFile.NoEffect     = IF->ReadString(SectionName, "NoEffect",     " ");
                LangFile.EffectType1  = IF->ReadString(SectionName, "EffectType1",  " ȿ");
                LangFile.EffectType2  = IF->ReadString(SectionName, "EffectType2",  "ü ȿ");
                LangFile.EffectType3  = IF->ReadString(SectionName, "EffectType3",  "̵ ϱ");
                LangFile.EffectType4  = IF->ReadString(SectionName, "EffectType4",  "۾ ");
                LangFile.EffectType5  = IF->ReadString(SectionName, "EffectType5",  " ε");
                LangFile.EffectType6  = IF->ReadString(SectionName, "EffectType6",  "Ŀư ȿ");
                LangFile.EffectType7  = IF->ReadString(SectionName, "EffectType7",  " ȿ");
                LangFile.EffectType8  = IF->ReadString(SectionName, "EffectType8",  "Ȯ ȿ");
                LangFile.EffectType9  = IF->ReadString(SectionName, "EffectType9",  "ȸ ȿ");
                LangFile.EffectType10 = IF->ReadString(SectionName, "EffectType10", "̱");
                LangFile.EffectType11 = IF->ReadString(SectionName, "EffectType11", "̱");
                LangFile.EffectType12 = IF->ReadString(SectionName, "EffectType12", "3D ȿ");
                LangFile.EffectType13 = IF->ReadString(SectionName, "EffectType13", "׽Ʈ");
                LangFile.EffectType14 = IF->ReadString(SectionName, "EffectType14", "");
                LangFile.EffectType15 = IF->ReadString(SectionName, "EffectType15", "");
                LangFile.EffectType16 = IF->ReadString(SectionName, "EffectType16", "");
                LangFile.EffectType17 = IF->ReadString(SectionName, "EffectType17", "");
                LangFile.EffectType18 = IF->ReadString(SectionName, "EffectType18", "");
                LangFile.EffectType19 = IF->ReadString(SectionName, "EffectType19", "");
                LangFile.EffectType20 = IF->ReadString(SectionName, "EffectType20", "");
                LangFile.DirType1  = IF->ReadString(SectionName, "DirType1",  " ");
                LangFile.DirType2  = IF->ReadString(SectionName, "DirType2",  " ");
                LangFile.DirType3  = IF->ReadString(SectionName, "DirType3",  "ο");
                LangFile.DirType4  = IF->ReadString(SectionName, "DirType4",  " ݻ");
                LangFile.DirType5  = IF->ReadString(SectionName, "DirType5",  " ݻ");
                LangFile.DirType6  = IF->ReadString(SectionName, "DirType6",  "     ");
                LangFile.DirType7  = IF->ReadString(SectionName, "DirType7",  "  ");
                LangFile.DirType8  = IF->ReadString(SectionName, "DirType8",  "     ");
                LangFile.DirType9  = IF->ReadString(SectionName, "DirType9",  "  ");
                LangFile.DirType10 = IF->ReadString(SectionName, "DirType10", " ");
                LangFile.DirType11 = IF->ReadString(SectionName, "DirType11", "ξƷ");
                LangFile.DirType12 = IF->ReadString(SectionName, "DirType12", " ̾");
                LangFile.DirType13 = IF->ReadString(SectionName, "DirType13", "ʾƷ");
                LangFile.DirType14 = IF->ReadString(SectionName, "DirType14", "");
                LangFile.DirType15 = IF->ReadString(SectionName, "DirType15", "ʾƷ");
                LangFile.DirType16 = IF->ReadString(SectionName, "DirType16", "߾ ");
                LangFile.DirType17 = IF->ReadString(SectionName, "DirType17", "");
                LangFile.DirType18 = IF->ReadString(SectionName, "DirType18", "");
                LangFile.DirType19 = IF->ReadString(SectionName, "DirType19", "");
                LangFile.DirType20 = IF->ReadString(SectionName, "DirType20", "");
                LangFile.DirType21 = IF->ReadString(SectionName, "DirType21", "ȹ");
                LangFile.DirType22 = IF->ReadString(SectionName, "DirType22", "ȹ");
                LangFile.DirType23 = IF->ReadString(SectionName, "DirType23", "ð ");
                LangFile.DirType24 = IF->ReadString(SectionName, "DirType24", "ð ݴ");
                LangFile.DirType25 = IF->ReadString(SectionName, "DirType25", "ð 2");
                LangFile.DirType26 = IF->ReadString(SectionName, "DirType26", "ð ݴ2");
                LangFile.DirType27 = IF->ReadString(SectionName, "DirType27", "    ");
                LangFile.DirType28 = IF->ReadString(SectionName, "DirType28", "    ");
                LangFile.DirType29 = IF->ReadString(SectionName, "DirType29", "    ");
                LangFile.DirType30 = IF->ReadString(SectionName, "DirType30", "    ");
                LangFile.DirType31 = IF->ReadString(SectionName, "DirType31", "    ü");
                LangFile.DirType32 = IF->ReadString(SectionName, "DirType32", " ȿ");
                LangFile.DirType33 = IF->ReadString(SectionName, "DirType33", "ȿ");
                LangFile.DirType34 = IF->ReadString(SectionName, "DirType34", "ȿ");
                LangFile.DirType35 = IF->ReadString(SectionName, "DirType35", "ȿ");
                LangFile.DirType36 = IF->ReadString(SectionName, "DirType36", "ξƷ");
                LangFile.DirType37 = IF->ReadString(SectionName, "DirType37", "̵");
                LangFile.DirType38 = IF->ReadString(SectionName, "DirType38", "̵");
                LangFile.DirType39 = IF->ReadString(SectionName, "DirType39", "̵");
                LangFile.DirType40 = IF->ReadString(SectionName, "DirType40", "Ʒ̵");
                LangFile.DirType41 = IF->ReadString(SectionName, "DirType41", "ȿ");
                LangFile.DirType42 = IF->ReadString(SectionName, "DirType42", "Ŀ");
                LangFile.DirType43 = IF->ReadString(SectionName, "DirType43", "Ŀ");
                LangFile.DirType44 = IF->ReadString(SectionName, "DirType44", "");
                LangFile.DirType45 = IF->ReadString(SectionName, "DirType45", "ľƷ");
                LangFile.DirType46 = IF->ReadString(SectionName, "DirType46", "    ");
                LangFile.DirType47 = IF->ReadString(SectionName, "DirType47", "");
                LangFile.DirType48 = IF->ReadString(SectionName, "DirType48", "");
                LangFile.DirType49 = IF->ReadString(SectionName, "DirType49", "");
                LangFile.DirType50 = IF->ReadString(SectionName, "DirType50", "");
                SectionName = "Message";
                LangFile.MessageCaption = IF->ReadString(SectionName,  "MessageCaption",  "޼ â");
                LangFile.MessageButton01 = IF->ReadString(SectionName, "MessageButton01", "");
                LangFile.MessageButton02 = IF->ReadString(SectionName, "MessageButton02", "ƴϿ");
                LangFile.MessageButton03 = IF->ReadString(SectionName, "MessageButton03", "");
                LangFile.MessageButton04 = IF->ReadString(SectionName, "MessageButton04", "Ȯ");
                LangFile.MessageButton05 = IF->ReadString(SectionName, "MessageButton05", "");
                LangFile.MessageButton06 = IF->ReadString(SectionName, "MessageButton06", "ü");
                LangFile.MessageButton07 = IF->ReadString(SectionName, "MessageButton07", "");
                LangFile.MessageButton08 = IF->ReadString(SectionName, "MessageButton08", "ؽƮ");
                LangFile.MessageButton09 = IF->ReadString(SectionName, "MessageButton09", "׷");
                LangFile.MessageButton10 = IF->ReadString(SectionName, "MessageButton10", "ݱ");
                LangFile.MessageButton11 = IF->ReadString(SectionName, "MessageButton11", "DB ݱ");
                LangFile.MessageButton12 = IF->ReadString(SectionName, "MessageButton12", "1 ٿ");
                LangFile.MessageButton13 = IF->ReadString(SectionName, "MessageButton13", "׷ ٿ");
                LangFile.MessageButton14 = IF->ReadString(SectionName, "MessageButton14", "ڵ");
                LangFile.MessageButton15 = IF->ReadString(SectionName, "MessageButton15", "б");
                LangFile.MessageButton16 = IF->ReadString(SectionName, "MessageButton16", "þ");
                LangFile.MessageButton17 = IF->ReadString(SectionName, "MessageButton17", "");
                LangFile.MessageButton18 = IF->ReadString(SectionName, "MessageButton18", "ʱȭ");
                LangFile.MessageButton19 = IF->ReadString(SectionName, "MessageButton19", "ۼ");
                LangFile.MessageButton20 = IF->ReadString(SectionName, "MessageButton20", "");
                LangFile.Message01       = IF->ReadString(SectionName, "Message01", "");
                LangFile.Message02       = IF->ReadString(SectionName, "Message02", "");
                LangFile.Message03       = IF->ReadString(SectionName, "Message03", "Power On");
                LangFile.Message04       = IF->ReadString(SectionName, "Message04", "Power Off");
                LangFile.Message05       = IF->ReadString(SectionName, "Message05", "   ϴ.");
                LangFile.Message06       = IF->ReadString(SectionName, "Message06", "ð ȭ ");
                LangFile.Message07       = IF->ReadString(SectionName, "Message07", " ũ ");
                LangFile.Message08       = IF->ReadString(SectionName, "Message08", "Ϲݹ ޸ʱȭ");
                LangFile.Message09       = IF->ReadString(SectionName, "Message09", "Ϲݹ ");
                LangFile.Message10       = IF->ReadString(SectionName, "Message10", "̹ ");
                LangFile.Message11       = IF->ReadString(SectionName, "Message11", " ʴ Դϴ.");
                LangFile.Message12       = IF->ReadString(SectionName, "Message12", "DIBD ߿  ʴ Դϴ.");
                LangFile.Message13       = IF->ReadString(SectionName, "Message13", "    ƴմϴ.");
            }
            else
            {
                SectionName = "MainButton";
                LangFile.BtnPort                        = IF->ReadString(SectionName, "BtnPort",                        "Comm.Setting");
                LangFile.BtnSize                        = IF->ReadString(SectionName, "BtnSize",                        "Screen Size");
                LangFile.BtnApply                       = IF->ReadString(SectionName, "BtnApply",                       "Apply");
                LangFile.BtnSend                        = IF->ReadString(SectionName, "BtnSend",                        "Send");
                LangFile.BtnTimeRead                    = IF->ReadString(SectionName, "BtnTimeRead",                    "DIBD Time Read");
                LangFile.BtnSignalSend                  = IF->ReadString(SectionName, "BtnSignalSend",                  "Send Output Signal");
                LangFile.BtnSyncLED                     = IF->ReadString(SectionName, "BtnSyncLED",                     "Time Sync.");
                LangFile.BtnPowerLEDOn                  = IF->ReadString(SectionName, "BtnPowerLEDOn",                  "Power On");
                LangFile.BtnPowerLEDOff                 = IF->ReadString(SectionName, "BtnPowerLEDOff",                 "Power Off");
                LangFile.BtnClose                       = IF->ReadString(SectionName, "BtnPClose",                      "Exit");
                LangFile.BtnLog                         = IF->ReadString(SectionName, "BtnLog",                         "Communication Log");
                LangFile.BtnSelectAll                   = IF->ReadString(SectionName, "BtnSelectAll",                   "All Check");
                SectionName = "FormComport";
                LangFile.FormComportCaption             = IF->ReadString(SectionName, "FormComportCaption",             "Communication Set Window");
                LangFile.FormComportButton1             = IF->ReadString(SectionName, "FormComportButton1",             "Close Port");
                LangFile.FormComportButton2             = IF->ReadString(SectionName, "FormComportButton2",             "Open Port");
                LangFile.FormComportButton3             = IF->ReadString(SectionName, "FormComportButton3",             "Connect DIBD");
                LangFile.FormComportButton4             = IF->ReadString(SectionName, "FormComportButton4",             "Disconnected");
                LangFile.FormComportButton5             = IF->ReadString(SectionName, "FormComportButton5",             "Connected");
                LangFile.FormComportrbSerial            = IF->ReadString(SectionName, "FormComportrbSerial",            "Serial Comm.");
                LangFile.FormComportrbLAN               = IF->ReadString(SectionName, "FormComportrbLAN",               "Client TCP/IP");
                LangFile.FormComportrbServer            = IF->ReadString(SectionName, "FormComportrbServer",            "Server TCP/IP");
                LangFile.FormComportrbUDP               = IF->ReadString(SectionName, "FormComportrbUDP",               "UDP");
                LangFile.FormComportLabel1              = IF->ReadString(SectionName, "FormComportLabel1",              "Comm.Port :");
                LangFile.FormComportLabel2              = IF->ReadString(SectionName, "FormComportLabel2",              "BuadRate   :");
                LangFile.FormComportLabel3              = IF->ReadString(SectionName, "FormComportLabel3",              "DTR Control :");
                LangFile.FormComportLabel4              = IF->ReadString(SectionName, "FormComportLabel4",              "RTS Control :");
                LangFile.FormComportLabel5              = IF->ReadString(SectionName, "FormComportLabel5",              "IP Address :");
                LangFile.FormComportLabel6              = IF->ReadString(SectionName, "FormComportLabel6",              "Port             :");
                LangFile.FormComportcbDDNS              = IF->ReadString(SectionName, "FormComportcbDDNS",              "Dynamic DNS");
                LangFile.FormComportAddress             = IF->ReadString(SectionName, "FormComportAddress",             "DIBD :");
                LangFile.FormComportSystem              = IF->ReadString(SectionName, "FormComportSystem",              "Device Manager");
                SectionName = "FormProtocol";
                LangFile.FormProtocolCaption = IF->ReadString(SectionName, "FormProtocolCaption",                       "DIBD Protocol Simulator(Ver 6.00)");
                LangFile.FormProtocolLabel1 = IF->ReadString(SectionName,  "FormProtocolLabel1",                        "1. Page No.");
                LangFile.FormProtocolLabel2 = IF->ReadString(SectionName,  "FormProtocolLabel2",                        "2. Section No.");
                LangFile.FormProtocolLabel3 = IF->ReadString(SectionName,  "FormProtocolLabel3",                        "3. Display Control");
                LangFile.FormProtocolLabel4 = IF->ReadString(SectionName,  "FormProtocolLabel4",                        "4. Display Method");
                LangFile.FormProtocolLabel5 = IF->ReadString(SectionName,  "FormProtocolLabel5",                        "5. Text Code");
                LangFile.FormProtocolLabel6 = IF->ReadString(SectionName,  "FormProtocolLabel6",                        "6. Font Size");
                LangFile.FormProtocolLabel7 = IF->ReadString(SectionName,  "FormProtocolLabel7",                        "7. Entry Effect");
                LangFile.FormProtocolLabel8 = IF->ReadString(SectionName,  "FormProtocolLabel8",                        "8. Exit Effect");
                LangFile.FormProtocolLabel9 = IF->ReadString(SectionName,  "FormProtocolLabel9",                        "9. Assistant Effect");
                LangFile.FormProtocolLabel10 = IF->ReadString(SectionName, "FormProtocolLabel10",                       "10.Effect Speed");
                LangFile.FormProtocolLabel11 = IF->ReadString(SectionName, "FormProtocolLabel11",                       "11.Stay Time(x500ms)");
                LangFile.FormProtocolLabel12 = IF->ReadString(SectionName, "FormProtocolLabel12",                       "12.X Start Pos.");
                LangFile.FormProtocolLabel13 = IF->ReadString(SectionName, "FormProtocolLabel13",                       "13.Y Start Pos.");
                LangFile.FormProtocolLabel14 = IF->ReadString(SectionName, "FormProtocolLabel14",                       "14.X End Pos.");
                LangFile.FormProtocolLabel15 = IF->ReadString(SectionName, "FormProtocolLabel15",                       "15.Y End Pos.");
                LangFile.FormProtocolLabel16 = IF->ReadString(SectionName, "FormProtocolLabel16",                       "16.B.G. Image");
                LangFile.FormProtocolLabel17 = IF->ReadString(SectionName, "FormProtocolLabel17",                       "17.1.Text Color");
                LangFile.FormProtocolLabel18 = IF->ReadString(SectionName, "FormProtocolLabel18",                       "17.2.Text B.G. Color");
                LangFile.FormProtocolLabel19 = IF->ReadString(SectionName, "FormProtocolLabel19",                       "18.Text Message");
                LangFile.FormProtocolLabel20 = IF->ReadString(SectionName, "FormProtocolLabel20",                       "Delete Normal Message Memory");
                LangFile.FormProtocolLabel21 = IF->ReadString(SectionName, "FormProtocolLabel21",                       "Register Total Pages for N.Message");
                LangFile.FormProtocolLabel22 = IF->ReadString(SectionName, "FormProtocolLabel22",                       "Select B.G. Image");
                LangFile.FormProtocolLabel23 = IF->ReadString(SectionName, "FormProtocolLabel23",                       "Note : Please be sure to confirm the actual display image on LED screen");
                LangFile.FormProtocolLabel24 = IF->ReadString(SectionName, "FormProtocolLabel24",                       "from which some preview image could differ, depending on the parameter.");
                LangFile.FormProtocolLabel25 = IF->ReadString(SectionName, "FormProtocolLabel25",                       "Receive repetitions");
                LangFile.FormProtocolLabel26 = IF->ReadString(SectionName, "FormProtocolLabel26",                       "Screen Size");
                LangFile.FormProtocolLabel27 = IF->ReadString(SectionName, "FormProtocolLabel27",                       "Dsp.Main");
                LangFile.FormProtocolTab1    = IF->ReadString(SectionName, "FormProtocolTab1",                          "Emergency");
                LangFile.FormProtocolTab2    = IF->ReadString(SectionName, "FormProtocolTab2",                          "Normal");
                LangFile.FormProtocolTab3    = IF->ReadString(SectionName, "FormProtocolTab3",                          "Special Functions");
                LangFile.FormProtocolEffect1  = IF->ReadString(SectionName, "FormProtocolEffect1",                      "Disabled");
                LangFile.FormProtocolEffect2  = IF->ReadString(SectionName, "FormProtocolEffect2",                      "NoShow");
                LangFile.FormProtocolEffect3  = IF->ReadString(SectionName, "FormProtocolEffect3",                      "Wipe List");
                LangFile.FormProtocolEffect4  = IF->ReadString(SectionName, "FormProtocolEffect4",                      "Add List");
                LangFile.FormProtocolEffect5  = IF->ReadString(SectionName, "FormProtocolEffect5",                      "ASCII");
                LangFile.FormProtocolEffect6  = IF->ReadString(SectionName, "FormProtocolEffect6",                      "UniCode");
                LangFile.FormProtocolEffect7  = IF->ReadString(SectionName, "FormProtocolEffect7",                      "Line");
                LangFile.FormProtocolEffect8  = IF->ReadString(SectionName, "FormProtocolEffect8",                      "Vertical");
                LangFile.FormProtocolEffect9  = IF->ReadString(SectionName, "FormProtocolEffect9",                      "Send Total");
                LangFile.FormProtocolEffect10 = IF->ReadString(SectionName, "FormProtocolEffect10",                     "Verti.|Horiz.");
                LangFile.FormProtocolEffect11 = IF->ReadString(SectionName, "FormProtocolEffect11",                     "Direction");
                LangFile.FormProtocolDateItem1 = IF->ReadString(SectionName, "FormProtocolDateItem1",                   "Mon");
                LangFile.FormProtocolDateItem2 = IF->ReadString(SectionName, "FormProtocolDateItem2",                   "Tue");
                LangFile.FormProtocolDateItem3 = IF->ReadString(SectionName, "FormProtocolDateItem3",                   "Wed");
                LangFile.FormProtocolDateItem4 = IF->ReadString(SectionName, "FormProtocolDateItem4",                   "Thu");
                LangFile.FormProtocolDateItem5 = IF->ReadString(SectionName, "FormProtocolDateItem5",                   "Fri");
                LangFile.FormProtocolDateItem6 = IF->ReadString(SectionName, "FormProtocolDateItem6",                   "Sat");
                LangFile.FormProtocolDateItem7 = IF->ReadString(SectionName, "FormProtocolDateItem7",                   "Sun");
                SectionName = "Effect";
                LangFile.NoEffect     = IF->ReadString(SectionName, "NoEffect",     "None");
                LangFile.EffectType1  = IF->ReadString(SectionName, "EffectType1",  "Stop");
                LangFile.EffectType2  = IF->ReadString(SectionName, "EffectType2",  "Random");
                LangFile.EffectType3  = IF->ReadString(SectionName, "EffectType3",  "Shift");
                LangFile.EffectType4  = IF->ReadString(SectionName, "EffectType4",  "Wipe");
                LangFile.EffectType5  = IF->ReadString(SectionName, "EffectType5",  "Blind");
                LangFile.EffectType6  = IF->ReadString(SectionName, "EffectType6",  "Curtain");
                LangFile.EffectType7  = IF->ReadString(SectionName, "EffectType7",  "ZoomOut");
                LangFile.EffectType8  = IF->ReadString(SectionName, "EffectType8",  "ZoomIn");
                LangFile.EffectType9  = IF->ReadString(SectionName, "EffectType9",  "Rotate");
                LangFile.EffectType10 = IF->ReadString(SectionName, "EffectType10", "Blink B.G.");
                LangFile.EffectType11 = IF->ReadString(SectionName, "EffectType11", "Blink Text");
                LangFile.EffectType12 = IF->ReadString(SectionName, "EffectType12", "3D Effect");
                LangFile.EffectType13 = IF->ReadString(SectionName, "EffectType13", "Test");
                LangFile.EffectType14 = IF->ReadString(SectionName, "EffectType14", "");
                LangFile.EffectType15 = IF->ReadString(SectionName, "EffectType15", "");
                LangFile.EffectType16 = IF->ReadString(SectionName, "EffectType16", "");
                LangFile.EffectType17 = IF->ReadString(SectionName, "EffectType17", "");
                LangFile.EffectType18 = IF->ReadString(SectionName, "EffectType18", "");
                LangFile.EffectType19 = IF->ReadString(SectionName, "EffectType19", "");
                LangFile.EffectType20 = IF->ReadString(SectionName, "EffectType20", "");

                LangFile.DirType1  = IF->ReadString(SectionName, "DirType1",  "NoDir");
                LangFile.DirType2  = IF->ReadString(SectionName, "DirType2",  "BrightOn");
                LangFile.DirType3  = IF->ReadString(SectionName, "DirType3",  "BirghtOff");
                LangFile.DirType4  = IF->ReadString(SectionName, "DirType4",  "HoriMirror");
                LangFile.DirType5  = IF->ReadString(SectionName, "DirType5",  "VertMirror");
                LangFile.DirType6  = IF->ReadString(SectionName, "DirType6",  "Left");
                LangFile.DirType7  = IF->ReadString(SectionName, "DirType7",  "Right");
                LangFile.DirType8  = IF->ReadString(SectionName, "DirType8",  "Up");
                LangFile.DirType9  = IF->ReadString(SectionName, "DirType9",  "Down");
                LangFile.DirType10 = IF->ReadString(SectionName, "DirType10", "Left Up");
                LangFile.DirType11 = IF->ReadString(SectionName, "DirType11", "Up&Down");
                LangFile.DirType12 = IF->ReadString(SectionName, "DirType12", "Left to Add");
                LangFile.DirType13 = IF->ReadString(SectionName, "DirType13", "Left Down");
                LangFile.DirType14 = IF->ReadString(SectionName, "DirType14", "Right Up");
                LangFile.DirType15 = IF->ReadString(SectionName, "DirType15", "Right Down");
                LangFile.DirType16 = IF->ReadString(SectionName, "DirType16", "Center");
                LangFile.DirType17 = IF->ReadString(SectionName, "DirType17", "Hori.Side");
                LangFile.DirType18 = IF->ReadString(SectionName, "DirType18", "Hori.Center");
                LangFile.DirType19 = IF->ReadString(SectionName, "DirType19", "Vert.Side");
                LangFile.DirType20 = IF->ReadString(SectionName, "DirType20", "Vert.Center");
                LangFile.DirType21 = IF->ReadString(SectionName, "DirType21", "Hori.Side&Center");
                LangFile.DirType22 = IF->ReadString(SectionName, "DirType22", "Vert.Side&Center");
                LangFile.DirType23 = IF->ReadString(SectionName, "DirType23", "Clockwize");
                LangFile.DirType24 = IF->ReadString(SectionName, "DirType24", "Counter");
                LangFile.DirType25 = IF->ReadString(SectionName, "DirType25", "Clockwize2");
                LangFile.DirType26 = IF->ReadString(SectionName, "DirType26", "Counter2");
                LangFile.DirType27 = IF->ReadString(SectionName, "DirType27", "Red");
                LangFile.DirType28 = IF->ReadString(SectionName, "DirType28", "Green");
                LangFile.DirType29 = IF->ReadString(SectionName, "DirType29", "Blue");
                LangFile.DirType30 = IF->ReadString(SectionName, "DirType30", "White");
                LangFile.DirType31 = IF->ReadString(SectionName, "DirType31", "All");
                LangFile.DirType32 = IF->ReadString(SectionName, "DirType32", "Sequential");
                LangFile.DirType33 = IF->ReadString(SectionName, "DirType33", "Random");
                LangFile.DirType34 = IF->ReadString(SectionName, "DirType34", "None");
                LangFile.DirType35 = IF->ReadString(SectionName, "DirType35", "None");
                LangFile.DirType36 = IF->ReadString(SectionName, "DirType36", "UpDown");
                LangFile.DirType37 = IF->ReadString(SectionName, "DirType37", "ShiftLeft");
                LangFile.DirType38 = IF->ReadString(SectionName, "DirType38", "ShiftRight");
                LangFile.DirType39 = IF->ReadString(SectionName, "DirType39", "ShiftUp");
                LangFile.DirType40 = IF->ReadString(SectionName, "DirType40", "ShiftDown");
                LangFile.DirType41 = IF->ReadString(SectionName, "DirType41", "ClearNone");
                LangFile.DirType42 = IF->ReadString(SectionName, "DirType42", "ClearLeft");
                LangFile.DirType43 = IF->ReadString(SectionName, "DirType43", "ClearRight");
                LangFile.DirType44 = IF->ReadString(SectionName, "DirType44", "ClearUp");
                LangFile.DirType45 = IF->ReadString(SectionName, "DirType45", "ClearDown");
                LangFile.DirType46 = IF->ReadString(SectionName, "DirType46", "Yellow");
                LangFile.DirType47 = IF->ReadString(SectionName, "DirType47", "");
                LangFile.DirType48 = IF->ReadString(SectionName, "DirType48", "");
                LangFile.DirType49 = IF->ReadString(SectionName, "DirType49", "");
                LangFile.DirType50 = IF->ReadString(SectionName, "DirType50", "");
                SectionName = "Message";
                LangFile.MessageCaption = IF->ReadString(SectionName,  "MessageCaption",  "Message Window");
                LangFile.MessageButton01 = IF->ReadString(SectionName, "MessageButton01", "Yes");
                LangFile.MessageButton02 = IF->ReadString(SectionName, "MessageButton02", "No");
                LangFile.MessageButton03 = IF->ReadString(SectionName, "MessageButton03", "Cancel");
                LangFile.MessageButton04 = IF->ReadString(SectionName, "MessageButton04", "Confirm");
                LangFile.MessageButton05 = IF->ReadString(SectionName, "MessageButton05", "Save");
                LangFile.MessageButton06 = IF->ReadString(SectionName, "MessageButton06", "Whole");
                LangFile.MessageButton07 = IF->ReadString(SectionName, "MessageButton07", "Part");
                LangFile.MessageButton08 = IF->ReadString(SectionName, "MessageButton08", "Text");
                LangFile.MessageButton09 = IF->ReadString(SectionName, "MessageButton09", "Graphic");
                LangFile.MessageButton10 = IF->ReadString(SectionName, "MessageButton10", "Close");
                LangFile.MessageButton11 = IF->ReadString(SectionName, "MessageButton11", "Save & Close");
                LangFile.MessageButton12 = IF->ReadString(SectionName, "MessageButton12", "Dupe 1th List");
                LangFile.MessageButton13 = IF->ReadString(SectionName, "MessageButton13", "Dupe Group");
                LangFile.MessageButton14 = IF->ReadString(SectionName, "MessageButton14", "Cancel Auto");
                LangFile.MessageButton15 = IF->ReadString(SectionName, "MessageButton15", "Read");
                LangFile.MessageButton16 = IF->ReadString(SectionName, "MessageButton16", "None");
                LangFile.MessageButton17 = IF->ReadString(SectionName, "MessageButton17", "Set");
                LangFile.MessageButton18 = IF->ReadString(SectionName, "MessageButton18", "Clear");
                LangFile.MessageButton19 = IF->ReadString(SectionName, "MessageButton19", "Create");
                LangFile.MessageButton20 = IF->ReadString(SectionName, "MessageButton20", "Stop");
                LangFile.Message01       = IF->ReadString(SectionName, "Message01", "Fastest");
                LangFile.Message02       = IF->ReadString(SectionName, "Message02", "Slowest");
                LangFile.Message03       = IF->ReadString(SectionName, "Message03", "Power On");
                LangFile.Message04       = IF->ReadString(SectionName, "Message04", "Power Off");
                LangFile.Message05       = IF->ReadString(SectionName, "Message05", "Can't connect");
                LangFile.Message06       = IF->ReadString(SectionName, "Message06", "Setting Time synchronization");
                LangFile.Message07       = IF->ReadString(SectionName, "Message07", "Setting DIBD Screen Size");
                LangFile.Message08       = IF->ReadString(SectionName, "Message08", "Clear Message Memory");
                LangFile.Message09       = IF->ReadString(SectionName, "Message09", "Message Register");
                LangFile.Message10       = IF->ReadString(SectionName, "Message10", "Select B.G. Image");
                LangFile.Message11       = IF->ReadString(SectionName, "Message11", "The command does not exist.");
                LangFile.Message12       = IF->ReadString(SectionName, "Message12", "This function is not supported by the firmware of DIBD.");
                LangFile.Message13       = IF->ReadString(SectionName, "Message13", "Transmitted data value is not normal.");
            }
        }
        __finally
        {
            if(IF)
            {
                delete IF;
                IF = NULL;
            }
        }
        InputLang();
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::InputLang()
{
        //       Լ
        //this->Caption       = LangFile.FormProtocolCaption;
        Label1->Caption     = LangFile.FormProtocolLabel1;
        Label2->Caption     = LangFile.FormProtocolLabel2;
        Label3->Caption     = LangFile.FormProtocolLabel3;
        Label4->Caption     = LangFile.FormProtocolLabel4;
        Label5->Caption     = LangFile.FormProtocolLabel5;
        Label6->Caption     = LangFile.FormProtocolLabel6 + "(Pixel)";
        Label7->Caption     = LangFile.FormProtocolLabel7;
        Label8->Caption     = LangFile.FormProtocolLabel8;
        Label9->Caption     = LangFile.FormProtocolLabel9;
        Label10->Caption    = LangFile.FormProtocolLabel10;
        Label11->Caption    = LangFile.FormProtocolLabel11;
        Label12->Caption    = LangFile.FormProtocolLabel12 + "(Pixel)";
        Label13->Caption    = LangFile.FormProtocolLabel13 + "(Pixel)";
        Label14->Caption    = LangFile.FormProtocolLabel14 + "(Pixel)";
        Label15->Caption    = LangFile.FormProtocolLabel15 + "(Pixel)";
        Label16->Caption    = LangFile.FormProtocolLabel16;
        Label17->Caption    = LangFile.FormProtocolLabel17;
        Label18->Caption    = LangFile.FormProtocolLabel18;
        Label19->Caption    = LangFile.FormProtocolLabel19;

        Label23->Caption    = LangFile.FormProtocolEffect11;
        Label24->Caption    = LangFile.FormProtocolEffect11;

        TeLabel1->Caption     = LangFile.FormProtocolLabel1;
        TeLabel2->Caption     = LangFile.FormProtocolLabel2;
        TeLabel3->Caption     = LangFile.FormProtocolLabel3;
        TeLabel4->Caption     = LangFile.FormProtocolLabel4;
        TeLabel5->Caption     = LangFile.FormProtocolLabel5;
        TeLabel6->Caption     = LangFile.FormProtocolLabel6 + "(Pixel)";
        TeLabel7->Caption     = LangFile.FormProtocolLabel7;
        TeLabel8->Caption     = LangFile.FormProtocolLabel8;
        TeLabel9->Caption     = LangFile.FormProtocolLabel9;
        TeLabel10->Caption    = LangFile.FormProtocolLabel10;
        TeLabel11->Caption    = LangFile.FormProtocolLabel11;
        TeLabel12->Caption    = LangFile.FormProtocolLabel12 + "(Pixel)";
        TeLabel13->Caption    = LangFile.FormProtocolLabel13 + "(Pixel)";
        TeLabel14->Caption    = LangFile.FormProtocolLabel14 + "(Pixel)";
        TeLabel15->Caption    = LangFile.FormProtocolLabel15 + "(Pixel)";
        TeLabel16->Caption    = LangFile.FormProtocolLabel16;
        TeLabel17->Caption    = LangFile.FormProtocolLabel17;
        TeLabel18->Caption    = LangFile.FormProtocolLabel18;
        TeLabel21->Caption    = LangFile.FormProtocolLabel19;
        gbMemClear->Caption   = LangFile.FormProtocolLabel20;
        gbMemInput->Caption   = LangFile.FormProtocolLabel21;
        gbBGImage->Caption    = LangFile.FormProtocolLabel22;
        cbRevRefeat->Caption  = LangFile.FormProtocolLabel25;
        TeLabel19->Caption    = LangFile.FormProtocolEffect11;
        TeLabel20->Caption    = LangFile.FormProtocolEffect11;

        tsEnv->Caption             = LangFile.FormProtocolTab1;
        tsNomarl->Caption          = LangFile.FormProtocolTab2;
        tsETC->Caption             = LangFile.FormProtocolTab3;
        NComPort->Caption          = LangFile.BtnPort;
        DataSend->Caption          = LangFile.BtnSend;
        BitBtnExit->Caption        = LangFile.BtnClose;
        BMemClear->Caption         = LangFile.BtnSend;
        BInput->Caption            = LangFile.BtnSend;
        BBGImage->Caption          = LangFile.BtnSend;
        SendSync->Caption          = LangFile.BtnSend;
        gbSync->Caption            = LangFile.BtnSignalSend;
        BitBtnSyncLED->Caption     = LangFile.BtnSyncLED;
        BitBtnPowerLEDOn->Caption  = LangFile.BtnPowerLEDOn;
        BitBtnPowerLEDOff->Caption = LangFile.BtnPowerLEDOff;
        gbSignSize->Caption        = LangFile.BtnSize;
        BDIBDTime->Caption         = LangFile.BtnTimeRead;
        pnLog->Caption             = LangFile.BtnLog;

        WideString asEffectType[24] = {LangFile.EffectType1, LangFile.EffectType2, LangFile.EffectType3, LangFile.EffectType4, LangFile.EffectType5,
            LangFile.EffectType6, LangFile.EffectType7, LangFile.EffectType8, LangFile.EffectType9, LangFile.EffectType10,
            LangFile.EffectType11, LangFile.EffectType12, LangFile.EffectType13,LangFile.EffectType14, LangFile.EffectType15,
            LangFile.EffectType16, LangFile.EffectType17, LangFile.EffectType18, LangFile.EffectType19, LangFile.EffectType20};
        for(int i = 0; i < EffectTypeCount; i++)
            EffectType[i] = asEffectType[i];

        WideString asDirType[50] = {LangFile.DirType1, LangFile.DirType2, LangFile.DirType3, LangFile.DirType4, LangFile.DirType5,
            LangFile.DirType6, LangFile.DirType7, LangFile.DirType8, LangFile.DirType9, LangFile.DirType10,
            LangFile.DirType11, LangFile.DirType12, LangFile.DirType13, LangFile.DirType14, LangFile.DirType15,
            LangFile.DirType16, LangFile.DirType17, LangFile.DirType18, LangFile.DirType19, LangFile.DirType20,
            LangFile.DirType21, LangFile.DirType22, LangFile.DirType23, LangFile.DirType24, LangFile.DirType25,
            LangFile.DirType26, LangFile.DirType27, LangFile.DirType28, LangFile.DirType29, LangFile.DirType30,
            LangFile.DirType31, LangFile.DirType32, LangFile.DirType33, LangFile.DirType34, LangFile.DirType35,
            LangFile.DirType36, LangFile.DirType37, LangFile.DirType38, LangFile.DirType39, LangFile.DirType40,
            LangFile.DirType41, LangFile.DirType42, LangFile.DirType43, LangFile.DirType44, LangFile.DirType45,
            LangFile.DirType46, LangFile.DirType47, LangFile.DirType48, LangFile.DirType49, LangFile.DirType50};
        if(ProgramType == e2BPP)
            asDirType[29] = LangFile.DirType46;
        for(int i = 0; i < DirTypeCount; i++)
            DirType[i] = asDirType[i];

        SpeedValue[0] = "0(" + LangFile.Message01 + ")";
        for(int i = 1; i <= 16; i++)
            SpeedValue[i] = IntToStr(i * 10);
        SpeedValue[17] = IntToStr(200);
        SpeedValue[18] = IntToStr(255) + "(" + LangFile.Message02 + ")";
        DelayValue[0] = "0";
        DelayValue[1] = "2";
        DelayValue[2] = "4";
        DelayValue[3] = "8";
        DelayValue[4] = "10";
        DelayValue[5] = "15";
        DelayValue[6] = "20";
        DelayValue[7] = "30";
        DelayValue[8] = "40";
        DelayValue[9] = "60";
        DelayValue[10] = "90";
        DelayValue[11] = "120(2Min)";
        DelayValue[12] = "180(3Min)";
        DelayValue[13] = "300(5Min)";
        DelayValue[14] = "600(10Min)";
        DelayValue[15] = "1800(30Min)";
        DelayValue[16] = "3600(1Hour)";
        DelayValue[17] = "10800(3Hour)";
        DelayValue[18] = "18000(5Hour)";
        DelayValue[19] = "32400(9Hour)";

        cbDispControl->ItemIndex = -1;
        cbDispControl2->ItemIndex = -1;
        for(int i = 1; i <= 98; i++)
        {
            cbDispControl->Items->Add(IntToStr(i));
            //cbDispControl2->Items->Add(IntToStr(i));
        }
        cbDispControl->ItemIndex = 0;
        cbDispControl2->ItemIndex = 0;

        cbPageNo->Clear();
        cbPageNo->Items->Add(LangFile.FormProtocolEffect1);
        cbPageNo->ItemIndex = 0;

        cbAssistEffect->Clear();
        cbAssistEffect->Items->Add(LangFile.FormProtocolEffect1);
        cbAssistEffect->ItemIndex = 0;

        cbAssistEffect2->Clear();
        cbAssistEffect2->Items->Add(LangFile.FormProtocolEffect1);
        cbAssistEffect2->ItemIndex = 0;

        int PageIndex2 = ProtocolPageNo2;
        cbPageNo2->Clear();
        cbMsgMemClear->Clear();
        cbMsgMemClear->Items->Add(LangFile.BtnSelectAll);
        cbMsgInput->Clear();
        for(int i = 0; i < 10; i++)
        {
            cbMsgMemClear->Items->Add(IntToStr(i));
            cbPageNo->Items->Add(IntToStr(i));
            cbPageNo2->Items->Add(IntToStr(i));
        }
        for(int i = 0; i < 50; i++)
            cbMsgInput->Items->Add(IntToStr(i + 1));
        cbMsgMemClear->ItemIndex = 0;
        cbPageNo2->ItemIndex = PageIndex2;
        cbMsgInput->ItemIndex = MessageCount - 1;
        ProtocolPageNo2 = PageIndex2;

        cbBGISelect->Clear();
        cbBGISelect->Items->Add(LangFile.FormProtocolEffect1);
        for(int i = 1; i <= 255; i++)
            cbBGISelect->Items->Add(IntToStr(i));
        cbBGISelect->ItemIndex = 0;

        cbCodeKind->Clear();
        cbCodeKind2->Clear();
        cbCodeKind->Items->Add(LangFile.FormProtocolEffect5);
        cbCodeKind->Items->Add(LangFile.FormProtocolEffect6);
        cbCodeKind2->Items->Add(LangFile.FormProtocolEffect5);
        cbCodeKind2->Items->Add(LangFile.FormProtocolEffect6);
        cbCodeKind->ItemIndex = 0;
        cbCodeKind2->ItemIndex = 0;

        cbFontSize->Items->Clear();
        cbFontSize2->Items->Clear();
        for(int i = 3; i <= 16; i++)
        {
            cbFontSize->Items->Add(IntToStr(i * 4));
            cbFontSize2->Items->Add(IntToStr(i * 4));
        }
        cbFontSize->ItemIndex = 0;
        cbFontSize2->ItemIndex = 0;

        cbEntEffect->Clear();
        cbLasEffect->Clear();
        cbEntEffect2->Clear();
        cbLasEffect2->Clear();
        cbLasEffect->Items->Add(LangFile.NoEffect);
        cbLasEffect2->Items->Add(LangFile.NoEffect);
        for(int i = 0; i < EffectTypeCount - 1; i++)
        {
            cbEntEffect->Items->Add(EffectType[i]);
            cbLasEffect->Items->Add(EffectType[i]);
            cbEntEffect2->Items->Add(EffectType[i]);
            cbLasEffect2->Items->Add(EffectType[i]);
        }
        cbEntEffect->ItemIndex = 0;
        cbLasEffect->ItemIndex = 0;
        cbEntEffect2->ItemIndex = 0;
        cbLasEffect2->ItemIndex = 0;
        cbEntDirect->Text = DirType[0];
        cbLasDirect->Text = LangFile.NoEffect;
        cbEntDirect2->Text = DirType[0];
        cbLasDirect2->Text = LangFile.NoEffect;

        cbSpeed->Clear();
        cbSpeed2->Clear();
        for(int i = 0; i < 19; i++)
        {
            cbSpeed->Items->Add(SpeedValue[i]);
            cbSpeed2->Items->Add(SpeedValue[i]);
        }
        cbSpeed->ItemIndex = 0;
        cbSpeed2->ItemIndex = 0;

        cbDelay->Clear();
        cbDelay2->Clear();
        for(int i = 0; i < 20; i++)
        {
            cbDelay->Items->Add(DelayValue[i]);
            cbDelay2->Items->Add(DelayValue[i]);
        }
        cbDelay->ItemIndex = 1;
        cbDelay2->ItemIndex = 1;

        cbStartXPos->ItemIndex = -1;
        cbEndXPos->ItemIndex = -1;
        cbStartXPos2->ItemIndex = -1;
        cbEndXPos2->ItemIndex = -1;
        cbStartXPos->Clear();
        cbEndXPos->Clear();
        cbStartXPos2->Clear();
        cbEndXPos2->Clear();
        for(int i = 0; i <= ModuleWidth * 4; i++)
        {
            cbStartXPos->Items->Add(IntToStr(i * 4));
            cbEndXPos->Items->Add(IntToStr(i * 4));
            cbStartXPos2->Items->Add(IntToStr(i * 4));
            cbEndXPos2->Items->Add(IntToStr(i * 4));
        }
        cbStartXPos->ItemIndex = 0;
        cbEndXPos->ItemIndex = cbEndXPos->Count - 1;
        cbStartXPos2->ItemIndex = 0;
        cbEndXPos2->ItemIndex = cbEndXPos2->Count - 1;

        cbStartYPos->ItemIndex = -1;
        cbEndYPos->ItemIndex = -1;
        cbStartYPos2->ItemIndex = -1;
        cbEndYPos2->ItemIndex = -1;
        cbStartYPos->Clear();
        cbEndYPos->Clear();
        cbStartYPos2->Clear();
        cbEndYPos2->Clear();
        for(int i = 0; i <= ModuleHeight * 4; i++)
        {
            cbStartYPos->Items->Add(IntToStr(i * 4));
            cbEndYPos->Items->Add(IntToStr(i * 4));
            cbStartYPos2->Items->Add(IntToStr(i * 4));
            cbEndYPos2->Items->Add(IntToStr(i * 4));
        }
        cbStartYPos->ItemIndex = 0;
        cbEndYPos->ItemIndex = cbEndYPos->Count - 1;
        cbStartYPos2->ItemIndex = 0;
        cbEndYPos2->ItemIndex = cbEndYPos2->Count - 1;

        cbBGImage->Clear();
        cbBGImage2->Clear();
        cbBGImage->Items->Add(LangFile.FormProtocolEffect1);
        cbBGImage2->Items->Add(LangFile.FormProtocolEffect1);
        for(int i = 1; i <= 10; i++)
        {
            cbBGImage->Items->Add(IntToStr(i));
            cbBGImage2->Items->Add(IntToStr(i));
        }
        cbBGImage->ItemIndex = 0;
        cbBGImage2->ItemIndex = 0;

        try{
            if(ProtocolTabKind == 0)
                pcMessage->ActivePage = tsEnv;
            else if(ProtocolTabKind == 2)
                pcMessage->ActivePage = tsETC;
            else
                pcMessage->ActivePage = tsNomarl;
            rbTextNoRoadClick(this);
            if(ProtocolBlockNo == 1)
                rbNo2->Checked = true;
            else if(ProtocolBlockNo == 2)
                rbNo3->Checked = true;
            else// if(ProtocolBlockNo == 0)
                rbNo1->Checked = true;
            cbPageNo2->ItemIndex = ProtocolPageNo2;
            rbTextNoRoad2Click(this);
            if(ProtocolBlockNo2 == 1)
                rbNo22->Checked = true;
            else if(ProtocolBlockNo2 == 2)
                rbNo23->Checked = true;
            else// if(ProtocolBlockNo2 == 0)
                rbNo21->Checked = true;
            if(pcMessage->ActivePage == tsETC)
                DataSend->Visible = false;
            UpDownHeight->Position = ModuleHeight;
            UpDownWidth->Position = ModuleWidth;
        }catch(...){
        }
}
//---------------------------------------------------------------------------

int __fastcall TFormMain::Message(WideString Mes, WideString wsYes, WideString wsNo, WideString wsCancel, int Width, int Height, int btnCnt, TColor FontColor)
{
        // ޽  Լ
        formMessage = new TFormMessage(this);
        formMessage->Caption = LangFile.MessageCaption;
        formMessage->laMessage->Font->Color = FontColor;
        formMessage->laMessage->Caption = Mes;
        int tempWidth = 0;
        int tempHeight = 0;
        if((Width * 10) * 2 > 15 * 10 * 2)
        {
            if((Width * 10) * 2 > 25 * 12 * 2)
                tempWidth = 25 * 12 * 2;
            else
                tempWidth = (Width * 10) * 2;
        }
        else
            tempWidth = 15 * 10 * 2;
        formMessage->Width = tempWidth;
        formMessage->laMessage->Width = formMessage->Width;
        formMessage->laMessage->Top = 18;
        formMessage->laMessage->Height = formMessage->laMessage->Top + Height * 13;
        tempHeight = 110 + formMessage->laMessage->Height;
        formMessage->Height = tempHeight;
        formMessage->btnYes->Top = formMessage->laMessage->Top + formMessage->laMessage->Height + 12;
        formMessage->btnNo->Top = formMessage->btnYes->Top;
        formMessage->btnCancel->Top = formMessage->btnYes->Top;
        formMessage->laMessage->Alignment = (TAlignment)2;
        if(btnCnt == 1)
        {
            formMessage->btnNo->Visible = false;
            formMessage->btnCancel->Visible = false;
        }
        else if(btnCnt == 2)
            formMessage->btnCancel->Visible = false;
        formMessage->btnYes->Left = (formMessage->Width - ((formMessage->btnYes->Width * btnCnt) + (btnCnt * 10))) / 2;
        formMessage->btnNo->Left = formMessage->btnYes->Left + formMessage->btnYes->Width + 10;
        formMessage->btnCancel->Left = formMessage->btnNo->Left + formMessage->btnNo->Width + 10;
        formMessage->btnYes->Caption = wsYes;
        formMessage->btnNo->Caption = wsNo;
        formMessage->btnCancel->Caption = wsCancel;
        formMessage->TabStop = true;
        formMessage->TabOrder = 1;
        formMessage->ShowModal();
        int Res = formMessage->Tag;
        if(formMessage)
        {
            delete formMessage;
            formMessage = NULL;
        }
        return Res;
}
//--------------------------------------------------------------------------

void __fastcall TFormMain::NoneDelayCount(int Cnt)
{
        //  Լ
        DWORD nowTick = GetTickCount();
        DWORD targetTick = nowTick + Cnt;
        while(nowTick < targetTick)
        {
            nowTick = GetTickCount();
            Application->ProcessMessages();
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::LANDelayCount(int Cnt)
{
        //   Լ
        DWORD nowTick = GetTickCount();
        DWORD targetTick = nowTick + Cnt;
        DWORD gap;
        bool bShow = false;
        TFormMessage *FMessage = NULL;
        while(nowTick < targetTick)
        {
            nowTick = GetTickCount();
            Application->ProcessMessages();
            gap = (targetTick - nowTick - 1) / 1000;
            if(this->Showing)
            {
                if((Cnt / 1000) - gap > 4 && !bShow)
                {
                    bShow = true;
                    FMessage = new TFormMessage(this);
                    FMessage->Caption = "Message";
                    FMessage->laMessage->Font->Color = clRed;
                    FMessage->laMessage->Font->Style = TFontStyles() << fsBold;
                    FMessage->laMessage->Caption = "\r\nConnecting Network. Please wait ...\r\n";
                    FMessage->Width = (17 * 12) * 2;
                    FMessage->laMessage->Width = FMessage->Width;
                    FMessage->laMessage->Top = 18;
                    FMessage->laMessage->Height = FMessage->laMessage->Top + 4 * 13;
                    FMessage->Height = 90 + FMessage->laMessage->Height + FMessage->btnCancel->Height;
                    FMessage->btnYes->Top = FMessage->laMessage->Top + FMessage->laMessage->Height + 12;
                    FMessage->laMessage->Alignment = (TAlignment)2;
                    FMessage->btnYes->Visible = false;
                    FMessage->btnNo->Visible = false;
                    FMessage->btnCancel->Caption = "Cancel";
                    FMessage->btnCancel->Top = FMessage->laMessage->Top + FMessage->laMessage->Height + 12;
                    FMessage->btnCancel->Left = (FMessage->Width - FMessage->btnCancel->Width) / 2;
                    FMessage->btnCancel->Visible = true;
                    FMessage->Show();
                    FMessage->Update();
                    FMessage->BringToFront();
                }
            }
            if(FMessage)
            {
                if(FMessage->Tag == mrCancel)
                   bStopSend = true;
                FMessage->laMessage->Caption = "\r\nConnecting Network. Please wait ...\r\n\r\n Time : " + IntToStr(gap + 1) + " Sec";
            }
            if(DNSConnect || bStopSend)
                break;
        }
        if(FMessage)
        {
            delete FMessage;
            FMessage = NULL;
        }
}
//---------------------------------------------------------------------------

bool __fastcall TFormMain::ModuleData(BYTE ComKind, BYTE Addr, BYTE *Data, DWORD DataLen, int Number, OPCode OPC, bool bMessage)
{
        //   ú  ް Ǵϴ Լ
        bool res = false;
        bCRCFail = false;
        DWORD nowTick = 0;
        DWORD targetTick = 0;
        ZeroMemory(&RP, sizeof(RP));
        SchBmpFile = false;
        SendData(ComKind, Addr, Data, DataLen, Number, OPC);
        nowTick = GetTickCount();
        if(DelayRun)
        {
            targetTick = nowTick + DelayTime;
            while(nowTick < targetTick)
            {
                nowTick = GetTickCount();
                Application->ProcessMessages();
            }
            res = true;
        }
        else
        {
            targetTick = GetTickCount() + WaitTime;
            while(nowTick < targetTick)
            {
                nowTick = GetTickCount();
                Application->ProcessMessages();
                if(SchBmpFile)
                    break;
            }
            if(!SchBmpFile || bCRCFail)
            {
                AnsiString asMessage = "Transfer FAIL";
                if(bCRCFail)
                    asLogMessage += " [CRC FAIL]";
                if(bMessage)
                    Message("\r\n" + asMessage + "\r\n", LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
                if(bDataFail)
                {
                    if(FailData == 0x10)
                        asLogMessage = asLogMessage + " [" + LangFile.Message10 + "]\r\n";
                    else if(FailData == 0x20)
                        asLogMessage = asLogMessage + " [" + LangFile.Message11 + "]\r\n";
                    else if(FailData == 0x40)
                        asLogMessage = asLogMessage + " [" + LangFile.Message12 + "]\r\n";
                    else
                        asLogMessage = asLogMessage + " 0x" + Byte2HexConvert(FailData) + " [Data FAIL]\r\n";
                }
                res = false;
            }
            else
                res = true;
        }
        return res;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::SendData(BYTE ComKind, BYTE Add, BYTE *Data, DWORD DataLen, int Number, OPCode OPC)
{
        //    Լ
        int TotDataLen = 0;
        char *CDBuff;
        union{
            DWORD iSize;
            BYTE cSize[4];
        }uSize;
        union{
            unsigned int uiData;
            char cData[2];
        }uData;
        int bccvalue = 0;
        int cdSize = 0;
        bool tempBCC = false;
        //tempBCC = bFlagCrcPacket;
        if(ComKind == 0)
            tempBCC = true;
        else
            tempBCC = false;
        if(tempBCC)
            bccvalue = 2;
        int CRCDLESize = 0;
        uSize.iSize = 1 + DataLen;
        CRCDLESize = uSize.iSize + bccvalue + 3;
        BYTE *CRCData = NULL;
        CRCData = new BYTE[CRCDLESize];
        ZeroMemory(CRCData, CRCDLESize);
        CRCData[0] = Add;
        if(tempBCC)
            uSize.iSize += 2;
        CRCData[1] = uSize.cSize[1];
        if(DelayRun)
            CRCData[1] |= 0x20;
        if(tempBCC)
            CRCData[1] |= 0x40;
        CRCData[2] = uSize.cSize[0];
        CRCData[3] = OPC;
        memcpy(&CRCData[4], Data, DataLen);
        if(tempBCC)
        {
            uData.uiData = Calc_crc(CRCData, CRCDLESize - bccvalue);
            memcpy(&CRCData[4 + DataLen], uData.cData, bccvalue);
        }
        TotDataLen = 8 + bccvalue + DataLen + cdSize;
        CDBuff = new char[TotDataLen];
        ZeroMemory(CDBuff, TotDataLen);

        CDBuff[0] = DLE;
        CDBuff[1] = STX;
        memcpy(&CDBuff[2], CRCData, CRCDLESize);
        CDBuff[2 + CRCDLESize + cdSize] = DLE;
        CDBuff[3 + CRCDLESize + cdSize] = ETX;
        asLogMessage = " ";
        if(Number <= 1)
        {
            for(int i = 0; i < TotDataLen; i++)
                asLogMessage = asLogMessage + Byte2HexConvert(CDBuff[i]) + " ";
        }
        else
        {
            for(int i = 0; i < 21; i++)
                asLogMessage = asLogMessage + Byte2HexConvert(CDBuff[i]) + " ";
            asLogMessage = asLogMessage + "~ ";
            for(int i = TotDataLen - 2; i < TotDataLen; i++)
                asLogMessage = asLogMessage + Byte2HexConvert(CDBuff[i]) + " ";
        }
        try{
            if(ComKind == 1)
            {
                if(!ClientSocket1->Socket->Connected)
                {
                    DNSConnect = false;
                    ClientSocket1->Open();
                    LANDelayCount(ServerCommOpenDelay);
                    if(DNSConnect)
                        DNSConnect = false;
                }
                ClientSocket1->Socket->SendBuf(CDBuff, TotDataLen);
            }
            else if(ComKind == 2)
            {
                if(SH)
                {
                    //if(SH->Connect)
                        IdUDPServer->SendBuffer(asUDPIPAddress, DSPPort, CDBuff, TotDataLen);
                }
            }
            else
            {
                if(!ComPort1->Connected)
                    ComPort1->Open();
                ComPort1->Write(CDBuff, TotDataLen);
            }
        }catch(...){
        }
        if(CRCData)
        {
            delete [] CRCData;
            CRCData = NULL;
        }
        if(CDBuff)
        {
            delete [] CDBuff;
            CDBuff = NULL;
        }
}
//---------------------------------------------------------------------------

unsigned short int __fastcall TFormMain::Calc_crc(unsigned char *buf, int numbytes)
{
      // CRC Լ
      unsigned char *ptr = buf, d;
      int i;
      int j;
      static const unsigned short int wCRCTable[] = {
          0X0000, 0XC0C1, 0XC181, 0X0140, 0XC301, 0X03C0, 0X0280, 0XC241,
          0XC601, 0X06C0, 0X0780, 0XC741, 0X0500, 0XC5C1, 0XC481, 0X0440,
          0XCC01, 0X0CC0, 0X0D80, 0XCD41, 0X0F00, 0XCFC1, 0XCE81, 0X0E40,
          0X0A00, 0XCAC1, 0XCB81, 0X0B40, 0XC901, 0X09C0, 0X0880, 0XC841,
          0XD801, 0X18C0, 0X1980, 0XD941, 0X1B00, 0XDBC1, 0XDA81, 0X1A40,
          0X1E00, 0XDEC1, 0XDF81, 0X1F40, 0XDD01, 0X1DC0, 0X1C80, 0XDC41,
          0X1400, 0XD4C1, 0XD581, 0X1540, 0XD701, 0X17C0, 0X1680, 0XD641,
          0XD201, 0X12C0, 0X1380, 0XD341, 0X1100, 0XD1C1, 0XD081, 0X1040,
          0XF001, 0X30C0, 0X3180, 0XF141, 0X3300, 0XF3C1, 0XF281, 0X3240,
          0X3600, 0XF6C1, 0XF781, 0X3740, 0XF501, 0X35C0, 0X3480, 0XF441,
          0X3C00, 0XFCC1, 0XFD81, 0X3D40, 0XFF01, 0X3FC0, 0X3E80, 0XFE41,
          0XFA01, 0X3AC0, 0X3B80, 0XFB41, 0X3900, 0XF9C1, 0XF881, 0X3840,
          0X2800, 0XE8C1, 0XE981, 0X2940, 0XEB01, 0X2BC0, 0X2A80, 0XEA41,
          0XEE01, 0X2EC0, 0X2F80, 0XEF41, 0X2D00, 0XEDC1, 0XEC81, 0X2C40,
          0XE401, 0X24C0, 0X2580, 0XE541, 0X2700, 0XE7C1, 0XE681, 0X2640,
          0X2200, 0XE2C1, 0XE381, 0X2340, 0XE101, 0X21C0, 0X2080, 0XE041,
          0XA001, 0X60C0, 0X6180, 0XA141, 0X6300, 0XA3C1, 0XA281, 0X6240,
          0X6600, 0XA6C1, 0XA781, 0X6740, 0XA501, 0X65C0, 0X6480, 0XA441,
          0X6C00, 0XACC1, 0XAD81, 0X6D40, 0XAF01, 0X6FC0, 0X6E80, 0XAE41,
          0XAA01, 0X6AC0, 0X6B80, 0XAB41, 0X6900, 0XA9C1, 0XA881, 0X6840,
          0X7800, 0XB8C1, 0XB981, 0X7940, 0XBB01, 0X7BC0, 0X7A80, 0XBA41,
          0XBE01, 0X7EC0, 0X7F80, 0XBF41, 0X7D00, 0XBDC1, 0XBC81, 0X7C40,
          0XB401, 0X74C0, 0X7580, 0XB541, 0X7700, 0XB7C1, 0XB681, 0X7640,
          0X7200, 0XB2C1, 0XB381, 0X7340, 0XB101, 0X71C0, 0X7080, 0XB041,
          0X5000, 0X90C1, 0X9181, 0X5140, 0X9301, 0X53C0, 0X5280, 0X9241,
          0X9601, 0X56C0, 0X5780, 0X9741, 0X5500, 0X95C1, 0X9481, 0X5440,
          0X9C01, 0X5CC0, 0X5D80, 0X9D41, 0X5F00, 0X9FC1, 0X9E81, 0X5E40,
          0X5A00, 0X9AC1, 0X9B81, 0X5B40, 0X9901, 0X59C0, 0X5880, 0X9841,
          0X8801, 0X48C0, 0X4980, 0X8941, 0X4B00, 0X8BC1, 0X8A81, 0X4A40,
          0X4E00, 0X8EC1, 0X8F81, 0X4F40, 0X8D01, 0X4DC0, 0X4C80, 0X8C41,
          0X4400, 0X84C1, 0X8581, 0X4540, 0X8701, 0X47C0, 0X4680, 0X8641,
          0X8201, 0X42C0, 0X4380, 0X8341, 0X4100, 0X81C1, 0X8081, 0X4040 };
      unsigned short int wCRCWord = 0x0000;
      for(j = 0; j < numbytes; j++)
      {
          d = (unsigned short int)*ptr++ ^ wCRCWord;
          wCRCWord >>= 8;
          wCRCWord  ^= wCRCTable[d];
      }
      return(wCRCWord);
}
//--------------------------------------------------------------------------

AnsiString __fastcall TFormMain::Byte2HexConvert(BYTE Value)
{
        // Byte   String Hex ȯ Լ
        AnsiString asResult = "";
        union{
            struct BIT {
                unsigned b0 : 4;
                unsigned b1 : 4;
            } bit;
            BYTE cData;
        }uData;
        uData.cData = Value;
        if(uData.bit.b1 ==  10)
            asResult = "A";
        else if(uData.bit.b1 ==  11)
            asResult = "B";
        else if(uData.bit.b1 ==  12)
            asResult = "C";
        else if(uData.bit.b1 ==  13)
            asResult = "D";
        else if(uData.bit.b1 ==  14)
            asResult = "E";
        else if(uData.bit.b1 >=  15)
            asResult = "F";
        else
            asResult += IntToStr(uData.bit.b1);
        if(uData.bit.b0 ==  10)
            asResult += "A";
        else if(uData.bit.b0 ==  11)
            asResult += "B";
        else if(uData.bit.b0 ==  12)
            asResult += "C";
        else if(uData.bit.b0 ==  13)
            asResult += "D";
        else if(uData.bit.b0 ==  14)
            asResult += "E";
        else if(uData.bit.b0 >=  15)
            asResult += "F";
        else
            asResult += IntToStr(uData.bit.b0);
        return asResult;
}
//---------------------------------------------------------------------------

BYTE __fastcall TFormMain::Hex2ByteConvert(AnsiString Value)
{
        // String Hex  Byte  ȯ Լ
        int iResult1 = 0;
        int iResult2 = 0;
        AnsiString tempValue = Value.SubString(1, 1);
        if(tempValue.LowerCase() == "a")
            iResult1 = 10;
        else if(tempValue.LowerCase() == "b")
            iResult1 = 11;
        else if(tempValue.LowerCase() == "c")
            iResult1 = 12;
        else if(tempValue.LowerCase() == "d")
            iResult1 = 13;
        else if(tempValue.LowerCase() == "e")
            iResult1 = 14;
        else if(tempValue.LowerCase() == "f")
            iResult1 = 15;
        else
            iResult1 = StrToIntDef(tempValue, 0);
        if(Value.Length() > 1)
        {
            tempValue = Value.SubString(2, 1);
            if(tempValue.LowerCase() == "a")
                iResult2 = 10;
            else if(tempValue.LowerCase() == "b")
                iResult2 = 11;
            else if(tempValue.LowerCase() == "c")
                iResult2 = 12;
            else if(tempValue.LowerCase() == "d")
                iResult2 = 13;
            else if(tempValue.LowerCase() == "e")
                iResult2 = 14;
            else if(tempValue.LowerCase() == "f")
                iResult2 = 15;
            else
                iResult2 = StrToIntDef(tempValue, 0);
        }
        union{
            struct BIT {
                unsigned b0 : 4;
                unsigned b1 : 4;
            } bit;
            BYTE cData;
        }uData;
        uData.bit.b0 = iResult1;
        uData.bit.b1 = iResult2;
        return (int)uData.cData;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::AddLog(AnsiString Msg, TColor Color)
{
        // α ǥ   Լ
        AnsiString Time = FormatDateTime("MM/DD hh:nn:ss", Now());
        try{
            if(RichEditLog->Lines->Count > 500)
                sbLogClear->Click();
            RichEditLog->SelStart = RichEditLog->Text.Length();
            RichEditLog->SelAttributes->Color = Color;
            RichEditLog->Lines->Add("[" + Time + "]\t " + Msg);
            SendMessage(RichEditLog->Handle, WM_VSCROLL, SB_BOTTOM, 0);
        }catch(...){
            sbLogClear->Click();
        }
        AnsiString LogFileName = "";
        AnsiString Buff = "";
        LogFileName = BasePath + IncludeTrailingPathDelimiter(DestLogPath) + FormatDateTime("YYYYMMDD", Now()) + "_" + IntToStr(LogFileCnt) + ".log";
        Buff = "[" + Time + "]\t " + Msg + "\r\n";
        TFileStream * FS = NULL;
        try{
            if(FileExists(LogFileName))
                FS = new TFileStream(LogFileName, fmOpenReadWrite | fmShareCompat);
            else
            {
                DeleteOldLogFile(BasePath + IncludeTrailingPathDelimiter(DestLogPath));
                LogFileName = BasePath + IncludeTrailingPathDelimiter(DestLogPath) + FormatDateTime("YYYYMMDD", Now()) + "_" + IntToStr(LogFileCnt) + ".log";
                FS = new TFileStream(LogFileName, fmCreate | fmShareCompat);
            }
            FS->Position = FS->Size;
            FS->Write(Buff.c_str(), Buff.Length());
            int tempSize = FS->Size + Buff.Length();
            if(tempSize > (128 * 1024))
            {
                LogFileCnt++;
                SaveIniFile();
            }
            OldLogDate = FormatDateTime("YYYYMMDD", Now());
        }catch (...){
        }
        if(FS)
        {
            delete FS;
            FS = NULL;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::DeleteOldLogFile(AnsiString SitePath)
{
        //  α   Լ
        if(SitePath == " " || SitePath == "")
            return;
        AnsiString FileName = "";
        AnsiString path = SitePath + "*.*";//LogPath + "*.*";
        TSearchRec sr;

        TDateTime dtToday = Now();
        TDateTime dtFile;

        int iAttributes = faAnyFile;
        if(0 == FindFirst(path, iAttributes, sr))
        {
            do
            {
                if((sr.Attr & faDirectory) == faDirectory)
                    continue;
                else
                {
                    dtFile = FileDateToDateTime(sr.Time);
                    if((dtToday - 7) >= dtFile)
                    {
                        FileName = BasePath + DestLogPath + "\\" + sr.Name;
                        if(ExtractFileExt(FileName).AnsiCompareIC(".log") == 0)
                            DeleteFile(FileName);
                    }
                }
            } while(0 == FindNext(sr));
        }
        FindClose(sr);
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnExitClick(TObject *Sender)
{
        // α׷ 
        ModuleHeight = UpDownHeight->Position;
        ModuleWidth = UpDownWidth->Position;
        ProtocolTabKind = pcMessage->ActivePageIndex;
        SaveIniFile();
        Application->Terminate();
}
//---------------------------------------------------------------------------

bool __fastcall TFormMain::CurrenTimeSync()
{
        // PC ð 
        bStopSend = false;
        bool Connect = false;
        AnsiString CurTimeData;
        TDateTime CurTime;
        CurTime = Now();
        BYTE TimeData[7];
        ZeroMemory(TimeData, sizeof(TimeData));
        TimeData[0] = StrToInt("0x" + FormatDateTime("yy", CurTime).TrimRight());
        TimeData[1] = StrToInt("0x" + FormatDateTime("mm", CurTime).TrimRight());
        TimeData[2] = StrToInt("0x" + FormatDateTime("dd", CurTime).TrimRight());
        TimeData[3] = StrToInt("0x" + AnsiString(ReturnDay(CurTime)).TrimRight());
        TimeData[4] = StrToInt("0x" + FormatDateTime("hh", CurTime).TrimRight());
        TimeData[5] = StrToInt("0x" + FormatDateTime("nn", CurTime).TrimRight());
        TimeData[6] = StrToInt("0x" + FormatDateTime("ss", Now()).TrimRight());
        if(ComPortSet(ComKind, PortUse1, BaudRateUse1, Disable, Disable, IPAddress, IPPort, false))
        {
            Connect = ModuleData(ComKind, Controler1, TimeData, sizeof(TimeData), 0, CT, bMsg);
            if(Connect)
                AddLog(LangFile.Message06 + " [OK]" + asLogMessage, clBlack);
            else
                AddLog(LangFile.Message06 + " [FAIL]" + asLogMessage, clRed);
            ComClose(ComKind);
        }
        return Connect;
}
//---------------------------------------------------------------------------

int __fastcall TFormMain::ReturnDay(TDateTime Time)
{
        //    Լ
        int iDay = DayOfWeek(Time);
        switch(iDay)
        {
            case 1:
                iDay = 7;
                break;
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
            case 7:
                iDay -= 1;
                break;
            default:
                iDay = 1;
                break;
        }
        return iDay;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ComPort1RxChar(TObject *Sender, int Count)
{
        // ø   ޴ ̺Ʈ
        int Size = Count;
        char *Buffer = new char[Size];
        ZeroMemory(Buffer, Size);
        ComPort1->Read(Buffer, Size);
        ReadParsing(0, 0, Buffer, Size);
        if(Buffer)
        {
            delete [] Buffer;
            Buffer = NULL;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::IdIcmpClient1Reply(TComponent *ASender,
      const TReplyStatus &AReplyStatus)
{
        // DDNS  IP ޴ ̺Ʈ
        DNSAddress = AReplyStatus.FromIpAddress;
        DNSConnect = true;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ClientSocket1Connect(TObject *Sender,
      TCustomWinSocket *Socket)
{
        // TCP/IP  ̺Ʈ
        DNSConnect = true;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ClientSocket1Disconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
        // TCP/IP ݴ ̺Ʈ
        bDisConnect = true;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ClientSocket1Error(TObject *Sender,
      TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
        // TCP/IP  ̺Ʈ
        ErrorCode = 0;
        switch (ErrorEvent)
        {
            case eeGeneral, eeSend, eeReceive, eeConnect, eeDisconnect, eeAccept, eeLookup:
                bDisConnect = true;
            break;
        }
        ClientSocket1->Socket->Disconnect(ClientSocket1->Socket->SocketHandle);
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ClientSocket1Read(TObject *Sender,
      TCustomWinSocket *Socket)
{
        // TCP/IP  ޴ ̺Ʈ
        int Size = Socket->ReceiveLength();
        char *Buffer = new char[Size];
        ZeroMemory(Buffer, Size);
        Socket->ReceiveBuf(Buffer, Size);
        ReadParsing(1, 0, Buffer, Size);
        if(Buffer)
        {
            delete [] Buffer;
            Buffer = NULL;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::IdUDPClientStatus(TObject *ASender,
      const TIdStatus AStatus, const AnsiString AStatusText)
{
        // UDP Ŭ̾Ʈ   ̺Ʈ
        if(AStatus == hsConnected)
            DNSConnect = true;
        else if(AStatus == hsDisconnected)
            bDisConnect = true;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::IdUDPServerStatus(TObject *ASender,
      const TIdStatus AStatus, const AnsiString AStatusText)
{
        // UDP    ̺Ʈ
        if(AStatus == hsConnected)
            DNSConnect = true;
        else if(AStatus == hsDisconnected)
            bDisConnect = true;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::IdUDPServerUDPRead(TObject *Sender,
      TStream *AData, TIdSocketHandle *ABinding)
{
        // UDP  ޴ ̺Ʈ
        if(!ABinding->HandleAllocated)
            return;
        if(!AData->Size && AData->Size > 2048)
            return;
        int Size = AData->Size;
        char *Buffer = new char[Size];
        ZeroMemory(Buffer, Size);
        AData->ReadBuffer(Buffer, Size);
        ReadParsing(2, 0, Buffer, Size);
        if(Buffer)
        {
            delete [] Buffer;
            Buffer = NULL;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ReadParsing(BYTE ComKind, char Add, BYTE *ParsingData, int ParsingSize)
{
        //   Ľ Լ
        BYTE ch;
        for(int i = 0; i < ParsingSize; i++)
        {
            ch = ParsingData[i];
            switch(RP.CS)
            {
                case SynSDLEHead :
                {
                    if(ch == DLE)
                        RP.CS = SynSTXHead;
                    else if(ch == 'D')
                    {
                        RP.Data[RP.Rcnt++] = ch;
                        RP.CS = SynBlock;
                    }
                    else
                        ZeroMemory(&RP, sizeof(RP));
                    break;
                }
                case SynSTXHead :
                {
                    if(ch == STX)
                        RP.CS = SynAddress;
                    else
                        ZeroMemory(&RP, sizeof(RP));
                    break;
                }
                case SynAddress :
                {
                    RP.CS = SynHLen;
                    RP.Add = ch;
                    break;
                }
                case SynSendID :
                {
                    RP.SendID = ch;
                    RP.CS = SynOPCode;
                    break;
                }
                case SynHLen :
                {
                    RP.HLen = ch;
                    RP.CS = SynLLen;
                    break;
                }
                case SynLLen :
                {
                    RP.LLen = ch;      
                    RP.CS = SynOPCode; 
                    break;             
                }
                case SynOPCode :       
                {
                    if(ch == PC || ch == CT || ch == RCT  || ch == BS || ch == FMMC || ch == EDI || ch == FMI ||
                        ch == SO || ch == FED || ch == FND)
                    {
                        RP.OPCode = ch;
                        RP.CS = SynDataField;
                    }
                    else
                        ZeroMemory(&RP, sizeof(RP));
                    break;
                }
                case SynDataField :
                {
                    int dl = 0;
                    int rdl = 0;
                    bool btempBCC = false;
                    //btempBCC = bFlagCrcPacket;
                    if(ComKind == 0)
                        btempBCC = true;
                    else
                        btempBCC = false;
                    rdl = 256 * 256;
                    union{
                        BYTE cbSize;
                        struct{
                            unsigned bit0 : 5;
                            unsigned bit1 : 1;
                            unsigned bit2 : 1;
                            unsigned bit3 : 1;
                        }Bit;
                    }uSize;
                    uSize.cbSize = RP.HLen;
                    dl = (int)uSize.Bit.bit0 * 256 + (int)RP.LLen;
                    if(btempBCC)
                        rdl = dl - 1 - sizeof(RP.Bcc);
                    else
                        rdl = dl - 1;
                    ch = ParsingData[i];
                    RP.Data[RP.Rcnt++] = ch;
                    if(RP.Rcnt >= rdl)
                    {
                        RP.Status = RP.Data[0];
                        if(RP.Status == ACK)
                            Status = "ACK";
                        else if(RP.Status == NAK)
                            Status = "NAK";
                        else
                            Status = "ACK?";
                        //RP.Rcnt = 0;
                        if(btempBCC)
                            RP.CS = SynBcc;
                        else
                            RP.CS = SynEDLEHead;
                    }
                    break;
                }
                case SynBcc :
                {
                    RP.Bcc[RP.BCCcnt++] = ch;
                    if(RP.BCCcnt >= sizeof(RP.Bcc))
                    {
                        union{
                            unsigned int uiData;
                            char cData[2];
                        }uData;
                        union{
                            BYTE cbSize;
                            struct{
                                unsigned bit0 : 5;
                                unsigned bit1 : 1;
                                unsigned bit2 : 1;
                                unsigned bit3 : 1;
                            }Bit;
                        }uSize;
                        int dl = 0;
                        uSize.cbSize = RP.HLen;
                        dl = (int)uSize.Bit.bit0 * 256 + (int)RP.LLen - 2;
                        BYTE tempBCC[2];
                        ZeroMemory(tempBCC, sizeof(tempBCC));
                        BYTE *CRCData = new BYTE[dl + 3];
                        ZeroMemory(CRCData, dl + 3);
                        try{
                            CRCData[0] = RP.Add;
                            CRCData[1] = RP.HLen;
                            CRCData[2] = RP.LLen;
                            CRCData[3] = RP.OPCode;
                            memcpy(&CRCData[4], RP.Data, dl - 1);
                            uData.uiData = Calc_crc(CRCData, dl + 3);
                            memcpy(&tempBCC, uData.cData, sizeof(tempBCC));
                        }catch(...){
                        }
                        if(RP.Bcc[0] != tempBCC[0] || RP.Bcc[1] != tempBCC[1])
                            bCRCFail = true;
                        else
                            bCRCFail = false;
                        if(CRCData)
                        {
                            delete [] CRCData;
                            CRCData = NULL;
                        }
                        RP.CS = SynEDLEHead;
                    }
                    break;
                }
                case SynEDLEHead :
                {
                    if(ch == DLE)
                        RP.CS = SynETXHead;
                    else
                        ZeroMemory(&RP, sizeof(RP));
                    break;
                }
                case SynETXHead :
                {
                    int dl = 0;
                    bool btempBCC = false;
                    //btempBCC = bFlagCrcPacket;
                    if(ComKind == 0)
                        btempBCC = true;
                    if(ch == ETX)
                    {
                        union{
                            BYTE cbSize;
                            struct{
                                unsigned bit0 : 5;
                                unsigned bit1 : 1;
                                unsigned bit2 : 1;
                                unsigned bit3 : 1;
                            }Bit;
                        }uSize;
                        uSize.cbSize = RP.HLen;
                        dl = (int)uSize.Bit.bit0 * 256 + (int)RP.LLen;
                        if(btempBCC)
                            dl -= 2;
                        switch(RP.OPCode)
                        {
                            case PC :
                            case CT :
                            case BS :
                            case FMMC :
                            case EDI :
                            case FMI :
                            case SO :
                            case FED :
                            case FND :
                            {
                                SchBmpFile = true;
                            }
                            break;
                            case RCT :
                            {
                                SchBmpFile = true;
                                union{
                                    BYTE cbSize;
                                    struct{
                                        unsigned bit0 : 4;
                                        unsigned bit1 : 4;
                                    }Bit;
                                }uSize;
                                AnsiString asDIBDTime = "";
                                char cNum = 0x00;
                                uSize.cbSize = RP.Data[0];
                                cNum = uSize.Bit.bit1 + 0x30;
                                asDIBDTime += cNum;
                                cNum = uSize.Bit.bit0 + 0x30;
                                asDIBDTime = asDIBDTime + cNum + "-";
                                uSize.cbSize = RP.Data[1];
                                cNum = uSize.Bit.bit1 + 0x30;
                                asDIBDTime += cNum;
                                cNum = uSize.Bit.bit0 + 0x30;
                                asDIBDTime = asDIBDTime + cNum + "-";
                                uSize.cbSize = RP.Data[2];
                                cNum = uSize.Bit.bit1 + 0x30;
                                asDIBDTime += cNum;
                                cNum = uSize.Bit.bit0 + 0x30;
                                asDIBDTime = asDIBDTime + cNum + " (" + GetDay((int)RP.Data[3]) + ") ";
                                uSize.cbSize = RP.Data[4];
                                cNum = uSize.Bit.bit1 + 0x30;
                                asDIBDTime += cNum;
                                cNum = uSize.Bit.bit0 + 0x30;
                                asDIBDTime = asDIBDTime + cNum + ":";
                                uSize.cbSize = RP.Data[5];
                                cNum = uSize.Bit.bit1 + 0x30;
                                asDIBDTime += cNum;
                                cNum = uSize.Bit.bit0 + 0x30;
                                asDIBDTime = asDIBDTime + cNum + ":";
                                uSize.cbSize = RP.Data[6];
                                cNum = uSize.Bit.bit1 + 0x30;
                                asDIBDTime += cNum;
                                cNum = uSize.Bit.bit0 + 0x30;
                                asDIBDTime += cNum;
                                Label25->Caption = asDIBDTime;
                                break;
                            }
                        }
                        BYTE bTempData[1];
                        bTempData[0] = 0x00;
                        asLogMessage = asLogMessage + "\r\n                \t Receive : 10 02 " + Byte2HexConvert(RP.Add) + " " + Byte2HexConvert(RP.HLen) + " "
                             + Byte2HexConvert(RP.LLen) + " " + Byte2HexConvert(RP.OPCode) + " ";
                        if(dl - 1 < 25)
                        {
                            for(int j = 0; j < dl - 1; j++)
                                asLogMessage = asLogMessage + Byte2HexConvert(RP.Data[j]) + " ";
                        }
                        else
                        {
                            for(int i = 0; i < 21; i++)
                                asLogMessage = asLogMessage + Byte2HexConvert(RP.Data[i]) + " ";
                            asLogMessage = asLogMessage + "~ ";
                            if(btempBCC)
                            {
                                for(int i = dl - 1 - 4; i < dl - 1 - 2; i++)
                                    asLogMessage = asLogMessage + Byte2HexConvert(RP.Data[i]) + " ";
                                for(int j = 0; j < sizeof(RP.Bcc); j++)
                                    asLogMessage = asLogMessage + Byte2HexConvert(RP.Bcc[j]) + " ";
                            }
                            else
                            {
                                for(int i = dl - 1 - 2; i < dl - 1; i++)
                                    asLogMessage = asLogMessage + Byte2HexConvert(RP.Data[i]) + " ";
                            }
                        }
                        asLogMessage += "10 03 ";
                        AddLog(asLogMessage, clBlack);
                    }
                    ZeroMemory(&RP, sizeof(RP));
                    break;
                }
            }
        }
}
//---------------------------------------------------------------------------

AnsiString __fastcall TFormMain::GetDay(int iDay)
{
         //   String  Լ
        AnsiString asDay = "";
        switch(iDay)
        {
            case 1:
                asDay = LangFile.FormProtocolDateItem1;
                break;
            case 2:
                asDay = LangFile.FormProtocolDateItem2;
                break;
            case 3:
                asDay = LangFile.FormProtocolDateItem3;
                break;
            case 4:
                asDay = LangFile.FormProtocolDateItem4;
                break;
            case 5:
                asDay = LangFile.FormProtocolDateItem5;
                break;
            case 6:
                asDay = LangFile.FormProtocolDateItem6;
                break;
            case 0:
            case 7:
                asDay = LangFile.FormProtocolDateItem7;
                break;
            default:
                asDay = LangFile.FormProtocolDateItem1;
                break;
        }
        return asDay;
}
//---------------------------------------------------------------------------
                                           
AnsiString __fastcall TFormMain::GetDNS()
{
        // PC DNS о Լ
        AnsiString result;
        FIXED_INFO * FixedInfo;
        ULONG    ulOutBufLen;
        DWORD    dwRetVal = 0;
        IP_ADDR_STRING * pIPAddr;
        FixedInfo = (FIXED_INFO *) GlobalAlloc( GPTR, sizeof( FIXED_INFO ) );
        ulOutBufLen = sizeof( FIXED_INFO );
        if( ERROR_BUFFER_OVERFLOW == GetNetworkParams( FixedInfo, &ulOutBufLen ) )
        {
            GlobalFree( FixedInfo );
            FixedInfo = (FIXED_INFO*)GlobalAlloc( GPTR, ulOutBufLen );
        }
        dwRetVal = GetNetworkParams( FixedInfo, &ulOutBufLen );
        if(dwRetVal)
        {
    //        ShowMessage("Error : ");
        }
        else
            result = FixedInfo->DnsServerList.IpAddress.String;
        //.........
        if(FixedInfo)
            GlobalFree( FixedInfo );
        return result;
}
//---------------------------------------------------------------------------

bool __fastcall TFormMain::ComPortSet(BYTE ComKind, AnsiString PortUse, BYTE BaudRateUse, BYTE DTR, BYTE RTS, AnsiString IPAddress, int IPPort, bool bMessage)
{
        //   Լ
        AnsiString asMessage = "";
        if(ComPort1->Connected || ClientSocket1->Socket->Connected || IdUDPServer->Active)
            ComClose(ComKind);
        bool bDDNS = false;
        if(ComKind == 1)
        {
            bool tempMsg = false;
            try{
                int tempIP = StrToIntDef(IPAddress.SubString(1, IPAddress.Pos(".") - 1), -1);
                if(tempIP < 0)
                    bDDNS = true;
                if(bDDNS)
                {
                    try{
                        SchBmpFile = false;
                        DNSAddress = "";
                        IdIcmpClient1->Host = IPAddress;
                        IdIcmpClient1->ReceiveTimeout = 1000;
                        DNSConnect = false;
                        IdIcmpClient1->Ping();
                        LANDelayCount(3000);
                        if(DNSAddress == "" || DNSAddress == " ")
                        {
                            IdDNSResolver->QueryRecords = IdDNSResolver->QueryRecords<<qtA;
                            IdDNSResolver->Host = GetDNS();
                            IdDNSResolver->Active = true;
                            IdDNSResolver->Resolve(IPAddress);
                            IdDNSResolver->Active = false;
                            for(int i = 0; i < IdDNSResolver->QueryResult->Count; i++)
                            {
                                switch(IdDNSResolver->QueryResult->Items[i]->RecType)
                                {
                                    case qtA:
                                    {
                                        DNSAddress = dynamic_cast<TARecord *>(IdDNSResolver->QueryResult->Items[i])->IPAddress;
                                        DNSConnect = true;
                                    }
                                    break;
                                }
                                if(DNSConnect)
                                    break;
                            }
                        }
                    }catch(...){
                        tempMsg = true;
                        try{
                            if(DNSAddress == "" || DNSAddress == " ")
                            {
                                IdDNSResolver->QueryRecords = IdDNSResolver->QueryRecords<<qtA;
                                IdDNSResolver->Host = GetDNS();
                                IdDNSResolver->Active = true;
                                IdDNSResolver->Resolve(IPAddress);
                                IdDNSResolver->Active = false;
                                for(int i = 0; i < IdDNSResolver->QueryResult->Count; i++)
                                {
                                    switch(IdDNSResolver->QueryResult->Items[i]->RecType)
                                    {
                                        case qtA:
                                        {
                                            DNSAddress = dynamic_cast<TARecord *>(IdDNSResolver->QueryResult->Items[i])->IPAddress;
                                            DNSConnect = true;
                                        }
                                        break;
                                    }
                                    if(DNSConnect)
                                        break;
                                }
                                tempMsg = false;
                            }
                        }catch(...){
                            asMessage = "IP:" + ClientSocket1->Address + ", PORT:" + IntToStr(ClientSocket1->Port) + " Open [FAIL]";
                            AddLog(asMessage, clRed);
                            if(bMessage)
                                Message("\r\n" + asMessage + "\r\n", LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
                            DNSConnect = false;
                            DNSAddress = "";
                            return false;
                        }
                        asMessage = "IP:" + ClientSocket1->Address + ", PORT:" + IntToStr(ClientSocket1->Port) + " Open [FAIL]";
                        AddLog(asMessage, clRed);
                        if(tempMsg && bMessage)
                            Message("\r\n" + asMessage + "\r\n", LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
                        DNSConnect = false;
                        DNSAddress = "";
                        return false;
                    }
                    if(DNSConnect)
                    {
                        ClientSocket1->Address = DNSAddress;
                        ClientSocket1->Port = IPPort;
                        DNSConnect = false;
                    }
                    else
                    {
                        ClientSocket1->Address = "127.0.0.1";
                        ClientSocket1->Port = IPPort;
                    }
                }
                else
                {
                    ClientSocket1->Address = IPAddress;
                    ClientSocket1->Port = IPPort;
                }
            }catch(...){
                asMessage = "IP:" + ClientSocket1->Address + ", PORT:" + IntToStr(ClientSocket1->Port) + " Open [FAIL]";
                AddLog(asMessage, clRed);
                Message("\r\n" + asMessage + "\r\n", LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
                return false;
            }
            try{
                DNSConnect = false;
                ClientSocket1->Open();
                LANDelayCount(ServerCommOpenDelay);
                if(!DNSConnect)
                {
                    asMessage = "IP:" + ClientSocket1->Address + ", PORT:" + IntToStr(ClientSocket1->Port) + " Open [FAIL]";
                    AddLog(asMessage, clRed);
                    if(bMessage)
                        Message("\r\n" + asMessage + "\r\n", LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
                    return false;
                }
                else
                {
                    asMessage = "IP:" + ClientSocket1->Address + ", PORT:" + IntToStr(ClientSocket1->Port) + " Open [OK]";
                    AddLog(asMessage, clBlack);
                    DNSConnect = false;
                }
            }catch(...){
                asMessage = "IP:" + ClientSocket1->Address + ", PORT:" + IntToStr(ClientSocket1->Port) + " Open [FAIL]";
                AddLog(asMessage, clRed);
                if(bMessage)
                    Message("\r\n" + asMessage + "\r\n", LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
                return false;
            }
        }
        else if(ComKind == 2)
        {
            bool tempMsg = false;
            try{
                bDDNS = false;
                int tempIP = StrToIntDef(UDPIPAddress.SubString(1, UDPIPAddress.Pos(".") - 1), -1);
                if(tempIP < 0)
                    bDDNS = true;
                if(bDDNS)
                {
                    try{
                        SchBmpFile = false;
                        DNSAddress = "";
                        IdIcmpClient1->Host = IPAddress;
                        IdIcmpClient1->ReceiveTimeout = 1000;
                        DNSConnect = false;
                        IdIcmpClient1->Ping();
                        LANDelayCount(3000);
                        if(DNSAddress == "" || DNSAddress == " ")
                        {
                            IdDNSResolver->QueryRecords = IdDNSResolver->QueryRecords<<qtA;
                            IdDNSResolver->Host = GetDNS();
                            IdDNSResolver->Active = true;
                            IdDNSResolver->Resolve(IPAddress);
                            IdDNSResolver->Active = false;
                            for(int i = 0; i < IdDNSResolver->QueryResult->Count; i++)
                            {
                                switch(IdDNSResolver->QueryResult->Items[i]->RecType)
                                {
                                    case qtA:
                                    {
                                        DNSAddress = dynamic_cast<TARecord *>(IdDNSResolver->QueryResult->Items[i])->IPAddress;
                                        DNSConnect = true;
                                    }
                                    break;
                                }
                                if(DNSConnect)
                                    break;
                            }
                        }
                    }catch(...){
                        tempMsg = true;
                        try{
                            if(DNSAddress == "" || DNSAddress == " ")
                            {
                                IdDNSResolver->QueryRecords = IdDNSResolver->QueryRecords<<qtA;
                                IdDNSResolver->Host = GetDNS();
                                IdDNSResolver->Active = true;
                                IdDNSResolver->Resolve(IPAddress);
                                IdDNSResolver->Active = false;
                                for(int i = 0; i < IdDNSResolver->QueryResult->Count; i++)
                                {
                                    switch(IdDNSResolver->QueryResult->Items[i]->RecType)
                                    {
                                        case qtA:
                                        {
                                            DNSAddress = dynamic_cast<TARecord *>(IdDNSResolver->QueryResult->Items[i])->IPAddress;
                                            DNSConnect = true;
                                        }
                                        break;
                                    }
                                    if(DNSConnect)
                                        break;
                                }
                                tempMsg = false;
                            }
                        }catch(...){
                            AddLog("IP:" + DNSAddress + ", PORT:" + SRCPort + " Open [FAIL]", clRed);
                            if(bMessage)
                                Message("\r\n" + LangFile.Message05 + "\r\n", LangFile.MessageButton04, "", "", LangFile.Message05.Length() - 2, 3, 1, clBlack);
                            DNSConnect = false;
                            DNSAddress = "";
                            return false;
                        }
                        AddLog("IP:" + DNSAddress + ", PORT:" + SRCPort + " Open [FAIL]", clRed);
                        if(bMessage)
                            Message("\r\n" + LangFile.Message05 + "\r\n", LangFile.MessageButton04, "", "", LangFile.Message05.Length() - 2, 3, 1, clBlack);
                        if(tempMsg)
                        {
                            DNSConnect = false;
                            DNSAddress = "";
                            return false;
                        }
                    }
                    if(DNSConnect)
                    {
                        DNSConnect = false;
                        asUDPIPAddress = DNSAddress;
                    }
                    else
                        asUDPIPAddress = "127.0.0.1";
                }
                else
                    asUDPIPAddress = UDPIPAddress;
            }catch(...){
                AddLog("UDP IP:" + asUDPIPAddress + ", PORT:" + SRCPort + " UDP Open [FAIL]", clRed);
                if(bMessage)
                    Message("\r\n" + LangFile.Message05 + "\r\n", LangFile.MessageButton04, "", "", LangFile.Message05.Length() - 2, 3, 1, clRed);
                return false;
            }
            SchBmpFile = false;
            DNSConnect = false;
            try{
                if(!SH)
                    SH = IdUDPServer->Bindings->Add();
                SH->Port = SRCPort;
                IdUDPServer->Active = true;
                if(bMessage)
                    AddLog("UDP IP:" + asUDPIPAddress + ", PORT:" + IntToStr(SH->Port) + " UDP Open [OK]", clBlack);
            }catch(...){
            }
        }
        else
        {
            ComPort1->Port = PortUse;
            AnsiString asBR = "";
            switch(BaudRateUse)
            {
                case 0 :
                    ComPort1->BaudRate = br2400;
                    asBR = ": 2,400bps";
                    break;
                case 1 :
                    ComPort1->BaudRate = br4800;
                    asBR = ": 4,800bps";
                    break;
                case 2 :
                    ComPort1->BaudRate = br9600;
                    asBR = ": 9,600bps";
                    break;
                case 3 :
                    ComPort1->BaudRate = br19200;
                    asBR = ": 19,200bps";
                    break;
                case 4 :
                    ComPort1->BaudRate = br38400;
                    asBR = ": 38,400bps";
                    break;
                case 5 :
                    ComPort1->BaudRate = br57600;
                    asBR = ": 57,600bps";
                    break;
                case 6 :
                    ComPort1->BaudRate = br115200;
                    asBR = ": 115,200bps";
                    break;
                default :
                    ComPort1->BaudRate = br115200;
                    asBR = ": 115,200bps";
                    break;
            }
            if(!ComPort1->Connected)
            {
                try{
                    ComPort1->Open();
                    asMessage = ComPort1->Port + " " + asBR + ", 8, 1, N - ComPort Open [OK]";
                    if(bMessage)
                        AddLog(asMessage, clBlack);
                }catch(...){
                    asMessage = ComPort1->Port + " " + asBR + ", 8, 1, N - ComPort Open [FAIL]";
                    AddLog(asMessage, clRed);
                    if(bMessage)
                        Message("\r\n" + asMessage + "\r\n", LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
                    return false;
                }
            }
        }
        return true;
}
//---------------------------------------------------------------------------

bool __fastcall TFormMain::ComClose(BYTE ComKind)
{
        //  ݴ Լ
        if(DelayRun == 1 && DelayTime == 0)
            NoneDelayCount(300);
        AnsiString asMessage = "";
        if(ComKind == 1)
        {
            try{
                ClientSocket1->Close();
                asMessage = "IP:" + ClientSocket1->Address + ", PORT:" + IntToStr(ClientSocket1->Port) + " Close [OK]";
                AddLog(asMessage, clBlack);
            }catch(...){
                asMessage = "IP:" + ClientSocket1->Address + ", PORT:" + IntToStr(ClientSocket1->Port) + " Close [FAIL]";
                AddLog(asMessage, clRed);
                Message("\r\n" + asMessage + "\r\n", FormMain->LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
                return false;
            }
        }
        else if(ComKind == 2)
        {
            try{
                IdUDPServer->Active = false;
                if(SH)
                    AddLog("UDP IP:" + asUDPIPAddress + ", PORT:" + IntToStr(SH->Port)+ " UDP Close : [OK]", clBlack);
            }catch(...){
                asMessage = "UDP IP:" + asUDPIPAddress + ", PORT:" + IntToStr(SH->Port)+ " UDP Close : [FAIL]";
                if(SH)
                    AddLog(asMessage, clRed);
                Message("\r\n" + asMessage + "\r\n", FormMain->LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
                return false;
            }
        }
        else
        {
            try{
                ComPort1->Close();
                asMessage = ComPort1->Port + " Close [OK]";
                AddLog(asMessage, clBlack);
            }catch(...){
                asMessage = ComPort1->Port + " Close [FAIL]";
                AddLog(asMessage, clRed);
                Message("\r\n" + asMessage + "\r\n", FormMain->LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
                return false;
            }
        }
        return true;
}
//---------------------------------------------------------------------------
                        
void __fastcall TFormMain::BitBtnSyncLEDClick(TObject *Sender)
{
        // ð  ư
        ButtonEnabled(false);
        bMsg = true;
        CurrenTimeSync();
        ButtonEnabled(true);
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BDIBDTimeClick(TObject *Sender)
{
        //  ð ޾ƿ ư
        BYTE SendData[1];
        ZeroMemory(SendData, sizeof(SendData));
        ButtonEnabled(false);
        if(ComPortSet(ComKind, PortUse1, BaudRateUse1, Disable, Disable, IPAddress, IPPort, false))
        {
            if(ModuleData(ComKind, Controler1, SendData, sizeof(SendData), 0, RCT, bMsg))
                AddLog(LangFile.BtnSignalSend + " [OK]" + asLogMessage, clBlack);
            else
                AddLog(LangFile.BtnSignalSend + " [FAIL]" + asLogMessage, clRed);
            ComClose(ComKind);
        }
        ModuleHeight = UpDownHeight->Position;
        ModuleWidth = UpDownWidth->Position;
        ButtonEnabled(true);
}
//---------------------------------------------------------------------------

int __fastcall TFormMain::FindItemIndex(AnsiString Data, int Col)
{
        // ȿ, ε  Լ
        switch (Col)
        {
            case 1:
                return -1;
            case 2:
            {
                for(int i = 0; i < EffectTypeCount; i++)
                    if(!Data.AnsiCompare(AnsiString(EffectType[i])))
                        return i;
            }
            break;
            case 3:
            {
                for(int i = 0; i < DirTypeCount; i++)
                    if(!Data.AnsiCompare(AnsiString(DirType[i])))
                        return i;
            }
            break;
            case 4:
                return -1;
            case 5:
                return -1;
            case 6:
                return -1;
        }
        return -1;
}
//---------------------------------------------------------------------------

BYTE __fastcall TFormMain::InputSchEffect(TGEffectType eEff, TGEffectDirection dDirect)
{
        //  ȿ  Լ
        BYTE ResultEffect = 0x00;
        switch(eEff)
        {
            case etNormal:
            {
                switch(dDirect)
                {
                    case edBrightUp:
                        ResultEffect = BrightUp;
                    break;
                    case edBrightDown:
                        ResultEffect = BrightDown;
                    break;
                    case edHoriMirror:
                        ResultEffect = HoriMirror;
                    break;
                    case edVertMirror:
                        ResultEffect = VertMirror;
                    break;
                    default:
                        ResultEffect = None;
                    break;
                }
            }
            break;
            case etRandom:
            {
                switch(dDirect)
                {
                    case edOrder:
                        ResultEffect = (Effect)Order;
                    break;
                    default:
                        ResultEffect = (Effect)Random;
                    break;
                }
            }
            break;
            case etShift:
            {
                switch(dDirect)
                {
                    case edRight:
                        ResultEffect = ShiftRight;
                    break;
                    case edUp:
                        ResultEffect = ShiftUp;
                    break;
                    case edDown:
                        ResultEffect = ShiftDown;
                    break;
                    case edLeftAdd:
                        ResultEffect = ShiftLeftAdd;
                    break;
                    case edUpDown:
                        ResultEffect = ShiftUpDown;
                    break;
                    default:
                        ResultEffect = ShiftLeft;
                    break;
                }
            }
            break;
            case et3DShift:
            {
                switch(dDirect)
                {
                    case edRight:
                        ResultEffect = Shift3DRight;
                    break;
                    case edUp:
                        ResultEffect = Shift3DUp;
                    break;
                    case edDown:
                        ResultEffect = Shift3DDown;
                    break;
                    default:
                        ResultEffect = Shift3DLeft;
                    break;
                }
            }
            break;
            case etWipe:
            {
                switch(dDirect)
                {
                    case edRight:
                        ResultEffect = WipeRight;
                    break;
                    case edUp:
                        ResultEffect = WipeUp;
                    break;
                    case edDown:
                        ResultEffect = WipeDown;
                    break;
                    case edLeftUp:
                        ResultEffect = WipeLeftUp;
                    break;
                    case edRightDown:
                        ResultEffect = WipeRightDown;
                    break;
                    default:
                        ResultEffect = WipeLeft;
                    break;
                }
            }
            break;
            case etBlind:
            {
                switch(dDirect)
                {
                    case edRight:
                        ResultEffect = BlindRight;
                    break;
                    case edUp:
                        ResultEffect = BlindUp;
                    break;
                    case edDown:
                        ResultEffect = BlindDown;
                    break;
                    case edLeftUp:
                        ResultEffect = BlindLeftUp;
                    break;
                    case edRightDown:
                        ResultEffect = BlindRightDown;
                    break;
                    default:
                        ResultEffect = BlindLeft;
                    break;
                }
            }
            break;
            case etCurtain:
            {
                switch(dDirect)
                {
                    case edHoriCenter:
                        ResultEffect = CurtainHoriCenter;
                    break;
                    case edVerSide:
                        ResultEffect = CurtainVertSide;
                    break;
                    case edVerCenter:
                        ResultEffect = CurtainVertCenter;
                    break;
                    case edHoriSideCenter:
                        ResultEffect = CurtainHoriSideCenter;
                    break;
                    case edVertSideCenter:
                        ResultEffect = CurtainVertSideCenter;
                    break;
                    default:
                        ResultEffect = CurtainHoriSide;
                    break;
                }
            }
            break;
            case etScaleIn:
            {
                switch(dDirect)
                {
                    case edLeft:
                        ResultEffect = ScaleInLeft;
                    break;
                    case edRight:
                        ResultEffect = ScaleInRight;
                    break;
                    case edUp:
                        ResultEffect = ScaleInUp;
                    break;
                    case edDown:
                        ResultEffect = ScaleInDown;
                    break;
                    default:
                        ResultEffect = ScaleInLeftUp;
                    break;
                }
            }
            break;
            case etScaleOut:
            {
                switch(dDirect)
                {
                    case edLeft:
                        ResultEffect = ScaleOutLeft;
                    break;
                    case edRight:
                        ResultEffect = ScaleOutRight;
                    break;
                    case edUp:
                        ResultEffect = ScaleOutUp;
                    break;
                    case edDown:
                        ResultEffect = ScaleOutDown;
                    break;
                    default:
                        ResultEffect = ScaleOutRightDown;
                    break;
                }
            }
            break;
            case etRotate:
            {
                switch(dDirect)
                {
                    case edReverseClock:
                        ResultEffect = RotateReverseClock;
                    break;
                    case edReverseClock2:
                        ResultEffect = Rotate2ReverseClock;
                    break;
                    case edClock2:
                        ResultEffect = Rotate2Clock;
                    break;
                    default:
                        ResultEffect = RotateClock;
                    break;
                }
            }
            break;
            case etBlink:
            {
                switch(dDirect)
                {
                    case edGreen:
                        ResultEffect = BlinkGreen;
                    break;
                    case edBlue:
                        ResultEffect = BlinkBlue;
                    break;
                    case edWhite:
                        ResultEffect = BlinkWhite;
                    break;
                    case edRGB:
                        ResultEffect = BlinkRGB;
                    break;
                    default:
                        ResultEffect = BlinkRed;
                    break;
                }
            }
            break;
            case etBlinkReverse:
            {
                switch(dDirect)
                {
                    case edGreen:
                        ResultEffect = BlinkReverseGreen;
                    break;
                    case edBlue:
                        ResultEffect = BlinkReverseBlue;
                    break;
                    case edWhite:
                        ResultEffect = BlinkReverseWhite;
                    break;
                    case edRGB:
                        ResultEffect = BlinkReverseRGB;
                    break;
                    default:
                        ResultEffect = BlinkReverseRed;
                    break;
                }
            }
            break;
            case etLineTest:
            {
                switch(dDirect)
                {
                    case edRight:
                        ResultEffect = LineRight;
                    break;
                    case edUp:
                        ResultEffect = LineUp;
                    break;
                    case edDown:
                        ResultEffect = LintDown;
                    break;
                    case edLeftUp:
                        ResultEffect = LineLeftUp;
                    break;
                    case edLeftDown:
                        ResultEffect = LineLeftDown;
                    break;
                    case edRightUp:
                        ResultEffect = LineRightUp;
                    break;
                    case edRightDown:
                        ResultEffect = LineRightDown;
                    break;
                    default:
                        ResultEffect = LineLeft;
                    break;
                }
            }
            break;
            default:
                ResultEffect = 0x00;
            break;
        }
        return ResultEffect;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbEntEffectClick(TObject *Sender)
{
        TGEffectType ED = (TGEffectType)FindItemIndex(cbEntEffect->Text, 2);
        cbEntDirect->Clear();
        cbEntDirect->ItemIndex = -1;
        switch(ED)
        {
            case etNormal:
                cbEntDirect->Items->Add(DirType[edNone]);
            break;
            case etShift:
                cbEntDirect->Items->Add(DirType[edLeft]);
            break;
            case etWipe:
            case et3DShift:
                cbEntDirect->Items->Add(DirType[edLeft]);
            break;
            case etBlind:
                cbEntDirect->Items->Add(DirType[edLeft]);
            break;
            case etCurtain:
                cbEntDirect->Items->Add(DirType[edHoriSide]);
            break;
            case etScaleIn:
                cbEntDirect->Items->Add(DirType[edLeftUp]);
            break;
            case etScaleOut:
                cbEntDirect->Items->Add(DirType[edRightDown]);
            break;
            case etRotate:
                cbEntDirect->Items->Add(DirType[edReverseClock]);
            break;
            case etBlink:
            case etBlinkReverse:
                cbEntDirect->Items->Add(DirType[edRed]);
            break;
            case etLineTest:
                cbEntDirect->Items->Add(DirType[edLeft]);
            break;
            case etRandom:
                cbEntDirect->Items->Add(DirType[edRandom]);
            break;
        }
        cbEntDirect->ItemIndex = 0;
}
//---------------------------------------------------------------------------

BYTE __fastcall TFormMain::SetDelayTime(int DelayTime)
{
        // ̰  Լ
        BYTE bResult = 0x00;
        switch(DelayTime)
        {
            case 0:
            case 2:
            case 4:
            case 8:
            case 10:
            case 15:
            case 20:
            case 30:
            case 40:
            case 60:
            case 90:
                bResult = DelayTime;
            break;
            case 120:
                bResult = 0xf0;
            break;
            case 180:
                bResult = 0xf1;
            break;
            case 300:
                bResult = 0xf2;
            break;
            case 600:
                bResult = 0xf3;
            break;
            case 1800:
                bResult = 0xf4;
            break;
            case 3600:
                bResult = 0xf5;
            break;
            case 10800:
                bResult = 0xf6;
            break;
            case 18000:
                bResult = 0xf7;
            break;
            case 32400:
                bResult = 0xf8;
            break;
            default:
                bResult = DelayTime;
            break;
        }
        if(DelayTime >= 120)
            return bResult / 2;
        else
            return bResult;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbEntEffectDropDown(TObject *Sender)
{
        if(cbEntEffect->Items->IndexOf(cbEntEffect->Text) > -1)
            cbEntEffect->ItemIndex = cbEntEffect->Items->IndexOf(cbEntEffect->Text);
        else
            cbEntEffect->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbEntDirectDropDown(TObject *Sender)
{
        AnsiString asED = cbEntDirect->Text;
        cbEntDirect->Clear();
        if(cbEntEffect->Text == EffectType[etNormal])
        {
            for(int i = edNone; i < 5; i++)
                cbEntDirect->Items->Add(DirType[i]);
        }
        else if(cbEntEffect->Text == EffectType[etShift])
        {
            for(int i = edLeft; i < edLeft + 6; i++)
            {
                if((TGEffectType)i == edLeftUp)
                    continue;
                if((TGEffectType)i == edUpDown)
                    continue;
                cbEntDirect->Items->Add(DirType[i]);
            }
        }
        else if(cbEntEffect->Text == EffectType[etWipe] ||
            cbEntEffect->Text == EffectType[etBlind])
        {
            for(int i = edLeft; i < edLeft + 4; i++)
                cbEntDirect->Items->Add(DirType[i]);
        }
        else if(cbEntEffect->Text == EffectType[etCurtain])
        {
            for(int i = edHoriSide; i < edHoriSide + 4; i++)
                cbEntDirect->Items->Add(DirType[i]);
        }
        else if(cbEntEffect->Text == EffectType[etScaleIn] ||
            cbEntEffect->Text == EffectType[etScaleOut])
        {
            for(int i = edLeft; i < edLeft + 4; i++)
                cbEntDirect->Items->Add(DirType[i]);
            if(cbEntEffect->Text == EffectType[etScaleIn])
                cbEntDirect->Items->Add(DirType[edLeftUp]);
            else
                cbEntDirect->Items->Add(DirType[edRightDown]);
        }
        else if(cbEntEffect->Text == EffectType[etRotate])
        {
            for(int i = edReverseClock; i < edReverseClock + 4; i++)
                cbEntDirect->Items->Add(DirType[i]);
        }
        else if(cbEntEffect->Text == EffectType[etBlink] ||
            cbEntEffect->Text == EffectType[etBlinkReverse])
        {
            for(int i = edRed; i < edRed + 5; i++)
                cbEntDirect->Items->Add(DirType[i]);
        }
        else if(cbEntEffect->Text == EffectType[etLineTest])
        {
            for(int i = edLeft; i < edLeft + 10; i++)
            {
                if((TGEffectType)i == edLeftUp || (TGEffectType)i == edUpDown || (TGEffectType)i == edLeftAdd)
                    continue;
                if((TGEffectType)i == edLeft || (TGEffectType)i == edDown || (TGEffectType)i == edRightDown)
                    cbEntDirect->Items->Add(DirType[i]);
            }
        }
        else if(cbEntEffect->Text == EffectType[etRandom])
        {
            for(int i = edOrder; i < edOrder + 2; i++)
                cbEntDirect->Items->Add(DirType[i]);
        }
        else if(cbEntEffect->Text == EffectType[et3DShift])
            cbEntDirect->Items->Add(DirType[edLeft]);
        if(cbEntDirect->Items->IndexOf(asED) > -1)
            cbEntDirect->ItemIndex = cbEntDirect->Items->IndexOf(asED);
        else
            cbEntDirect->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbLasEffectClick(TObject *Sender)
{
        TGEffectType ED = (TGEffectType)FindItemIndex(cbLasEffect->Text, 2);
        cbLasDirect->Clear();
        cbLasDirect->ItemIndex = -1;
        switch(ED)
        {
            case etNormal:
                cbLasDirect->Items->Add(DirType[edNone]);
            break;
            case etShift:
            case et3DShift:
                cbLasDirect->Items->Add(DirType[edLeft]);
            break;
            case etWipe:
                cbLasDirect->Items->Add(DirType[edLeft]);
            break;
            case etBlind:
                cbLasDirect->Items->Add(DirType[edLeft]);
            break;
            case etCurtain:
                cbLasDirect->Items->Add(DirType[edHoriSide]);
            break;
            case etScaleIn:
                cbLasDirect->Items->Add(DirType[edLeftUp]);
            break;
            case etScaleOut:
                cbLasDirect->Items->Add(DirType[edRightDown]);
            break;
            case etRotate:
                cbLasDirect->Items->Add(DirType[edReverseClock]);
            break;
            case etBlink:
            case etBlinkReverse:
                cbLasDirect->Items->Add(DirType[edRed]);
            break;
            case etLineTest:
                cbLasDirect->Items->Add(DirType[edLeft]);
            break;
            case etRandom:
                cbLasDirect->Items->Add(DirType[edRandom]);
            break;
            default:
                cbLasDirect->Items->Add(LangFile.NoEffect);
            break;
        }
        cbLasDirect->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbLasEffectDropDown(TObject *Sender)
{
        if(cbLasEffect->Items->IndexOf(cbLasEffect->Text) > -1)
            cbLasEffect->ItemIndex = cbLasEffect->Items->IndexOf(cbLasEffect->Text);
        else
            cbLasEffect->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbLasDirectDropDown(TObject *Sender)
{
        AnsiString asED = cbLasDirect->Text;
        cbLasDirect->Clear();
        if(cbLasEffect->Text == EffectType[etNormal])
        {
            for(int i = edNone; i < 5; i++)
                cbLasDirect->Items->Add(DirType[i]);
        }
        else if(cbLasEffect->Text == EffectType[etShift])
        {
            for(int i = edLeft; i < edLeft + 6; i++)
            {
                if((TGEffectType)i == edLeftUp)
                    continue;
                if((TGEffectType)i == edUpDown)
                    continue;
                cbLasDirect->Items->Add(DirType[i]);
            }
        }
        else if(cbLasEffect->Text == EffectType[etWipe] ||
            cbLasEffect->Text == EffectType[etBlind])
        {
            for(int i = edLeft; i < edLeft + 4; i++)
                cbLasDirect->Items->Add(DirType[i]);
        }
        else if(cbLasEffect->Text == EffectType[etCurtain])
        {
            for(int i = edHoriSide; i < edHoriSide + 4; i++)
                cbLasDirect->Items->Add(DirType[i]);
        }
        else if(cbLasEffect->Text == EffectType[etScaleIn] ||
            cbLasEffect->Text == EffectType[etScaleOut])
        {
            for(int i = edLeft; i < edLeft + 4; i++)
                cbLasDirect->Items->Add(DirType[i]);
            if(cbLasEffect->Text == EffectType[etScaleIn])
                cbLasDirect->Items->Add(DirType[edLeftUp]);
            else
                cbLasDirect->Items->Add(DirType[edRightDown]);
        }
        else if(cbLasEffect->Text == EffectType[etRotate])
        {
            for(int i = edReverseClock; i < edReverseClock + 4; i++)
                cbLasDirect->Items->Add(DirType[i]);
        }
        else if(cbLasEffect->Text == EffectType[etBlink] ||
            cbLasEffect->Text == EffectType[etBlinkReverse])
        {
            for(int i = edRed; i < edRed + 5; i++)
                cbLasDirect->Items->Add(DirType[i]);
        }
        else if(cbLasEffect->Text == EffectType[etLineTest])
        {
            for(int i = edLeft; i < edLeft + 10; i++)
            {
                if((TGEffectType)i == edLeftUp || (TGEffectType)i == edUpDown || (TGEffectType)i == edLeftAdd)
                    continue;
                if((TGEffectType)i == edLeft || (TGEffectType)i == edDown || (TGEffectType)i == edRightDown)
                    cbLasDirect->Items->Add(DirType[i]);
            }
        }
        else if(cbLasEffect->Text == EffectType[etRandom])
        {
            for(int i = edOrder; i < edOrder + 2; i++)
                cbLasDirect->Items->Add(DirType[i]);
        }
        else if(cbLasEffect->Text == EffectType[et3DShift])
            cbLasDirect->Items->Add(DirType[edLeft]);
        else
            cbLasDirect->Items->Add(LangFile.NoEffect);
        if(cbLasDirect->Items->IndexOf(asED) > -1)
            cbLasDirect->ItemIndex = cbLasDirect->Items->IndexOf(asED);
        else
            cbLasDirect->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbEntEffect2Click(TObject *Sender)
{
        TGEffectType ED = (TGEffectType)FindItemIndex(cbEntEffect2->Text, 2);
        cbEntDirect2->Clear();
        cbEntDirect2->ItemIndex = -1;
        switch(ED)
        {
            case etNormal:
                cbEntDirect2->Items->Add(DirType[edNone]);
            break;
            case etShift:
                cbEntDirect2->Items->Add(DirType[edLeft]);
            break;
            case etWipe:
            case et3DShift:
                cbEntDirect2->Items->Add(DirType[edLeft]);
            break;
            case etBlind:
                cbEntDirect2->Items->Add(DirType[edLeft]);
            break;
            case etCurtain:
                cbEntDirect2->Items->Add(DirType[edHoriSide]);
            break;
            case etScaleIn:
                cbEntDirect2->Items->Add(DirType[edLeftUp]);
            break;
            case etScaleOut:
                cbEntDirect2->Items->Add(DirType[edRightDown]);
            break;
            case etRotate:
            //case etRotate2:
                cbEntDirect2->Items->Add(DirType[edReverseClock]);
            break;
            case etBlink:
            case etBlinkReverse:
                cbEntDirect2->Items->Add(DirType[edRed]);
            break;
            case etLineTest:
                cbEntDirect2->Items->Add(DirType[edLeft]);
            break;
            case etRandom:
                cbEntDirect2->Items->Add(DirType[edRandom]);
            break;
        }
        cbEntDirect2->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbEntEffect2DropDown(TObject *Sender)
{
        if(cbEntEffect2->Items->IndexOf(cbEntEffect2->Text) > -1)
            cbEntEffect2->ItemIndex = cbEntEffect2->Items->IndexOf(cbEntEffect2->Text);
        else
            cbEntEffect2->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbEntDirect2DropDown(TObject *Sender)
{
        AnsiString asED = cbEntDirect2->Text;
        cbEntDirect2->Clear();
        if(cbEntEffect2->Text == EffectType[etNormal])
        {
            for(int i = edNone; i < 5; i++)
                cbEntDirect2->Items->Add(DirType[i]);
        }
        else if(cbEntEffect2->Text == EffectType[etShift])
        {
            for(int i = edLeft; i < edLeft + 6; i++)
            {
                if((TGEffectType)i == edLeftUp)
                    continue;
                if((TGEffectType)i == edUpDown)
                    continue;
                cbEntDirect2->Items->Add(DirType[i]);
            }
        }
        else if(cbEntEffect2->Text == EffectType[etWipe] ||
            cbEntEffect2->Text == EffectType[etBlind])
        {
            for(int i = edLeft; i < edLeft + 4; i++)
                cbEntDirect2->Items->Add(DirType[i]);
        }
        else if(cbEntEffect2->Text == EffectType[etCurtain])
        {
            for(int i = edHoriSide; i < edHoriSide + 4; i++)
                cbEntDirect2->Items->Add(DirType[i]);
        }
        else if(cbEntEffect2->Text == EffectType[etScaleIn] ||
            cbEntEffect2->Text == EffectType[etScaleOut])
        {
            for(int i = edLeft; i < edLeft + 4; i++)
                cbEntDirect2->Items->Add(DirType[i]);
            if(cbEntEffect2->Text == EffectType[etScaleIn])
                cbEntDirect2->Items->Add(DirType[edLeftUp]);
            else
                cbEntDirect2->Items->Add(DirType[edRightDown]);
        }
        else if(cbEntEffect2->Text == EffectType[etRotate])
        {
            for(int i = edReverseClock; i < edReverseClock + 4; i++)
                cbEntDirect2->Items->Add(DirType[i]);
        }
        else if(cbEntEffect2->Text == EffectType[etBlink] ||
            cbEntEffect2->Text == EffectType[etBlinkReverse])
        {
            for(int i = edRed; i < edRed + 5; i++)
                cbEntDirect2->Items->Add(DirType[i]);
        }
        else if(cbEntEffect2->Text == EffectType[etLineTest])
        {
            for(int i = edLeft; i < edLeft + 10; i++)
            {
                if((TGEffectType)i == edLeftUp || (TGEffectType)i == edUpDown || (TGEffectType)i == edLeftAdd)
                    continue;
                if((TGEffectType)i == edLeft || (TGEffectType)i == edDown || (TGEffectType)i == edRightDown)
                    cbEntDirect2->Items->Add(DirType[i]);
            }
        }
        else if(cbEntEffect2->Text == EffectType[etRandom])
        {
            for(int i = edOrder; i < edOrder + 2; i++)
                cbEntDirect2->Items->Add(DirType[i]);
        }
        else if(cbEntEffect2->Text == EffectType[et3DShift])
            cbEntDirect2->Items->Add(DirType[edLeft]);
        if(cbEntDirect2->Items->IndexOf(asED) > -1)
            cbEntDirect2->ItemIndex = cbEntDirect2->Items->IndexOf(asED);
        else
            cbEntDirect2->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbLasEffect2Click(TObject *Sender)
{
        TGEffectType ED = (TGEffectType)FindItemIndex(cbLasEffect2->Text, 2);
        cbLasDirect2->Clear();
        cbLasDirect2->ItemIndex = -1;
        switch(ED)
        {
            case etNormal:
                cbLasDirect2->Items->Add(DirType[edNone]);
            break;
            case etShift:
                cbLasDirect2->Items->Add(DirType[edLeft]);
            break;
            case etWipe:
            case et3DShift:
                cbLasDirect2->Items->Add(DirType[edLeft]);
            break;
            case etBlind:
                cbLasDirect2->Items->Add(DirType[edLeft]);
            break;
            case etCurtain:
                cbLasDirect2->Items->Add(DirType[edHoriSide]);
            break;
            case etScaleIn:
                cbLasDirect2->Items->Add(DirType[edLeftUp]);
            break;
            case etScaleOut:
                cbLasDirect2->Items->Add(DirType[edRightDown]);
            break;
            case etRotate:
            //case etRotate2:
                cbLasDirect2->Items->Add(DirType[edReverseClock]);
            break;
            case etBlink:
            case etBlinkReverse:
                cbLasDirect2->Items->Add(DirType[edRed]);
            break;
            case etLineTest:
                cbLasDirect2->Items->Add(DirType[edLeft]);
            break;
            case etRandom:
                cbLasDirect2->Items->Add(DirType[edRandom]);
            break;
            default:
                cbLasDirect2->Items->Add(LangFile.NoEffect);
            break;
        }
        cbLasDirect2->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbLasEffect2DropDown(TObject *Sender)
{
        if(cbLasEffect2->Items->IndexOf(cbLasEffect2->Text) > -1)
            cbLasEffect2->ItemIndex = cbLasEffect2->Items->IndexOf(cbLasEffect2->Text);
        else
            cbLasEffect2->ItemIndex = 0;        
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbLasDirect2DropDown(TObject *Sender)
{
        AnsiString asED = cbLasDirect2->Text;
        cbLasDirect2->Clear();
        if(cbLasEffect2->Text == EffectType[etNormal])
        {
            for(int i = edNone; i < 5; i++)
                cbLasDirect2->Items->Add(DirType[i]);
        }
        else if(cbLasEffect2->Text == EffectType[etShift])
        {
            for(int i = edLeft; i < edLeft + 6; i++)
            {
                if((TGEffectType)i == edLeftUp)
                    continue;
                if((TGEffectType)i == edUpDown)
                    continue;
                cbLasDirect2->Items->Add(DirType[i]);
            }
        }
        else if(cbLasEffect2->Text == EffectType[etWipe] ||
            cbLasEffect2->Text == EffectType[etBlind])
        {
            for(int i = edLeft; i < edLeft + 4; i++)
                cbLasDirect2->Items->Add(DirType[i]);
        }
        else if(cbLasEffect2->Text == EffectType[etCurtain])
        {
            for(int i = edHoriSide; i < edHoriSide + 4; i++)
                cbLasDirect2->Items->Add(DirType[i]);
        }
        else if(cbLasEffect2->Text == EffectType[etScaleIn] ||
            cbLasEffect2->Text == EffectType[etScaleOut])
        {
            for(int i = edLeft; i < edLeft + 4; i++)
                cbLasDirect2->Items->Add(DirType[i]);
            if(cbLasEffect2->Text == EffectType[etScaleIn])
                cbLasDirect2->Items->Add(DirType[edLeftUp]);
            else
                cbLasDirect2->Items->Add(DirType[edRightDown]);
        }
        else if(cbLasEffect2->Text == EffectType[etRotate])
        {
            for(int i = edReverseClock; i < edReverseClock + 4; i++)
            {
                cbLasDirect2->Items->Add(DirType[i]);
            }
        }
        else if(cbLasEffect2->Text == EffectType[etBlink] ||
            cbLasEffect2->Text == EffectType[etBlinkReverse])
        {
            for(int i = edRed; i < edRed + 5; i++)
                cbLasDirect2->Items->Add(DirType[i]);
        }
        else if(cbLasEffect2->Text == EffectType[etLineTest])
        {
            for(int i = edLeft; i < edLeft + 10; i++)
            {
                if((TGEffectType)i == edLeftUp || (TGEffectType)i == edUpDown || (TGEffectType)i == edLeftAdd)
                    continue;
                if((TGEffectType)i == edLeft || (TGEffectType)i == edDown || (TGEffectType)i == edRightDown)
                    cbLasDirect2->Items->Add(DirType[i]);
            }
        }
        else if(cbLasEffect2->Text == EffectType[etRandom])
        {
            for(int i = edOrder; i < edOrder + 2; i++)
                cbLasDirect2->Items->Add(DirType[i]);
        }
        else if(cbLasEffect2->Text == EffectType[et3DShift])
            cbLasDirect2->Items->Add(DirType[edLeft]);
        else
            cbLasDirect2->Items->Add(LangFile.NoEffect);
        if(cbLasDirect2->Items->IndexOf(asED) > -1)
            cbLasDirect2->ItemIndex = cbLasDirect2->Items->IndexOf(asED);
        else
            cbLasDirect2->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::rbTextNoClick(TObject *Sender)
{
        // ޹ ü  Լ
        if(rbNo1->Checked)
            ProtocolBlockNo = 0;
        else if(rbNo2->Checked)
            ProtocolBlockNo = 1;
        else if(rbNo3->Checked)
            ProtocolBlockNo = 2;
        ProtocolData.ProtocolDispControl[0][ProtocolBlockNo] = cbDispControl->ItemIndex;
        if(cbRevRefeat->Checked)
            ProtocolData.ProtocolDispControl[0][ProtocolBlockNo] |= 0x80;
        ProtocolData.ProtocolDispType[0][ProtocolBlockNo] = cbDispType->ItemIndex;
        ProtocolData.ProtocolCodeKind[0][ProtocolBlockNo] = cbCodeKind->ItemIndex;
        ProtocolData.ProtocolFontSize[0][ProtocolBlockNo] = cbFontSize->ItemIndex;
        ZeroMemory(&ProtocolData.ProtocolEntEffect[0][ProtocolBlockNo], sizeof(ProtocolData.ProtocolEntEffect[0][0]));
        memcpy(&ProtocolData.ProtocolEntEffect[0][ProtocolBlockNo][0], AnsiString(cbEntEffect->Text).c_str(), AnsiString(cbEntEffect->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolLasDirect[0][ProtocolBlockNo], sizeof(ProtocolData.ProtocolLasDirect[0][0]));
        memcpy(&ProtocolData.ProtocolLasDirect[0][ProtocolBlockNo][0], AnsiString(cbEntDirect->Text).c_str(), AnsiString(cbEntDirect->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolLasEffect[0][ProtocolBlockNo], sizeof(ProtocolData.ProtocolLasEffect[0][0]));
        memcpy(&ProtocolData.ProtocolLasEffect[0][ProtocolBlockNo][0], AnsiString(cbLasEffect->Text).c_str(), AnsiString(cbLasEffect->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolLasDirect[0][ProtocolBlockNo], sizeof(ProtocolData.ProtocolLasDirect[0][0]));
        memcpy(&ProtocolData.ProtocolLasDirect[0][ProtocolBlockNo][0], AnsiString(cbLasDirect->Text).c_str(), AnsiString(cbLasDirect->Text).Length());
        ProtocolData.ProtocolColorType[0][ProtocolBlockNo] = cbAssistEffect->ItemIndex;
        ZeroMemory(&ProtocolData.ProtocolSpeed[0][ProtocolBlockNo], sizeof(ProtocolData.ProtocolSpeed[0][0]));
        memcpy(&ProtocolData.ProtocolSpeed[0][ProtocolBlockNo][0], AnsiString(cbSpeed->Text).c_str(), AnsiString(cbSpeed->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolDelay[0][ProtocolBlockNo], sizeof(ProtocolData.ProtocolDelay[0][0]));
        memcpy(&ProtocolData.ProtocolDelay[0][ProtocolBlockNo][0], AnsiString(cbDelay->Text).c_str(), AnsiString(cbDelay->Text).Length());
        ProtocolData.ProtocolStartXPos[0][ProtocolBlockNo] = cbStartXPos->ItemIndex;
        ProtocolData.ProtocolStartYPos[0][ProtocolBlockNo] = cbStartYPos->ItemIndex;
        ProtocolData.ProtocolEndXPos[0][ProtocolBlockNo] = cbEndXPos->ItemIndex;
        ProtocolData.ProtocolEndYPos[0][ProtocolBlockNo] = cbEndYPos->ItemIndex;
        ProtocolData.ProtocolBGImage[0][ProtocolBlockNo] = cbBGImage->ItemIndex;
        ZeroMemory(&ProtocolData.ProtocolColor[0][ProtocolBlockNo], sizeof(ProtocolData.ProtocolColor[0][0]));
        memcpy(&ProtocolData.ProtocolColor[0][ProtocolBlockNo][0], AnsiString(eColor->Text).c_str(), AnsiString(eColor->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolBGColor[0][ProtocolBlockNo], sizeof(ProtocolData.ProtocolBGColor[0][0]));
        memcpy(&ProtocolData.ProtocolBGColor[0][ProtocolBlockNo][0], AnsiString(eBGColor->Text).c_str(), AnsiString(eBGColor->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolData[0][ProtocolBlockNo], sizeof(ProtocolData.ProtocolData[0][0]));
        memcpy(&ProtocolData.ProtocolData[0][ProtocolBlockNo][0], AnsiString(eData->Text).c_str(), AnsiString(eData->Text).Length());
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::rbTextNo2Click(TObject *Sender)
{
        // Ϲݹ ü  Լ
        if(rbNo21->Checked)
            ProtocolBlockNo2 = 0;
        else if(rbNo22->Checked)
            ProtocolBlockNo2 = 1;
        else if(rbNo23->Checked)
            ProtocolBlockNo2 = 2;
        ProtocolPageNo2 = cbPageNo2->ItemIndex + 1;
        ProtocolData.ProtocolDispControl[ProtocolPageNo2][ProtocolBlockNo2] = cbDispControl2->ItemIndex;
        ProtocolData.ProtocolDispType[ProtocolPageNo2][ProtocolBlockNo2] = cbDispType2->ItemIndex;
        ProtocolData.ProtocolCodeKind[ProtocolPageNo2][ProtocolBlockNo2] = cbCodeKind2->ItemIndex;
        ProtocolData.ProtocolFontSize[ProtocolPageNo2][ProtocolBlockNo2] = cbFontSize2->ItemIndex;
        ZeroMemory(&ProtocolData.ProtocolEntEffect[ProtocolPageNo2][ProtocolBlockNo2], sizeof(ProtocolData.ProtocolEntEffect[0][0]));
        memcpy(&ProtocolData.ProtocolEntEffect[ProtocolPageNo2][ProtocolBlockNo2][0], AnsiString(cbEntEffect2->Text).c_str(), AnsiString(cbEntEffect2->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolLasDirect[ProtocolPageNo2][ProtocolBlockNo2], sizeof(ProtocolData.ProtocolLasDirect[0][0]));
        memcpy(&ProtocolData.ProtocolLasDirect[ProtocolPageNo2][ProtocolBlockNo2][0], AnsiString(cbEntDirect2->Text).c_str(), AnsiString(cbEntDirect2->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolLasEffect[ProtocolPageNo2][ProtocolBlockNo2], sizeof(ProtocolData.ProtocolLasEffect[0][0]));
        memcpy(&ProtocolData.ProtocolLasEffect[ProtocolPageNo2][ProtocolBlockNo2][0], AnsiString(cbLasEffect2->Text).c_str(), AnsiString(cbLasEffect2->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolLasDirect[ProtocolPageNo2][ProtocolBlockNo2], sizeof(ProtocolData.ProtocolLasDirect[0][0]));
        memcpy(&ProtocolData.ProtocolLasDirect[ProtocolPageNo2][ProtocolBlockNo2][0], AnsiString(cbLasDirect2->Text).c_str(), AnsiString(cbLasDirect2->Text).Length());
        ProtocolData.ProtocolColorType[ProtocolPageNo2][ProtocolBlockNo2] = cbAssistEffect2->ItemIndex;
        ZeroMemory(&ProtocolData.ProtocolSpeed[ProtocolPageNo2][ProtocolBlockNo2], sizeof(ProtocolData.ProtocolSpeed[0][0]));
        memcpy(&ProtocolData.ProtocolSpeed[ProtocolPageNo2][ProtocolBlockNo2][0], AnsiString(cbSpeed2->Text).c_str(), AnsiString(cbSpeed2->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolDelay[ProtocolPageNo2][ProtocolBlockNo2], sizeof(ProtocolData.ProtocolDelay[0][0]));
        memcpy(&ProtocolData.ProtocolDelay[ProtocolPageNo2][ProtocolBlockNo2][0], AnsiString(cbDelay2->Text).c_str(), AnsiString(cbDelay2->Text).Length());
        ProtocolData.ProtocolStartXPos[ProtocolPageNo2][ProtocolBlockNo2] = cbStartXPos2->ItemIndex;
        ProtocolData.ProtocolStartYPos[ProtocolPageNo2][ProtocolBlockNo2] = cbStartYPos2->ItemIndex;
        ProtocolData.ProtocolEndXPos[ProtocolPageNo2][ProtocolBlockNo2] = cbEndXPos2->ItemIndex;
        ProtocolData.ProtocolEndYPos[ProtocolPageNo2][ProtocolBlockNo2] = cbEndYPos2->ItemIndex;
        ProtocolData.ProtocolBGImage[ProtocolPageNo2][ProtocolBlockNo2] = cbBGImage2->ItemIndex;
        ZeroMemory(&ProtocolData.ProtocolColor[ProtocolPageNo2][ProtocolBlockNo2], sizeof(ProtocolData.ProtocolColor[0][0]));
        memcpy(&ProtocolData.ProtocolColor[ProtocolPageNo2][ProtocolBlockNo2][0], AnsiString(eColor2->Text).c_str(), AnsiString(eColor2->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolBGColor[ProtocolPageNo2][ProtocolBlockNo2], sizeof(ProtocolData.ProtocolBGColor[0][0]));
        memcpy(&ProtocolData.ProtocolBGColor[ProtocolPageNo2][ProtocolBlockNo2][0], AnsiString(eBGColor2->Text).c_str(), AnsiString(eBGColor2->Text).Length());
        ZeroMemory(&ProtocolData.ProtocolData[ProtocolPageNo2][ProtocolBlockNo2], sizeof(ProtocolData.ProtocolData[0][0]));
        memcpy(&ProtocolData.ProtocolData[ProtocolPageNo2][ProtocolBlockNo2][0], AnsiString(eData2->Text).c_str(), AnsiString(eData2->Text).Length());
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbFontSizeClick(TObject *Sender)
{
        // ޹ 12x12 Ʈ   ϰ ´
        if(cbFontSize->ItemIndex == 0)
        {
            eBGColor->Enabled = false;
            Label18->Enabled = false;
        }
        else
        {
            eBGColor->Enabled = true;
            Label18->Enabled = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::cbFontSize2Click(TObject *Sender)
{
        // Ϲݹ 12x12 Ʈ   ϰ ´
        if(cbFontSize2->ItemIndex == 0)
        {
            eBGColor2->Enabled = false;
            TeLabel18->Enabled = false;
        }
        else
        {
            eBGColor2->Enabled = true;
            TeLabel18->Enabled = true;
        }        
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::rbTextNoRoadClick(TObject *Sender)
{
        // ޹ ü ҷ Լ
        try{
            if(rbNo1->Checked)
                ProtocolBlockNo = 0;
            else if(rbNo2->Checked)
                ProtocolBlockNo = 1;
            else if(rbNo3->Checked)
                ProtocolBlockNo = 2;
            union{
                char cbSize;
                struct{
                    unsigned bit0 : 7;
                    unsigned bit1 : 1;
                }Bit;
            }uSize3;
            uSize3.cbSize = ProtocolData.ProtocolDispControl[0][ProtocolBlockNo];
            cbDispControl->ItemIndex = uSize3.Bit.bit0;
            if(!ProtocolBlockNo)
            {
                cbRevRefeat->Checked = uSize3.Bit.bit1;
                cbRevRefeat->Visible = true;
            }
            else
            {
                cbRevRefeat->Checked = false;
                cbRevRefeat->Visible = false;
            }
            cbDispType->ItemIndex = ProtocolData.ProtocolDispType[0][ProtocolBlockNo];
            cbCodeKind->ItemIndex = ProtocolData.ProtocolCodeKind[0][ProtocolBlockNo];
            cbFontSize->ItemIndex = ProtocolData.ProtocolFontSize[0][ProtocolBlockNo];
            cbFontSizeClick(this);
            cbEntEffect->ItemIndex = -1;
            cbEntEffect->ItemIndex = cbEntEffect->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolEntEffect[0][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolEntEffect[0][0])));
            if(cbEntEffect->ItemIndex < 0)
                cbEntEffect->ItemIndex = 0;
            cbEntDirectDropDown(this);
            cbEntDirect->ItemIndex = cbEntDirect->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolEntDirect[0][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolEntDirect[0][0])));
            if(cbEntDirect->ItemIndex < 0)
                cbEntDirect->ItemIndex = 0;
            cbLasEffect->ItemIndex = - 1;
            cbLasEffect->ItemIndex = cbLasEffect->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolLasEffect[0][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolLasEffect[0][0])));
            if(cbLasEffect->ItemIndex < 0)
                cbLasEffect->ItemIndex = 0;
            cbLasDirectDropDown(this);
            cbLasDirect->ItemIndex = cbLasDirect->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolLasDirect[0][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolLasDirect[0][0])));
            if(cbLasDirect->ItemIndex < 0)
                cbLasDirect->ItemIndex = 0;
            cbSpeed->ItemIndex = cbSpeed->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolSpeed[0][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolSpeed[0][0])));
            cbDelay->ItemIndex = cbDelay->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolDelay[0][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolDelay[0][0])));
            cbStartXPos->ItemIndex = ProtocolData.ProtocolStartXPos[0][ProtocolBlockNo];
            cbStartYPos->ItemIndex = ProtocolData.ProtocolStartYPos[0][ProtocolBlockNo];
            cbEndXPos->ItemIndex = ProtocolData.ProtocolEndXPos[0][ProtocolBlockNo];
            cbEndYPos->ItemIndex = ProtocolData.ProtocolEndYPos[0][ProtocolBlockNo];
            if(ProtocolBlockNo == 0)
            {
                cbBGImage->ItemIndex = ProtocolData.ProtocolBGImage[0][ProtocolBlockNo];
                cbBGImage->Enabled = true;
                cbDelay->Enabled = true;
            }
            else
            {
                cbBGImage->Enabled = false;
                cbDelay->Enabled = false;
            }
            cbAssistEffect->ItemIndex = ProtocolData.ProtocolColorType[0][ProtocolBlockNo];
            eColor->Text = (WideString)AnsiString((char*)ProtocolData.ProtocolColor[0][ProtocolBlockNo]).TrimRight().SubString(1, sizeof(ProtocolData.ProtocolColor[0][0]));
            eBGColor->Text = (WideString)AnsiString((char*)ProtocolData.ProtocolBGColor[0][ProtocolBlockNo]).TrimRight().SubString(1, sizeof(ProtocolData.ProtocolBGColor[0][0]));
            AnsiString EditFileName = BasePath + IncludeTrailingPathDelimiter(FormMain->DestSysPath)
                + "EnvData" + IntToStr(ProtocolBlockNo) + ".dat";
            eData->Text = (WideString)"";
            if(FileExists(EditFileName))
                eData->Lines->LoadFromFile(EditFileName);
            else
                eData->Text = (WideString)AnsiString((char*)ProtocolData.ProtocolData[0][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolBGColor[0][0]));
        }catch(...){
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::rbTextNoRoad2Click(TObject *Sender)
{
        // Ϲݹ ü ҷ Լ
        try{
            if(rbNo21->Checked)
                ProtocolBlockNo2 = 0;
            else if(rbNo22->Checked)
                ProtocolBlockNo2 = 1;
            else if(rbNo23->Checked)
                ProtocolBlockNo2 = 2;
            ProtocolPageNo2 = cbPageNo2->ItemIndex + 1;
            cbDispControl2->ItemIndex = ProtocolData.ProtocolDispControl[ProtocolPageNo2][ProtocolBlockNo2];
            cbDispType2->ItemIndex = ProtocolData.ProtocolDispType[ProtocolPageNo2][ProtocolBlockNo2];
            cbCodeKind2->ItemIndex = ProtocolData.ProtocolCodeKind[ProtocolPageNo2][ProtocolBlockNo2];
            cbFontSize2->ItemIndex = ProtocolData.ProtocolFontSize[ProtocolPageNo2][ProtocolBlockNo2];
            cbFontSize2Click(this);
            cbEntEffect2->ItemIndex = cbEntEffect->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolEntEffect[ProtocolPageNo2][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolEntEffect[0][0])));
            if(cbEntEffect2->ItemIndex < 0)
                cbEntEffect2->ItemIndex = 0;
            cbEntDirect2DropDown(this);
            cbEntDirect2->ItemIndex = cbEntDirect->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolEntDirect[ProtocolPageNo2][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolEntDirect[0][0])));
            if(cbEntDirect2->ItemIndex < 0)
                cbEntDirect2->ItemIndex = 0;
            cbLasEffect2->ItemIndex = - 1;
            cbLasEffect2->ItemIndex = cbLasEffect->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolLasEffect[ProtocolPageNo2][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolLasEffect[0][0])));
            if(cbLasEffect2->ItemIndex < 0)
                cbLasEffect2->ItemIndex = 0;
            cbLasDirect2DropDown(this);
            cbLasDirect2->ItemIndex = cbLasDirect->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolLasDirect[ProtocolPageNo2][ProtocolBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolLasDirect[0][0])));
            if(cbEntDirect2->ItemIndex < 0)
                cbEntDirect2->ItemIndex = 0;
            cbSpeed2->ItemIndex = cbSpeed->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolSpeed[ProtocolPageNo2][ProtocolBlockNo2]).SubString(1, sizeof(ProtocolData.ProtocolSpeed[0][0])));
            cbDelay2->ItemIndex = cbDelay->Items->IndexOf(AnsiString((char*)ProtocolData.ProtocolDelay[ProtocolPageNo2][ProtocolBlockNo2]).SubString(1, sizeof(ProtocolData.ProtocolDelay[0][0])));
            cbStartXPos2->ItemIndex = ProtocolData.ProtocolStartXPos[ProtocolPageNo2][ProtocolBlockNo2];
            cbStartYPos2->ItemIndex = ProtocolData.ProtocolStartYPos[ProtocolPageNo2][ProtocolBlockNo2];
            cbEndXPos2->ItemIndex = ProtocolData.ProtocolEndXPos[ProtocolPageNo2][ProtocolBlockNo2];
            cbEndYPos2->ItemIndex = ProtocolData.ProtocolEndYPos[ProtocolPageNo2][ProtocolBlockNo2];
            if(ProtocolBlockNo2 == 0)
            {
                cbBGImage2->ItemIndex = ProtocolData.ProtocolBGImage[ProtocolPageNo2][ProtocolBlockNo2];
                cbBGImage2->Enabled = true;
                cbDelay2->Enabled = true;
            }
            else
            {
                cbBGImage2->Enabled = false;
                cbDelay2->Enabled = false;
            }
            cbAssistEffect2->ItemIndex   = ProtocolData.ProtocolColorType[ProtocolPageNo2][ProtocolBlockNo2];
            eColor2->Text = (WideString)AnsiString((char*)ProtocolData.ProtocolColor[ProtocolPageNo2][ProtocolBlockNo]).TrimRight().SubString(1, sizeof(ProtocolData.ProtocolColor[0][0]));
            eBGColor2->Text = (WideString)AnsiString((char*)ProtocolData.ProtocolBGColor[ProtocolPageNo2][ProtocolBlockNo]).TrimRight().SubString(1, sizeof(ProtocolData.ProtocolBGColor[0][0]));
            AnsiString EditFileName = BasePath + IncludeTrailingPathDelimiter(DestSysPath)
                + "MessageData" + IntToStr(ProtocolPageNo2) + IntToStr(ProtocolBlockNo2) + ".dat";
            eData2->Text = (WideString)"";
            if(FileExists(EditFileName))
                eData2->Lines->LoadFromFile(EditFileName);
            else
                eData2->Text = (WideString)AnsiString((char*)ProtocolData.ProtocolData[ProtocolPageNo2][ProtocolBlockNo2]).SubString(1, sizeof(ProtocolData.ProtocolBGColor[0][0]));
        }catch(...){
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BMemClearClick(TObject *Sender)
{
        bStopSend = false;
        int Addr = 0;
        AnsiString Data = "";
        Addr = Controler1;
        BYTE SendData[1];
        SendData[0] = 0x00;
        BYTE tempOpCode = 0;
        AnsiString asMessage = "";
        if(Sender == BMemClear)
        {
            // Ϲݹ ޸ ʱȭ
            if(cbMsgMemClear->ItemIndex == 0)
                SendData[0] = 0x80;
            else
                SendData[0] = cbMsgMemClear->ItemIndex - 1;
            tempOpCode = FMMC;
            asMessage = LangFile.Message08;
        }
        else if(Sender == BBGImage)
        {
            // ȭ ̹ 
            SendData[0] = cbBGISelect->ItemIndex;
            tempOpCode = EDI;
            asMessage = LangFile.Message10;
        }
        else
        {
            // Ϲݹ  
            SendData[0] = cbMsgInput->ItemIndex + 1;
            MessageCount = SendData[0];
            tempOpCode = FMI;
            asMessage = LangFile.Message09;
        }
        bool Connect = false;
        ButtonEnabled(false);
        if(ComPortSet(ComKind, PortUse1, BaudRateUse1, Disable, Disable, IPAddress, IPPort, false))
        {
            Connect = ModuleData(ComKind, Addr, SendData, sizeof(SendData), 0, (OPCode)tempOpCode, bMsg);
            if(Connect)
                AddLog(asMessage + " [OK]" + asLogMessage, clBlack);
            else
                AddLog(asMessage + " [FAIL]" + asLogMessage, clRed);
            ComClose(ComKind);
        }
        if(MessageCount != cbMsgInput->ItemIndex + 1) // Ϲݹ  ̿ ü ʱȭ
        {
            char Buf[3];
            char Buf2[3];
            AnsiString asFileName = "";
            AnsiString asData = "";
            for(int i = 1; i <= MessageCount; i++)
            {
                for(int j = 0; j < 3; j++)
                {
                    if(j == 0)
                        ProtocolData.ProtocolDispControl[i][j] = 1;
                    else
                        ProtocolData.ProtocolDispControl[i][j] = 0;
                    ProtocolData.ProtocolDispType[i][j]  = 0;
                    ProtocolData.ProtocolCodeKind[i][j]  = 0;
                    ProtocolData.ProtocolFontSize[i][j]  = 1;
                    asData = "ȿ";
                    memcpy(&ProtocolData.ProtocolEntEffect[i][j][0], asData.c_str(), asData.Length());
                    memcpy(&ProtocolData.ProtocolLasDirect[i][j][0], asData.c_str(), asData.Length());
                    asData = " ";
                    memcpy(&ProtocolData.ProtocolEntDirect[i][j][0], asData.c_str(), asData.Length());
                    memcpy(&ProtocolData.ProtocolLasDirect[i][j][0], asData.c_str(), asData.Length());
                    ProtocolData.ProtocolStartXPos[i][j] = 0;
                    ProtocolData.ProtocolStartYPos[i][j] = 0;
                    ProtocolData.ProtocolEndXPos[i][j] = 0;
                    ProtocolData.ProtocolEndYPos[i][j] = 0;
                    ProtocolData.ProtocolBGImage[i][j] = 0;
                    ProtocolData.ProtocolColorType[i][j] = 0;
                    asData = "20";
                    memcpy(&ProtocolData.ProtocolSpeed[i][j][0], asData.c_str(), asData.Length());
                    asData = "2";
                    memcpy(&ProtocolData.ProtocolDelay[i][j][0], asData.c_str(), asData.Length());
                    asData = "1";
                    memcpy(&ProtocolData.ProtocolColor[i][j][0], asData.c_str(), asData.Length());
                    asData = "0";
                    memcpy(&ProtocolData.ProtocolBGColor[i][j][0], asData.c_str(), asData.Length());
                    ZeroMemory(Buf, 3);
                    wsprintf(Buf, "%02d", i + 1);
                    ZeroMemory(Buf2, 3);
                    wsprintf(Buf2, "%02d", j + 1);
                    asData = LangFile.FormProtocolTab2 + AnsiString(Buf).TrimRight() + "-" + AnsiString(Buf2).TrimRight();
                    memcpy(&ProtocolData.ProtocolData[i][j][0], asData.c_str(), asData.Length());
                    asFileName = BasePath + IncludeTrailingPathDelimiter(DestSysPath) + "MessageData" + IntToStr(i) + IntToStr(j) + ".dat";
                    if(FileExists(asFileName))
                        DeleteFile(asFileName);
                }
            }
        }
        MessageCount = cbMsgInput->ItemIndex + 1;
        int PageIndex2 = ProtocolPageNo2;
        cbPageNo2->Clear();
        for(int i = 0; i < MessageCount; i++)
            cbPageNo2->Items->Add(IntToStr(i));
        if(MessageCount - 1 < PageIndex2)
            cbPageNo2->ItemIndex = MessageCount - 1;
        else
            cbPageNo2->ItemIndex = PageIndex2;
        PageIndex2 = cbMsgMemClear->ItemIndex;
        cbMsgMemClear->Clear();
        cbMsgMemClear->Items->Add(LangFile.BtnSelectAll);
        for(int i = 0; i < MessageCount; i++)
            cbMsgMemClear->Items->Add(IntToStr(i));
        if(PageIndex2 >= MessageCount)
            cbMsgMemClear->ItemIndex = MessageCount;
        else
            cbMsgMemClear->ItemIndex = PageIndex2;
        ProtocolPageNo2 = cbPageNo2->ItemIndex;
        ButtonEnabled(true);
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::SendSyncClick(TObject *Sender)
{
        // ȣ   ư
        bStopSend = false;
        BYTE SendData[4];
        ZeroMemory(SendData, sizeof(SendData));
        try{
            switch(cbSoundSec1->ItemIndex)
            {
                case 0:
                {
                    SendData[0] = 0x00;
                    SendData[1] = 0xf1;
                }
                break;
                case 1:
                {
                    SendData[0] = 0x00;
                    SendData[1] = 0xf0;
                }
                break;
                case 2:
                {
                    SendData[0] = 0x00;
                    SendData[1] = 0x00;
                }
                break;
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                case 9:
                case 10:
                case 11:
                case 12:
                    SendData[0] = cbSoundSec1->ItemIndex - 2;
                break;
                case 13:
                case 14:
                case 15:
                case 16:
                case 17:
                    SendData[0] = 12 + (cbSoundSec1->ItemIndex - 13) * 2;
                break;
                case 18:
                    SendData[0] = 25;
                break;
                case 19:
                    SendData[0] = 30;
                break;
                case 20:
                    SendData[0] = 40;
                break;
                case 21:
                    SendData[0] = 50;
                break;
                case 22:
                    SendData[0] = 75;
                break;
                case 23:
                    SendData[0] = 100;
                break;
                case 24:
                    SendData[0] = 120;
                break;
                case 25:
                    SendData[0] = 140;
                break;
                case 26:
                    SendData[0] = 160;
                break;
                case 27:
                    SendData[0] = 180;
                break;
                case 28:
                    SendData[0] = 200;
                break;
                case 29:
                    SendData[0] = 220;
                break;
                case 30:
                    SendData[0] = 230;
                break;
                default:
                    SendData[0] = 1;
                break;
            }
            switch(cbSoundSec2->ItemIndex)
            {
                case 0:
                {
                    SendData[2] = 0x00;
                    SendData[3] = 0xf1;
                }
                break;
                case 1:
                {
                    SendData[2] = 0x00;
                    SendData[3] = 0xf0;
                }
                break;
                case 2:
                {
                    SendData[2] = 0x00;
                    SendData[3] = 0x00;
                }
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                case 9:
                case 10:
                case 11:
                case 12:
                    SendData[2] = cbSoundSec2->ItemIndex - 2;
                break;
                case 13:
                case 14:
                case 15:
                case 16:
                case 17:
                    SendData[2] = 12 + (cbSoundSec2->ItemIndex - 13) * 2;
                break;
                case 18:
                    SendData[2] = 25;
                break;
                case 19:
                    SendData[2] = 30;
                break;
                case 20:
                    SendData[2] = 40;
                break;
                case 21:
                    SendData[2] = 50;
                break;
                case 22:
                    SendData[2] = 75;
                break;
                case 23:
                    SendData[2] = 100;
                break;
                case 24:
                    SendData[2] = 120;
                break;
                case 25:
                    SendData[2] = 140;
                break;
                case 26:
                    SendData[2] = 160;
                break;
                case 27:
                    SendData[2] = 180;
                break;
                case 28:
                    SendData[2] = 200;
                break;
                case 29:
                    SendData[2] = 220;
                break;
                case 30:
                    SendData[2] = 230;
                break;
                default:
                    SendData[2] = 1;
                break;
            }
        }catch(...){
            SendData[0] = 1;
            SendData[2] = 1;
        }
        ButtonEnabled(false);
        int Addr = 0;
        Addr = Controler1;
        try{
            if(ComPortSet(ComKind, PortUse1, BaudRateUse1, Disable, Disable, IPAddress, IPPort, false))
            {
                if(ModuleData(ComKind, Addr, SendData, sizeof(SendData), 0, SO, bMsg))
                    AddLog(LangFile.BtnSignalSend + " [OK] " + asLogMessage, clBlack);
                else
                    AddLog(LangFile.BtnSignalSend + " [Fail] " + asLogMessage, clRed);
                ComClose(ComKind);
            }
        }catch(...){
        }
        ButtonEnabled(true);
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonEnabled(bool bEnabled)
{
        // ư Ȱȭ Լ
        DataSend->Enabled = bEnabled;
        BMemClear->Enabled = bEnabled;
        BInput->Enabled = bEnabled;
        BBGImage->Enabled = bEnabled;
        SendSync->Enabled = bEnabled;
        BtnSignSize->Enabled = bEnabled;
        BitBtnPowerLEDOn->Enabled = bEnabled;
        BitBtnPowerLEDOff->Enabled = bEnabled;
        BitBtnSyncLED->Enabled = bEnabled;
        BDIBDTime->Enabled = bEnabled;
        this->Enabled = bEnabled;
        this->BringToFront();
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::tsShow(TObject *Sender)
{
        if(Sender == tsETC)
            DataSend->Visible = false;
        else
            DataSend->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnPowerLEDClick(TObject *Sender)
{
        //    ư
        bStopSend = false;
        int Addr = 0;
        ButtonEnabled(false);
        Addr = Controler1;
        OPCode tempOPC;
        BYTE SendData[1];
        ZeroMemory(SendData, sizeof(SendData));
        if(Sender == BitBtnPowerLEDOff)
            SendData[0] = PowerOff;
        else
            SendData[0] = PowerOn;
        if(ComPortSet(ComKind, PortUse1, BaudRateUse1, Disable, Disable, IPAddress, IPPort, false))
        {
            if(ModuleData(ComKind, Addr, SendData, sizeof(SendData), 0, PC, bMsg))
            {
                if(Sender == BitBtnPowerLEDOff)
                    AddLog(LangFile.Message04 + " [OK]" + asLogMessage, clBlack);
                else
                    AddLog(LangFile.Message03 + " [OK]" + asLogMessage, clBlack);
            }
            else
            {
                if(Sender == BitBtnPowerLEDOff)
                    AddLog(LangFile.Message04 + " [Fail]" + asLogMessage, clRed);
                else
                    AddLog(LangFile.Message03 + " [Fail]" + asLogMessage, clRed);
            }
            ComClose(ComKind);
        }
        ButtonEnabled(true);
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::DataSendClick(TObject *Sender)
{
        DataSend->Enabled = false;
        bStopSend = false;
        union{
            char cbSize;
            struct{
                unsigned bit0 : 4;
                unsigned bit1 : 4;
            }Bit;
        }uSize2;
        BYTE *SendProtocoData = NULL;
        try{
            bool bPortOpen = false;
            bool bConnect = false;
            int TextSize = 0;
            int Addr = 0;
            AnsiString Data = "";
            int ModuleSize = 0;
            ModuleSize = ModuleWidth * 2;
            int SendSize = 0;
            int TotDataSize = 0;
            AnsiString asMessage = "";
            AnsiString EntData = "";
            BYTE *RealPPAData;
            OPCode tempOPCode;
            AnsiString asSpeed = "";
            union{
                char cbSize;
                struct{
                    unsigned bit0 : 7;
                    unsigned bit1 : 1;
                }Bit;
            }uSize;
            int iCurBlockNo = 0;
            int iCurPageNo = 0;
            if(tsEnv->Showing)// ޹
            {
                if(rbNo1->Checked)
                    ProtocolBlockNo = 0;
                else if(rbNo2->Checked)
                    ProtocolBlockNo = 1;
                else if(rbNo3->Checked)
                    ProtocolBlockNo = 2;
                iCurBlockNo = ProtocolBlockNo;
                iCurPageNo = 0;
            }
            else// Ϲݹ
            {
                if(rbNo21->Checked)
                    ProtocolBlockNo2 = 0;
                else if(rbNo22->Checked)
                    ProtocolBlockNo2 = 1;
                else if(rbNo23->Checked)
                    ProtocolBlockNo2 = 2;
                ProtocolPageNo2 = cbPageNo2->ItemIndex;
                iCurBlockNo = ProtocolBlockNo2;
                iCurPageNo = ProtocolPageNo2 + 1;
            }
            WideString wtempData;
            AnsiString tempData;
            AnsiString EditFileName;
            if(tsEnv->Showing)// ޹
            {
                //  ޹ ü 
                ProtocolData.ProtocolDispControl[0][iCurBlockNo] = cbDispControl->ItemIndex;
                if(cbRevRefeat->Checked)
                    ProtocolData.ProtocolDispControl[0][iCurBlockNo] |= 0x80;
                ProtocolData.ProtocolDispType[0][iCurBlockNo] = cbDispType->ItemIndex;
                ProtocolData.ProtocolCodeKind[0][iCurBlockNo] = cbCodeKind->ItemIndex;
                ProtocolData.ProtocolFontSize[0][iCurBlockNo] = cbFontSize->ItemIndex;
                tempData = cbEntEffect->Text;
                ZeroMemory(&ProtocolData.ProtocolEntEffect[0][iCurBlockNo], sizeof(ProtocolData.ProtocolEntEffect[0][0]));
                memcpy(&ProtocolData.ProtocolEntEffect[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = cbEntDirect->Text;
                ZeroMemory(&ProtocolData.ProtocolEntDirect[0][iCurBlockNo], sizeof(ProtocolData.ProtocolEntDirect[0][0]));
                memcpy(&ProtocolData.ProtocolEntDirect[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = cbLasEffect->Text;
                ZeroMemory(&ProtocolData.ProtocolLasEffect[0][iCurBlockNo], sizeof(ProtocolData.ProtocolLasEffect[0][0]));
                memcpy(&ProtocolData.ProtocolLasEffect[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = cbLasDirect->Text;
                ZeroMemory(&ProtocolData.ProtocolLasDirect[0][iCurBlockNo], sizeof(ProtocolData.ProtocolLasDirect[0][0]));
                memcpy(&ProtocolData.ProtocolLasDirect[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                ProtocolData.ProtocolColorType[0][iCurBlockNo] = cbAssistEffect->ItemIndex;
                tempData = cbSpeed->Text;
                ZeroMemory(&ProtocolData.ProtocolSpeed[0][iCurBlockNo], sizeof(ProtocolData.ProtocolSpeed[0][0]));
                memcpy(&ProtocolData.ProtocolSpeed[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = cbDelay->Text;
                ZeroMemory(&ProtocolData.ProtocolDelay[0][iCurBlockNo], sizeof(ProtocolData.ProtocolDelay[0][0]));
                memcpy(&ProtocolData.ProtocolDelay[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                ProtocolData.ProtocolStartXPos[0][iCurBlockNo] = cbStartXPos->ItemIndex;
                ProtocolData.ProtocolStartYPos[0][iCurBlockNo] = cbStartYPos->ItemIndex;
                ProtocolData.ProtocolEndXPos[0][iCurBlockNo] = cbEndXPos->ItemIndex;
                ProtocolData.ProtocolEndYPos[0][iCurBlockNo] = cbEndYPos->ItemIndex;
                ProtocolData.ProtocolBGImage[0][iCurBlockNo] = cbBGImage->ItemIndex;
                tempData = eColor->Text;
                ZeroMemory(&ProtocolData.ProtocolColor[0][iCurBlockNo], sizeof(ProtocolData.ProtocolColor[0][0]));
                memcpy(&ProtocolData.ProtocolColor[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = eBGColor->Text;
                ZeroMemory(&ProtocolData.ProtocolBGColor[0][iCurBlockNo], sizeof(ProtocolData.ProtocolBGColor[0][0]));
                memcpy(&ProtocolData.ProtocolBGColor[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = eData->Text;
                wtempData = eData->Text;
                ZeroMemory(&ProtocolData.ProtocolData[0][iCurBlockNo], sizeof(ProtocolData.ProtocolData[0][0]));
                memcpy(&ProtocolData.ProtocolData[0][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                EditFileName = BasePath + IncludeTrailingPathDelimiter(DestSysPath)
                    + "EnvData" + IntToStr(iCurBlockNo) + ".dat";
                eData->Lines->SaveToFile(EditFileName);
                WideString wtempData2 = "";
                int Totlen = 0;
                if(cbCodeKind->ItemIndex == 1)
                    Totlen = wtempData.Length() * 2;
                else
                    Totlen = tempData.Length();
                TextSize = Totlen;
                AnsiString SparePPAData = "";
                RealPPAData = new BYTE[Totlen];
                ZeroMemory(RealPPAData, Totlen);
                memcpy(&RealPPAData[0], tempData.c_str(), tempData.Length());
                BYTE *UniData = new BYTE[Totlen];
                FillMemory(UniData, Totlen, cbCodeKind->ItemIndex);
                int bytePos = 0;
                char casData[2];
                int tempSize = 0;
                int ppaPos = 0;
                int iRealSize = 0;
                BYTE tempByte[2];
                try{
                    int Datalen = 0;
                    BYTE tempChar;
                    AnsiString asDummy = "";
                    if(tempData.Pos("^[")) //  Ʈ ڵ  Ǵ
                    {
                        bytePos = 0;
                        for(int i = 0; i < Totlen; i++)
                        {
                            if(tempData.Pos("^["))
                            {
                                bytePos = 0;
                                tempSize = tempData.Pos("^[");
                                ppaPos = tempData.Pos("^]");
                                SparePPAData = tempData.SubString(tempSize + 2, ppaPos - (tempSize + 2));
                                tempData = tempData.Delete(tempSize, (ppaPos - tempSize) + 2);
                                TextSize = TextSize - ((ppaPos - tempSize) + 2);
                                Datalen = SparePPAData.Length();
                                for(int j = 0; j < Datalen; j++)
                                {
                                    if(SparePPAData.Pos(";"))
                                        tempChar = StrToInt("0x" + SparePPAData.SubString(1, SparePPAData.Pos(";") - 1));
                                    else
                                    {
                                        tempChar = StrToInt("0x" + SparePPAData.SubString(1, SparePPAData.Length()));
                                        RealPPAData[tempSize - 1 + bytePos] = tempChar;
                                        UniData[tempSize - 1 + bytePos] = 0;
                                        TextSize++;
                                        bytePos++;
                                        break;
                                    }
                                    RealPPAData[tempSize - 1 + bytePos] = tempChar;
                                    UniData[tempSize - 1 + bytePos] = 0;
                                    SparePPAData = SparePPAData.Delete(1, SparePPAData.Pos(";"));
                                    TextSize++;
                                    bytePos++;
                                }
                                for(int j = 0; j < bytePos;j++)
                                    asDummy += " ";
                                tempData = tempData.Insert(asDummy, tempSize);
                                memcpy(&RealPPAData[tempSize - 1 + bytePos], &RealPPAData[ppaPos + 1], Totlen - (ppaPos + 1));
                                asDummy = "";
                            }
                            else
                                break;
                        }
                        if(cbCodeKind->ItemIndex == 1) // ϼڵ带 ڵ ȯ
                        {
                            for(int i = 0; i < TextSize; i++)
                            {
                                if(UniData[i] == 0x01 && RealPPAData[i] != 0x00)
                                {
                                    ZeroMemory(tempByte, sizeof(tempByte));
                                    ZeroMemory(casData, sizeof(casData));
                                    BYTE *tempRealData = new BYTE[Totlen];
                                    ZeroMemory(tempRealData, Totlen);
                                    if(RealPPAData[i] >= 0x80)
                                    {
                                        casData[0] = RealPPAData[i];
                                        casData[1] = RealPPAData[i + 1];
                                        wtempData2 = AnsiString((char*)casData).SubString(1, 2);
                                        memcpy(tempByte, wtempData2.c_bstr(), 2);
                                        RealPPAData[i] = tempByte[1];
                                        RealPPAData[i + 1] = tempByte[0];
                                    }
                                    else
                                    {
                                        memcpy(tempRealData, &RealPPAData[i + 1], Totlen - (i + 1));
                                        memcpy(&RealPPAData[i + 2], tempRealData, Totlen - (i + 2));
                                        RealPPAData[i + 1] = RealPPAData[i];
                                        RealPPAData[i] = 0x00;
                                        TextSize++;
                                        ZeroMemory(tempRealData, Totlen);
                                        memcpy(tempRealData, &UniData[i + 1], Totlen - (i + 1));
                                        memcpy(&UniData[i + 2], tempRealData, Totlen - (i + 2));
                                    }
                                    i++;
                                    if(tempRealData)
                                    {
                                        delete [] tempRealData;
                                        tempRealData = NULL;
                                    }
                                }
                            }
                            for(int i = 0; i < TextSize; i+=2)
                            {
                                if(RealPPAData[i] == 0x00 && RealPPAData[i + 1] == 0x00)
                                {
                                    TextSize = i;
                                    break;
                                }
                            }
                        }
                    }
                    else
                    {
                        if(cbCodeKind->ItemIndex == 1) // ϼڵ带 ڵ ȯ
                        {
                            for(int i = 0; i < wtempData.Length(); i++)
                            {
                                ZeroMemory(tempByte, sizeof(tempByte));
                                ZeroMemory(casData, sizeof(casData));
                                wtempData2 = wtempData.SubString(i + 1, 1);
                                WideCharToMultiByte(949, 0, wtempData2, -1, casData, sizeof(casData), NULL, NULL);
                                //if((byte)casData[0] >= 0x80)
                                //{
                                    memcpy(tempByte, wtempData2.c_bstr(), 2);
                                    RealPPAData[bytePos] = tempByte[1];
                                    RealPPAData[bytePos + 1] = tempByte[0];
                                    bytePos += 2;
                                /*}
                                else
                                {
                                    RealPPAData[bytePos] = 0x00;
                                    RealPPAData[bytePos + 1] = casData[0];
                                    bytePos += 2;
                                }*/
                            }
                        }
                    }
                }catch(...){
                    memcpy(&RealPPAData[0], AnsiString(eData->Text).TrimRight().c_str(), Totlen);
                    TextSize = Totlen;
                }
                SendSize = TextSize;
                TotDataSize = SendSize * 2 + 16;
                if(SendProtocoData)
                {
                    delete [] SendProtocoData;
                    SendProtocoData = NULL;
                }
                SendProtocoData = new BYTE[TotDataSize];
                ZeroMemory(SendProtocoData, TotDataSize);
                //   ݷ ޸𸮿 
                SendProtocoData[0] = cbPageNo->ItemIndex;
                SendProtocoData[1] = iCurBlockNo;
                union{
                    char cbSize;
                    struct{
                        unsigned bit0 : 7;
                        unsigned bit1 : 1;
                    }Bit;
                }uSize3;
                uSize3.cbSize = ProtocolData.ProtocolDispControl[0][iCurBlockNo];
                if(uSize3.Bit.bit0 == 0)
                    SendProtocoData[2] = 0;
                else if(uSize3.Bit.bit0 == 1)
                    SendProtocoData[2] = 99;
                else
                    SendProtocoData[2] = uSize3.Bit.bit0 - 1;
                if(uSize3.Bit.bit1 == 1)
                    SendProtocoData[2] |= 0x80;
                SendProtocoData[3] = ProtocolData.ProtocolDispType[0][iCurBlockNo];
                SendProtocoData[4] = ProtocolData.ProtocolCodeKind[0][iCurBlockNo];
                if(ProtocolData.ProtocolFontSize[0][iCurBlockNo] == 0)
                    SendProtocoData[5] = 1;
                else
                    SendProtocoData[5] = ProtocolData.ProtocolFontSize[0][iCurBlockNo] + 2;
                SendProtocoData[6] = InputSchEffect((TGEffectType)FindItemIndex(AnsiString((char*)ProtocolData.ProtocolEntEffect[0][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolEntEffect[0][iCurBlockNo])), 2),
                    (TGEffectDirection)FindItemIndex(AnsiString((char*)ProtocolData.ProtocolEntDirect[0][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolEntDirect[0][iCurBlockNo])), 3));
                SendProtocoData[7] = InputSchEffect((TGEffectType)FindItemIndex(AnsiString((char*)ProtocolData.ProtocolLasEffect[0][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolLasEffect[0][iCurBlockNo])), 2),
                    (TGEffectDirection)FindItemIndex(AnsiString((char*)ProtocolData.ProtocolLasDirect[0][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolLasDirect[0][iCurBlockNo])), 3));
                SendProtocoData[8] = ProtocolData.ProtocolColorType[0][iCurBlockNo];
                asSpeed = AnsiString((char*)ProtocolData.ProtocolSpeed[0][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolSpeed[0][iCurBlockNo])).TrimRight();
                if(!asSpeed.SubString(asSpeed.Pos("(") + 1, AnsiString(LangFile.Message01).Length()).AnsiCompareIC(LangFile.Message01))
                    SendProtocoData[9] = 0;
                else if(!asSpeed.SubString(asSpeed.Pos("(") + 1, AnsiString(LangFile.Message02).Length()).AnsiCompareIC(LangFile.Message02))
                    SendProtocoData[9] = 255;
                else
                    SendProtocoData[9] = StrToIntDef(asSpeed.TrimRight(), 20);
                asSpeed = AnsiString((char*)ProtocolData.ProtocolDelay[0][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolDelay[0][iCurBlockNo])).TrimRight();
                if(asSpeed.Pos("("))
                    SendProtocoData[10] = SetDelayTime(StrToIntDef(asSpeed.SubString(1, asSpeed.Pos("(") - 1).Trim(), 2));
                else
                    SendProtocoData[10] = SetDelayTime(StrToIntDef(asSpeed, 2));
                SendProtocoData[11] = ProtocolData.ProtocolStartXPos[0][iCurBlockNo];
                SendProtocoData[12] = ProtocolData.ProtocolStartYPos[0][iCurBlockNo];
                SendProtocoData[13] = ProtocolData.ProtocolEndXPos[0][iCurBlockNo];
                SendProtocoData[14] = ProtocolData.ProtocolEndYPos[0][iCurBlockNo];
                if(ProtocolData.ProtocolBGImage[0][iCurBlockNo] >= 11)
                    SendProtocoData[15] = ProtocolData.ProtocolBGImage[0][iCurBlockNo] + 190;
                else
                    SendProtocoData[15] = ProtocolData.ProtocolBGImage[0][iCurBlockNo];
                int ColorSize = AnsiString((char*)ProtocolData.ProtocolColor[0][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolColor[0][iCurBlockNo])).TrimRight().Length();
                if(SendSize < ColorSize)
                    ColorSize = SendSize;
                BYTE tempColor = Hex2ByteConvert(AnsiString((char*)ProtocolData.ProtocolColor[0][iCurBlockNo]).SubString(ColorSize, 1));
                FillMemory(&SendProtocoData[16], SendSize, tempColor);
                bool bASCII = true;
                int iHan = 0;
                int iCodeCnt = 0;
                for(int i = 1; i <= ColorSize; i++)
                {
                    tempColor = Hex2ByteConvert(AnsiString((char*)ProtocolData.ProtocolColor[0][iCurBlockNo]).SubString(i, 1));
                    SendProtocoData[16 + iCodeCnt] = tempColor;
                    if(RealPPAData[iCodeCnt++] >= 0x80 || cbCodeKind->ItemIndex == 1)
                        SendProtocoData[16 + iCodeCnt++] = 0x00;
                    if(iCodeCnt >= SendSize)
                        break;
                }
                if(iCodeCnt <= SendSize)
                {
                    for(; iCodeCnt < SendSize;)
                    {
                        SendProtocoData[16 + iCodeCnt] = tempColor;
                        if(RealPPAData[iCodeCnt++] >= 0x80 || cbCodeKind->ItemIndex == 1)
                            SendProtocoData[16 + iCodeCnt++] = 0x00;
                    }
                }
                if(eBGColor->Enabled)
                {
                    int ColorSize2 = AnsiString((char*)ProtocolData.ProtocolBGColor[0][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolBGColor[0][iCurBlockNo])).TrimRight().Length();
                    BYTE tempColor2 = Hex2ByteConvert(AnsiString((char*)ProtocolData.ProtocolBGColor[0][iCurBlockNo]).SubString(ColorSize, 1));
                    if((int)tempColor2 > 15)
                        tempColor2 = 0;
                    if(SendSize < ColorSize2)
                        ColorSize2 = SendSize;
                    iCodeCnt = 0;
                    for(int i = 1; i <= ColorSize2; i++)
                    {
                        tempColor2 = Hex2ByteConvert(AnsiString((char*)ProtocolData.ProtocolBGColor[0][iCurBlockNo]).SubString(i, 1));
                        if((int)tempColor2 > 15)
                            tempColor2 = 0;
                        uSize2.cbSize = SendProtocoData[16 + iCodeCnt];
                        uSize2.Bit.bit1 = tempColor2;
                        SendProtocoData[16 + iCodeCnt] = uSize2.cbSize;
                        if(RealPPAData[iCodeCnt++] >= 0x80 || cbCodeKind->ItemIndex == 1)
                            SendProtocoData[16 + iCodeCnt++] = 0x00;
                        if(iCodeCnt >= SendSize)
                            break;
                    }
                    if(iCodeCnt <= SendSize)
                    {
                        for(; iCodeCnt < SendSize;)
                        {
                            uSize2.cbSize = SendProtocoData[16 + iCodeCnt];
                            uSize2.Bit.bit1 = tempColor2;
                            SendProtocoData[16 + iCodeCnt] = uSize2.cbSize;
                            if(RealPPAData[iCodeCnt++] >= 0x80 || cbCodeKind->ItemIndex == 1)
                                SendProtocoData[16 + iCodeCnt++] = 0x00;
                        }
                    }
                }
                asMessage = LangFile.FormProtocolTab1;
                tempOPCode = FED;
                FillMemory(&SendProtocoData[16 + SendSize], SendSize, 0x20);
                memcpy(&SendProtocoData[16 + SendSize], RealPPAData, TextSize);
                if(RealPPAData)
                {
                    delete [] RealPPAData;
                    RealPPAData = NULL;
                }
                if(UniData)
                {
                    delete [] UniData;
                    UniData = NULL;
                }
            }
            else // Ϲ 
            {
                //  Ϲݹ ü 
                ProtocolData.ProtocolDispControl[iCurPageNo][iCurBlockNo] = cbDispControl2->ItemIndex;
                ProtocolData.ProtocolDispType[iCurPageNo][iCurBlockNo] = cbDispType2->ItemIndex;
                ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo] = cbCodeKind2->ItemIndex;
                ProtocolData.ProtocolFontSize[iCurPageNo][iCurBlockNo] = cbFontSize2->ItemIndex;
                tempData = cbEntEffect2->Text;
                ZeroMemory(&ProtocolData.ProtocolEntEffect[iCurPageNo][iCurBlockNo], sizeof(ProtocolData.ProtocolEntEffect[0][0]));
                memcpy(&ProtocolData.ProtocolEntEffect[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = cbEntDirect2->Text;
                ZeroMemory(&ProtocolData.ProtocolEntDirect[iCurPageNo][iCurBlockNo], sizeof(ProtocolData.ProtocolEntDirect[0][0]));
                memcpy(&ProtocolData.ProtocolEntDirect[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = cbLasEffect2->Text;
                ZeroMemory(&ProtocolData.ProtocolLasEffect[iCurPageNo][iCurBlockNo], sizeof(ProtocolData.ProtocolLasEffect[0][0]));
                memcpy(&ProtocolData.ProtocolLasEffect[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = cbLasDirect2->Text;
                ZeroMemory(&ProtocolData.ProtocolLasDirect[iCurPageNo][iCurBlockNo], sizeof(ProtocolData.ProtocolLasDirect[0][0]));
                memcpy(&ProtocolData.ProtocolLasDirect[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                ProtocolData.ProtocolColorType[iCurPageNo][iCurBlockNo] = cbAssistEffect->ItemIndex;
                tempData = cbSpeed2->Text;
                ZeroMemory(&ProtocolData.ProtocolSpeed[iCurPageNo][iCurBlockNo], sizeof(ProtocolData.ProtocolSpeed[0][0]));
                memcpy(&ProtocolData.ProtocolSpeed[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = cbDelay2->Text;
                ZeroMemory(&ProtocolData.ProtocolDelay[iCurPageNo][iCurBlockNo], sizeof(ProtocolData.ProtocolDelay[0][0]));
                memcpy(&ProtocolData.ProtocolDelay[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                ProtocolData.ProtocolStartXPos[iCurPageNo][iCurBlockNo] = cbStartXPos2->ItemIndex;
                ProtocolData.ProtocolStartYPos[iCurPageNo][iCurBlockNo] = cbStartYPos2->ItemIndex;
                ProtocolData.ProtocolEndXPos[iCurPageNo][iCurBlockNo] = cbEndXPos2->ItemIndex;
                ProtocolData.ProtocolEndYPos[iCurPageNo][iCurBlockNo] = cbEndYPos2->ItemIndex;
                ProtocolData.ProtocolBGImage[iCurPageNo][iCurBlockNo] = cbBGImage2->ItemIndex;
                tempData = eColor2->Text;
                ZeroMemory(&ProtocolData.ProtocolColor[iCurPageNo][iCurBlockNo], sizeof(ProtocolData.ProtocolColor[0][0]));
                memcpy(&ProtocolData.ProtocolColor[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = eBGColor2->Text;
                ZeroMemory(&ProtocolData.ProtocolBGColor[iCurPageNo][iCurBlockNo], sizeof(ProtocolData.ProtocolBGColor[0][0]));
                memcpy(&ProtocolData.ProtocolBGColor[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                tempData = eData2->Text;
                wtempData = eData2->Text;
                ZeroMemory(&ProtocolData.ProtocolData[iCurPageNo][iCurBlockNo], sizeof(ProtocolData.ProtocolData[0][0]));
                memcpy(&ProtocolData.ProtocolData[iCurPageNo][iCurBlockNo][0], tempData.c_str(), tempData.Length());
                EditFileName = BasePath + IncludeTrailingPathDelimiter(DestSysPath)
                    + "MessageData" + IntToStr(iCurPageNo) + IntToStr(iCurBlockNo) + ".dat";
                eData2->Lines->SaveToFile(EditFileName);
                tempData = (AnsiString)wtempData;
                WideString wtempData2 = "";
                int Totlen = 0;
                if(ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo] == 1)
                    Totlen = wtempData.Length() * 2;
                else
                    Totlen = tempData.Length();
                TextSize = Totlen;
                AnsiString SparePPAData = "";
                RealPPAData = new BYTE[Totlen];
                ZeroMemory(RealPPAData, Totlen);
                memcpy(&RealPPAData[0], tempData.c_str(), tempData.Length());
                BYTE *UniData = new BYTE[Totlen];
                FillMemory(UniData, Totlen, ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo]);
                int iUniPos = 0;
                int bytePos = 0;
                char casData[2];
                int tempSize = 0;
                int ppaPos = 0;
                int iRealSize = 0;
                BYTE tempByte[2];
                try{
                    int Datalen = 0;
                    BYTE tempChar;
                    AnsiString asDummy = "";
                    if(tempData.Pos("^[")) //  Ʈ ڵ  Ǵ
                    {
                        bytePos = 0;
                        for(int i = 0; i < Totlen; i++)
                        {
                            if(tempData.Pos("^["))
                            {
                                bytePos = 0;
                                tempSize = tempData.Pos("^[");
                                ppaPos = tempData.Pos("^]");
                                SparePPAData = tempData.SubString(tempSize + 2, ppaPos - (tempSize + 2));
                                tempData = tempData.Delete(tempSize, (ppaPos - tempSize) + 2);
                                TextSize = TextSize - ((ppaPos - tempSize) + 2);
                                Datalen = SparePPAData.Length();
                                for(int j = 0; j < Datalen; j++)
                                {
                                    if(SparePPAData.Pos(";"))
                                        tempChar = StrToInt("0x" + SparePPAData.SubString(1, SparePPAData.Pos(";") - 1));
                                    else
                                    {
                                        tempChar = StrToInt("0x" + SparePPAData.SubString(1, SparePPAData.Length()));
                                        RealPPAData[tempSize - 1 + bytePos] = tempChar;
                                        UniData[tempSize - 1 + bytePos] = 0;
                                        TextSize++;
                                        bytePos++;
                                        break;
                                    }
                                    RealPPAData[tempSize - 1 + bytePos] = tempChar;
                                    UniData[tempSize - 1 + bytePos] = 0;
                                    SparePPAData = SparePPAData.Delete(1, SparePPAData.Pos(";"));
                                    TextSize++;
                                    bytePos++;
                                }
                                for(int j = 0; j < bytePos;j++)
                                    asDummy += " ";
                                tempData = tempData.Insert(asDummy, tempSize);
                                memcpy(&RealPPAData[tempSize - 1 + bytePos], &RealPPAData[ppaPos + 1], Totlen - (ppaPos + 1));
                                asDummy = "";
                            }
                            else
                                break;
                        }
                        if(ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo] == 1) // ϼڵ带 ڵ ȯ
                        {
                            for(int i = 0; i < TextSize; i++)
                            {
                                if(UniData[i] == 0x01 && RealPPAData[i] != 0x00)
                                {
                                    ZeroMemory(tempByte, sizeof(tempByte));
                                    ZeroMemory(casData, sizeof(casData));
                                    BYTE *tempRealData = new BYTE[Totlen];
                                    ZeroMemory(tempRealData, Totlen);
                                    if(RealPPAData[i] >= 0x80)
                                    {
                                        casData[0] = RealPPAData[i];
                                        casData[1] = RealPPAData[i + 1];
                                        wtempData2 = AnsiString((char*)casData).SubString(1, 2);
                                        memcpy(tempByte, wtempData2.c_bstr(), 2);
                                        RealPPAData[i] = tempByte[1];
                                        RealPPAData[i + 1] = tempByte[0];
                                    }
                                    else
                                    {
                                        memcpy(tempRealData, &RealPPAData[i + 1], Totlen - (i + 1));
                                        memcpy(&RealPPAData[i + 2], tempRealData, Totlen - (i + 2));
                                        RealPPAData[i + 1] = RealPPAData[i];
                                        RealPPAData[i] = 0x00;
                                        TextSize++;
                                        ZeroMemory(tempRealData, Totlen);
                                        memcpy(tempRealData, &UniData[i + 1], Totlen - (i + 1));
                                        memcpy(&UniData[i + 2], tempRealData, Totlen - (i + 2));
                                    }
                                    i++;
                                    if(tempRealData)
                                    {
                                        delete [] tempRealData;
                                        tempRealData = NULL;
                                    }
                                }
                            }
                            for(int i = 0; i < TextSize; i+=2)
                            {
                                if(RealPPAData[i] == 0x00 && RealPPAData[i + 1] == 0x00)
                                    TextSize = i;
                            }
                        }
                    }
                    else
                    {
                        if(ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo] == 1) // ϼڵ带 ڵ ȯ
                        {
                            for(int i = 0; i < wtempData.Length(); i++)
                            {
                                ZeroMemory(tempByte, sizeof(tempByte));
                                ZeroMemory(casData, sizeof(casData));
                                wtempData2 = wtempData.SubString(i + 1, 1);
                                WideCharToMultiByte(949, 0, wtempData2, -1, casData, sizeof(casData), NULL, NULL);
                                //if((byte)casData[0] >= 0x80)
                                //{
                                    memcpy(tempByte, wtempData2.c_bstr(), 2);
                                    RealPPAData[bytePos] = tempByte[1];
                                    RealPPAData[bytePos + 1] = tempByte[0];
                                    bytePos += 2;
                                /*}
                                else
                                {
                                    RealPPAData[bytePos] = 0x00;
                                    RealPPAData[bytePos + 1] = casData[0];
                                    bytePos += 2;
                                }*/
                            }
                        }
                    }
                }catch(...){
                    memcpy(&RealPPAData[0], AnsiString(eData2->Text).TrimRight().c_str(), Totlen);
                    TextSize = Totlen;
                }
                SendSize = TextSize;
                TotDataSize = SendSize * 2 + 16;
                if(SendProtocoData)
                {
                    delete [] SendProtocoData;
                    SendProtocoData = NULL;
                }
                SendProtocoData = new BYTE[TotDataSize];
                ZeroMemory(SendProtocoData, TotDataSize);
                //   ݷ ޸𸮿 
                SendProtocoData[0] = ProtocolPageNo2;
                SendProtocoData[1] = iCurBlockNo;
                if(ProtocolData.ProtocolDispControl[iCurPageNo][iCurBlockNo] == 0)
                    SendProtocoData[2] = 0;
                else if(ProtocolData.ProtocolDispControl[iCurPageNo][iCurBlockNo] == 1)
                    SendProtocoData[2] = 99;
                else
                    SendProtocoData[2] = ProtocolData.ProtocolDispControl[iCurPageNo][iCurBlockNo] - 1;
                SendProtocoData[3] = ProtocolData.ProtocolDispType[iCurPageNo][iCurBlockNo];
                SendProtocoData[4] = ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo];
                if(ProtocolData.ProtocolFontSize[iCurPageNo][iCurBlockNo] == 0)
                    SendProtocoData[5] = 1;
                else
                    SendProtocoData[5] = ProtocolData.ProtocolFontSize[iCurPageNo][iCurBlockNo] + 2;
                SendProtocoData[6] = InputSchEffect((TGEffectType)FindItemIndex(AnsiString((char*)ProtocolData.ProtocolEntEffect[iCurPageNo][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolEntEffect[0][iCurBlockNo])), 2),
                    (TGEffectDirection)FindItemIndex(AnsiString((char*)ProtocolData.ProtocolEntDirect[iCurPageNo][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolEntDirect[0][iCurBlockNo])), 3));
                SendProtocoData[7] = InputSchEffect((TGEffectType)FindItemIndex(AnsiString((char*)ProtocolData.ProtocolLasEffect[iCurPageNo][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolLasEffect[0][iCurBlockNo])), 2),
                    (TGEffectDirection)FindItemIndex(AnsiString((char*)ProtocolData.ProtocolLasDirect[iCurPageNo][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolLasDirect[0][iCurBlockNo])), 3));
                SendProtocoData[8] = ProtocolData.ProtocolColorType[iCurPageNo][iCurBlockNo];
                asSpeed = AnsiString((char*)ProtocolData.ProtocolSpeed[iCurPageNo][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolSpeed[0][iCurBlockNo])).TrimRight();
                if(!asSpeed.SubString(asSpeed.Pos("(") + 1, AnsiString(LangFile.Message01).Length()).AnsiCompareIC(LangFile.Message01))
                    SendProtocoData[9] = 0;
                else if(!asSpeed.SubString(asSpeed.Pos("(") + 1, AnsiString(LangFile.Message02).Length()).AnsiCompareIC(LangFile.Message02))
                    SendProtocoData[9] = 255;
                else
                    SendProtocoData[9] = StrToIntDef(asSpeed.TrimRight(), 20);
                asSpeed = AnsiString((char*)ProtocolData.ProtocolDelay[iCurPageNo][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolDelay[0][iCurBlockNo])).TrimRight();
                if(asSpeed.Pos("("))
                    SendProtocoData[10] = SetDelayTime(StrToIntDef(asSpeed.SubString(1, asSpeed.Pos("(") - 1).Trim(), 2));
                else
                    SendProtocoData[10] = SetDelayTime(StrToIntDef(asSpeed, 2));
                SendProtocoData[11] = ProtocolData.ProtocolStartXPos[iCurPageNo][iCurBlockNo];
                SendProtocoData[12] = ProtocolData.ProtocolStartYPos[iCurPageNo][iCurBlockNo];
                SendProtocoData[13] = ProtocolData.ProtocolEndXPos[iCurPageNo][iCurBlockNo];
                SendProtocoData[14] = ProtocolData.ProtocolEndYPos[iCurPageNo][iCurBlockNo];
                if(ProtocolData.ProtocolBGImage[iCurPageNo][iCurBlockNo] >= 11)
                    SendProtocoData[15] = ProtocolData.ProtocolBGImage[iCurPageNo][iCurBlockNo] + 190;
                else
                    SendProtocoData[15] = ProtocolData.ProtocolBGImage[iCurPageNo][iCurBlockNo];
                int ColorSize = AnsiString((char*)ProtocolData.ProtocolColor[iCurPageNo][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolColor[0][iCurBlockNo])).TrimRight().Length();
                if(SendSize < ColorSize)
                    ColorSize = SendSize;
                BYTE tempColor = Hex2ByteConvert(AnsiString((char*)ProtocolData.ProtocolColor[iCurPageNo][iCurBlockNo]).SubString(ColorSize, 1));
                FillMemory(&SendProtocoData[16], SendSize, tempColor);
                bool bASCII = true;
                int iHan = 0;
                int iCodeCnt = 0;
                for(int i = 1; i <= ColorSize; i++)
                {
                    tempColor = Hex2ByteConvert(AnsiString((char*)ProtocolData.ProtocolColor[iCurPageNo][iCurBlockNo]).SubString(i, 1));
                    SendProtocoData[16 + iCodeCnt] = tempColor;
                    if(RealPPAData[iCodeCnt++] >= 0x80 || ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo] == 1)
                        SendProtocoData[16 + iCodeCnt++] = 0x00;
                    if(iCodeCnt >= SendSize)
                        break;
                }
                if(iCodeCnt <= SendSize)
                {
                    for(; iCodeCnt < SendSize;)
                    {
                        SendProtocoData[16 + iCodeCnt] = tempColor;
                        if(RealPPAData[iCodeCnt++] >= 0x80 || ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo] == 1)
                            SendProtocoData[16 + iCodeCnt++] = 0x00;
                    }
                }
                if(eBGColor2->Enabled)
                {
                    int ColorSize2 = AnsiString((char*)ProtocolData.ProtocolBGColor[iCurPageNo][iCurBlockNo]).SubString(1, sizeof(ProtocolData.ProtocolBGColor[0][iCurBlockNo])).TrimRight().Length();
                    if(SendSize < ColorSize2)
                        ColorSize2 = SendSize;
                    BYTE tempColor2 = Hex2ByteConvert(AnsiString((char*)ProtocolData.ProtocolBGColor[iCurPageNo][iCurBlockNo]).SubString(ColorSize, 1));
                    if((int)tempColor2 > 7)
                        tempColor2 = 0;
                    iCodeCnt = 0;
                    for(int i = 1; i <= ColorSize2; i++)
                    {
                        tempColor2 = Hex2ByteConvert(AnsiString((char*)ProtocolData.ProtocolBGColor[iCurPageNo][iCurBlockNo]).SubString(i, 1));
                        if((int)tempColor2 > 7)
                            tempColor2 = 0;
                        uSize2.cbSize = SendProtocoData[16 + iCodeCnt];
                        uSize2.Bit.bit1 = tempColor2;
                        SendProtocoData[16 + iCodeCnt] = uSize2.cbSize;
                        if(RealPPAData[iCodeCnt++] >= 0x80 || ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo] == 1)
                            SendProtocoData[16 + iCodeCnt++] = 0x00;
                        if(iCodeCnt >= SendSize)
                            break;
                    }
                    if(iCodeCnt <= SendSize)
                    {
                        for(; iCodeCnt < SendSize;)
                        {
                            uSize2.cbSize = SendProtocoData[16 + iCodeCnt];
                            uSize2.Bit.bit1 = tempColor2;
                            SendProtocoData[16 + iCodeCnt] = uSize2.cbSize;
                            if(RealPPAData[iCodeCnt++] >= 0x80 || ProtocolData.ProtocolCodeKind[iCurPageNo][iCurBlockNo] == 1)
                                SendProtocoData[16 + iCodeCnt++] = 0x00;
                        }
                    }
                }
                asMessage = LangFile.FormProtocolTab2;
                tempOPCode = FND;
                FillMemory(&SendProtocoData[16 + SendSize], SendSize, 0x20);
                memcpy(&SendProtocoData[16 + SendSize], RealPPAData, TextSize);
                if(RealPPAData)
                {
                    delete [] RealPPAData;
                    RealPPAData = NULL;
                }
                if(UniData)
                {
                    delete [] UniData;
                    UniData = NULL;
                }
            }
            //  ޸  ǿ 
            Addr = Controler1;
            if(!bPortOpen)
                bConnect = ComPortSet(ComKind, PortUse1, BaudRateUse1, Disable, Disable, IPAddress, IPPort, false);
            if(bConnect)
            {
                if(ModuleData(ComKind, Addr, SendProtocoData, TotDataSize, 0, tempOPCode, bMsg))
                    AddLog(asMessage + " [OK]" + asLogMessage, clBlack);
                else
                    AddLog(asMessage + " [FAIL]" + asLogMessage, clRed);
            }
            if(SendProtocoData)
            {
                delete [] SendProtocoData;
                SendProtocoData = NULL;
            }
        }catch(...){
        }
        DataSend->Enabled = true;
        this->BringToFront();
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BtnSignSizeClick(TObject *Sender)
{
        //  ũ  ư
        BYTE SendData[2];
        ZeroMemory(SendData, sizeof(SendData));
        SendData[0] = UpDownHeight->Position;
        SendData[1] = UpDownWidth->Position;
        ButtonEnabled(false);
        if(ComPortSet(ComKind, PortUse1, BaudRateUse1, Disable, Disable, IPAddress, IPPort, false))
        {
            if(ModuleData(ComKind, Controler1, SendData, sizeof(SendData), 0, BS, bMsg))
                AddLog(LangFile.Message07 +  "(" + IntToStr(UpDownHeight->Position) + " X " + IntToStr(UpDownWidth->Position) + ") [OK]" + asLogMessage, clBlack);
            else
                AddLog(LangFile.Message07 +  "(" + IntToStr(UpDownHeight->Position) + " X " + IntToStr(UpDownWidth->Position) + ") [FAIL]" + asLogMessage, clRed);
            ComClose(ComKind);
        }
        ModuleHeight = UpDownHeight->Position;
        ModuleWidth = UpDownWidth->Position;
        ButtonEnabled(true);
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::NComPortClick(TObject *Sender)
{
        //  â  ư
        FComPort = new TFormComPort(this);
        FComPort->ShowModal();
        if(FComPort)
        {
            delete FComPort;
            FComPort = NULL;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::sbLogClearClick(TObject *Sender)
{
        RichEditLog->Clear();
}
//---------------------------------------------------------------------------

